/*!-----------------------------------------------------------
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Version: 0.48.0-dev-20240312(69991d66135e4a1fc1cf0b1ac4ad25d429866a0d)
 * Released under the MIT license
 * https://github.com/microsoft/vscode/blob/main/LICENSE.txt
 *-----------------------------------------------------------*/(function(){var Z=["require","exports","vs/editor/common/core/range","vs/editor/common/core/offsetRange","vs/editor/common/core/position","vs/base/common/errors","vs/base/common/strings","vs/base/common/arrays","vs/editor/common/diff/defaultLinesDiffComputer/algorithms/diffAlgorithm","vs/base/common/event","vs/editor/common/core/lineRange","vs/base/common/arraysFind","vs/base/common/assert","vs/base/common/lifecycle","vs/base/common/objects","vs/editor/common/diff/defaultLinesDiffComputer/utils","vs/editor/common/diff/rangeMapping","vs/base/common/platform","vs/base/common/uri","vs/nls","vs/base/common/functional","vs/base/common/iterator","vs/base/common/linkedList","vs/base/common/stopwatch","vs/base/common/diff/diff","vs/base/common/types","vs/base/common/codiconsUtil","vs/base/common/uint","vs/editor/common/core/characterClassifier","vs/editor/common/core/wordHelper","vs/editor/common/diff/defaultLinesDiffComputer/algorithms/myersDiffAlgorithm","vs/editor/common/diff/defaultLinesDiffComputer/linesSliceCharSequence","vs/editor/common/diff/linesDiffComputer","vs/base/common/cache","vs/base/common/color","vs/base/common/diff/diffChange","vs/base/common/keyCodes","vs/base/common/lazy","vs/base/common/map","vs/base/common/cancellation","vs/base/common/hash","vs/base/common/codiconsLibrary","vs/base/common/codicons","vs/editor/common/core/selection","vs/editor/common/core/wordCharacterClassifier","vs/editor/common/diff/defaultLinesDiffComputer/heuristicSequenceOptimizations","vs/editor/common/diff/defaultLinesDiffComputer/lineSequence","vs/editor/common/diff/defaultLinesDiffComputer/algorithms/dynamicProgrammingDiffing","vs/editor/common/diff/defaultLinesDiffComputer/computeMovedLines","vs/editor/common/diff/defaultLinesDiffComputer/defaultLinesDiffComputer","vs/editor/common/diff/legacyLinesDiffComputer","vs/editor/common/diff/linesDiffComputers","vs/editor/common/languages/defaultDocumentColorsComputer","vs/editor/common/languages/linkComputer","vs/editor/common/languages/supports/inplaceReplaceSupport","vs/editor/common/model","vs/editor/common/model/prefixSumComputer","vs/editor/common/model/mirrorTextModel","vs/editor/common/model/textModelSearch","vs/editor/common/services/unicodeTextModelHighlighter","vs/editor/common/standalone/standaloneEnums","vs/editor/common/tokenizationRegistry","vs/nls!vs/base/common/platform","vs/nls!vs/base/common/worker/simpleWorker","vs/base/common/process","vs/base/common/path","vs/nls!vs/editor/common/languages","vs/editor/common/languages","vs/editor/common/services/editorBaseApi","vs/base/common/worker/simpleWorker","vs/editor/common/services/editorSimpleWorker"],K=function(q){for(var n=[],r=0,M=q.length;r<M;r++)n[r]=Z[q[r]];return n};const Re=this,Ae=typeof global=="object"?global:{};var fe;(function(q){q.global=Re;class n{get isWindows(){return this._detect(),this._isWindows}get isNode(){return this._detect(),this._isNode}get isElectronRenderer(){return this._detect(),this._isElectronRenderer}get isWebWorker(){return this._detect(),this._isWebWorker}get isElectronNodeIntegrationWebWorker(){return this._detect(),this._isElectronNodeIntegrationWebWorker}constructor(){this._detected=!1,this._isWindows=!1,this._isNode=!1,this._isElectronRenderer=!1,this._isWebWorker=!1,this._isElectronNodeIntegrationWebWorker=!1}_detect(){this._detected||(this._detected=!0,this._isWindows=n._isWindows(),this._isNode=typeof module<"u"&&!!module.exports,this._isElectronRenderer=typeof process<"u"&&typeof process.versions<"u"&&typeof process.versions.electron<"u"&&process.type==="renderer",this._isWebWorker=typeof q.global.importScripts=="function",this._isElectronNodeIntegrationWebWorker=this._isWebWorker&&typeof process<"u"&&typeof process.versions<"u"&&typeof process.versions.electron<"u"&&process.type==="worker")}static _isWindows(){return typeof navigator<"u"&&navigator.userAgent&&navigator.userAgent.indexOf("Windows")>=0?!0:typeof process<"u"?process.platform==="win32":!1}}q.Environment=n})(fe||(fe={}));var fe;(function(q){class n{constructor(g,v,p){this.type=g,this.detail=v,this.timestamp=p}}q.LoaderEvent=n;class r{constructor(g){this._events=[new n(1,"",g)]}record(g,v){this._events.push(new n(g,v,q.Utilities.getHighPerformanceTimestamp()))}getEvents(){return this._events}}q.LoaderEventRecorder=r;class M{record(g,v){}getEvents(){return[]}}M.INSTANCE=new M,q.NullLoaderEventRecorder=M})(fe||(fe={}));var fe;(function(q){class n{static fileUriToFilePath(M,A){if(A=decodeURI(A).replace(/%23/g,"#"),M){if(/^file:\/\/\//.test(A))return A.substr(8);if(/^file:\/\//.test(A))return A.substr(5)}else if(/^file:\/\//.test(A))return A.substr(7);return A}static startsWith(M,A){return M.length>=A.length&&M.substr(0,A.length)===A}static endsWith(M,A){return M.length>=A.length&&M.substr(M.length-A.length)===A}static containsQueryString(M){return/^[^\#]*\?/gi.test(M)}static isAbsolutePath(M){return/^((http:\/\/)|(https:\/\/)|(file:\/\/)|(\/))/.test(M)}static forEachProperty(M,A){if(M){let g;for(g in M)M.hasOwnProperty(g)&&A(g,M[g])}}static isEmpty(M){let A=!0;return n.forEachProperty(M,()=>{A=!1}),A}static recursiveClone(M){if(!M||typeof M!="object"||M instanceof RegExp||!Array.isArray(M)&&Object.getPrototypeOf(M)!==Object.prototype)return M;let A=Array.isArray(M)?[]:{};return n.forEachProperty(M,(g,v)=>{v&&typeof v=="object"?A[g]=n.recursiveClone(v):A[g]=v}),A}static generateAnonymousModule(){return"===anonymous"+n.NEXT_ANONYMOUS_ID+++"==="}static isAnonymousModule(M){return n.startsWith(M,"===anonymous")}static getHighPerformanceTimestamp(){return this.PERFORMANCE_NOW_PROBED||(this.PERFORMANCE_NOW_PROBED=!0,this.HAS_PERFORMANCE_NOW=q.global.performance&&typeof q.global.performance.now=="function"),this.HAS_PERFORMANCE_NOW?q.global.performance.now():Date.now()}}n.NEXT_ANONYMOUS_ID=1,n.PERFORMANCE_NOW_PROBED=!1,n.HAS_PERFORMANCE_NOW=!1,q.Utilities=n})(fe||(fe={}));var fe;(function(q){function n(A){if(A instanceof Error)return A;const g=new Error(A.message||String(A)||"Unknown Error");return A.stack&&(g.stack=A.stack),g}q.ensureError=n;class r{static validateConfigurationOptions(g){function v(p){if(p.phase==="loading"){console.error('Loading "'+p.moduleId+'" failed'),console.error(p),console.error("Here are the modules that depend on it:"),console.error(p.neededBy);return}if(p.phase==="factory"){console.error('The factory function of "'+p.moduleId+'" has thrown an exception'),console.error(p),console.error("Here are the modules that depend on it:"),console.error(p.neededBy);return}}if(g=g||{},typeof g.baseUrl!="string"&&(g.baseUrl=""),typeof g.isBuild!="boolean"&&(g.isBuild=!1),typeof g.paths!="object"&&(g.paths={}),typeof g.config!="object"&&(g.config={}),typeof g.catchError>"u"&&(g.catchError=!1),typeof g.recordStats>"u"&&(g.recordStats=!1),typeof g.urlArgs!="string"&&(g.urlArgs=""),typeof g.onError!="function"&&(g.onError=v),Array.isArray(g.ignoreDuplicateModules)||(g.ignoreDuplicateModules=[]),g.baseUrl.length>0&&(q.Utilities.endsWith(g.baseUrl,"/")||(g.baseUrl+="/")),typeof g.cspNonce!="string"&&(g.cspNonce=""),typeof g.preferScriptTags>"u"&&(g.preferScriptTags=!1),g.nodeCachedData&&typeof g.nodeCachedData=="object"&&(typeof g.nodeCachedData.seed!="string"&&(g.nodeCachedData.seed="seed"),(typeof g.nodeCachedData.writeDelay!="number"||g.nodeCachedData.writeDelay<0)&&(g.nodeCachedData.writeDelay=1e3*7),!g.nodeCachedData.path||typeof g.nodeCachedData.path!="string")){const p=n(new Error("INVALID cached data configuration, 'path' MUST be set"));p.phase="configuration",g.onError(p),g.nodeCachedData=void 0}return g}static mergeConfigurationOptions(g=null,v=null){let p=q.Utilities.recursiveClone(v||{});return q.Utilities.forEachProperty(g,(h,l)=>{h==="ignoreDuplicateModules"&&typeof p.ignoreDuplicateModules<"u"?p.ignoreDuplicateModules=p.ignoreDuplicateModules.concat(l):h==="paths"&&typeof p.paths<"u"?q.Utilities.forEachProperty(l,(w,e)=>p.paths[w]=e):h==="config"&&typeof p.config<"u"?q.Utilities.forEachProperty(l,(w,e)=>p.config[w]=e):p[h]=q.Utilities.recursiveClone(l)}),r.validateConfigurationOptions(p)}}q.ConfigurationOptionsUtil=r;class M{constructor(g,v){if(this._env=g,this.options=r.mergeConfigurationOptions(v),this._createIgnoreDuplicateModulesMap(),this._createSortedPathsRules(),this.options.baseUrl===""&&this.options.nodeRequire&&this.options.nodeRequire.main&&this.options.nodeRequire.main.filename&&this._env.isNode){let p=this.options.nodeRequire.main.filename,h=Math.max(p.lastIndexOf("/"),p.lastIndexOf("\\"));this.options.baseUrl=p.substring(0,h+1)}}_createIgnoreDuplicateModulesMap(){this.ignoreDuplicateModulesMap={};for(let g=0;g<this.options.ignoreDuplicateModules.length;g++)this.ignoreDuplicateModulesMap[this.options.ignoreDuplicateModules[g]]=!0}_createSortedPathsRules(){this.sortedPathsRules=[],q.Utilities.forEachProperty(this.options.paths,(g,v)=>{Array.isArray(v)?this.sortedPathsRules.push({from:g,to:v}):this.sortedPathsRules.push({from:g,to:[v]})}),this.sortedPathsRules.sort((g,v)=>v.from.length-g.from.length)}cloneAndMerge(g){return new M(this._env,r.mergeConfigurationOptions(g,this.options))}getOptionsLiteral(){return this.options}_applyPaths(g){let v;for(let p=0,h=this.sortedPathsRules.length;p<h;p++)if(v=this.sortedPathsRules[p],q.Utilities.startsWith(g,v.from)){let l=[];for(let w=0,e=v.to.length;w<e;w++)l.push(v.to[w]+g.substr(v.from.length));return l}return[g]}_addUrlArgsToUrl(g){return q.Utilities.containsQueryString(g)?g+"&"+this.options.urlArgs:g+"?"+this.options.urlArgs}_addUrlArgsIfNecessaryToUrl(g){return this.options.urlArgs?this._addUrlArgsToUrl(g):g}_addUrlArgsIfNecessaryToUrls(g){if(this.options.urlArgs)for(let v=0,p=g.length;v<p;v++)g[v]=this._addUrlArgsToUrl(g[v]);return g}moduleIdToPaths(g){if(this._env.isNode&&this.options.amdModulesPattern instanceof RegExp&&!this.options.amdModulesPattern.test(g))return this.isBuild()?["empty:"]:["node|"+g];let v=g,p;if(!q.Utilities.endsWith(v,".js")&&!q.Utilities.isAbsolutePath(v)){p=this._applyPaths(v);for(let h=0,l=p.length;h<l;h++)this.isBuild()&&p[h]==="empty:"||(q.Utilities.isAbsolutePath(p[h])||(p[h]=this.options.baseUrl+p[h]),!q.Utilities.endsWith(p[h],".js")&&!q.Utilities.containsQueryString(p[h])&&(p[h]=p[h]+".js"))}else!q.Utilities.endsWith(v,".js")&&!q.Utilities.containsQueryString(v)&&(v=v+".js"),p=[v];return this._addUrlArgsIfNecessaryToUrls(p)}requireToUrl(g){let v=g;return q.Utilities.isAbsolutePath(v)||(v=this._applyPaths(v)[0],q.Utilities.isAbsolutePath(v)||(v=this.options.baseUrl+v)),this._addUrlArgsIfNecessaryToUrl(v)}isBuild(){return this.options.isBuild}shouldInvokeFactory(g){return!!(!this.options.isBuild||q.Utilities.isAnonymousModule(g)||this.options.buildForceInvokeFactory&&this.options.buildForceInvokeFactory[g])}isDuplicateMessageIgnoredFor(g){return this.ignoreDuplicateModulesMap.hasOwnProperty(g)}getConfigForModule(g){if(this.options.config)return this.options.config[g]}shouldCatchError(){return this.options.catchError}shouldRecordStats(){return this.options.recordStats}onError(g){this.options.onError(g)}}q.Configuration=M})(fe||(fe={}));var fe;(function(q){class n{constructor(l){this._env=l,this._scriptLoader=null,this._callbackMap={}}load(l,w,e,s){if(!this._scriptLoader)if(this._env.isWebWorker)this._scriptLoader=new A;else if(this._env.isElectronRenderer){const{preferScriptTags:u}=l.getConfig().getOptionsLiteral();u?this._scriptLoader=new r:this._scriptLoader=new g(this._env)}else this._env.isNode?this._scriptLoader=new g(this._env):this._scriptLoader=new r;let o={callback:e,errorback:s};if(this._callbackMap.hasOwnProperty(w)){this._callbackMap[w].push(o);return}this._callbackMap[w]=[o],this._scriptLoader.load(l,w,()=>this.triggerCallback(w),u=>this.triggerErrorback(w,u))}triggerCallback(l){let w=this._callbackMap[l];delete this._callbackMap[l];for(let e=0;e<w.length;e++)w[e].callback()}triggerErrorback(l,w){let e=this._callbackMap[l];delete this._callbackMap[l];for(let s=0;s<e.length;s++)e[s].errorback(w)}}class r{attachListeners(l,w,e){let s=()=>{l.removeEventListener("load",o),l.removeEventListener("error",u)},o=b=>{s(),w()},u=b=>{s(),e(b)};l.addEventListener("load",o),l.addEventListener("error",u)}load(l,w,e,s){if(/^node\|/.test(w)){let o=l.getConfig().getOptionsLiteral(),u=v(l.getRecorder(),o.nodeRequire||q.global.nodeRequire),b=w.split("|"),d=null;try{d=u(b[1])}catch(y){s(y);return}l.enqueueDefineAnonymousModule([],()=>d),e()}else{let o=document.createElement("script");o.setAttribute("async","async"),o.setAttribute("type","text/javascript"),this.attachListeners(o,e,s);const{trustedTypesPolicy:u}=l.getConfig().getOptionsLiteral();u&&(w=u.createScriptURL(w)),o.setAttribute("src",w);const{cspNonce:b}=l.getConfig().getOptionsLiteral();b&&o.setAttribute("nonce",b),document.getElementsByTagName("head")[0].appendChild(o)}}}function M(h){const{trustedTypesPolicy:l}=h.getConfig().getOptionsLiteral();try{return(l?self.eval(l.createScript("","true")):new Function("true")).call(self),!0}catch{return!1}}class A{constructor(){this._cachedCanUseEval=null}_canUseEval(l){return this._cachedCanUseEval===null&&(this._cachedCanUseEval=M(l)),this._cachedCanUseEval}load(l,w,e,s){if(/^node\|/.test(w)){const o=l.getConfig().getOptionsLiteral(),u=v(l.getRecorder(),o.nodeRequire||q.global.nodeRequire),b=w.split("|");let d=null;try{d=u(b[1])}catch(y){s(y);return}l.enqueueDefineAnonymousModule([],function(){return d}),e()}else{const{trustedTypesPolicy:o}=l.getConfig().getOptionsLiteral();if(!(/^((http:)|(https:)|(file:))/.test(w)&&w.substring(0,self.origin.length)!==self.origin)&&this._canUseEval(l)){fetch(w).then(b=>{if(b.status!==200)throw new Error(b.statusText);return b.text()}).then(b=>{b=`${b}
//# sourceURL=${w}`,(o?self.eval(o.createScript("",b)):new Function(b)).call(self),e()}).then(void 0,s);return}try{o&&(w=o.createScriptURL(w)),importScripts(w),e()}catch(b){s(b)}}}}class g{constructor(l){this._env=l,this._didInitialize=!1,this._didPatchNodeRequire=!1}_init(l){this._didInitialize||(this._didInitialize=!0,this._fs=l("fs"),this._vm=l("vm"),this._path=l("path"),this._crypto=l("crypto"))}_initNodeRequire(l,w){const{nodeCachedData:e}=w.getConfig().getOptionsLiteral();if(!e||this._didPatchNodeRequire)return;this._didPatchNodeRequire=!0;const s=this,o=l("module");function u(b){const d=b.constructor;let y=function(N){try{return b.require(N)}finally{}};return y.resolve=function(N,S){return d._resolveFilename(N,b,!1,S)},y.resolve.paths=function(N){return d._resolveLookupPaths(N,b)},y.main=process.mainModule,y.extensions=d._extensions,y.cache=d._cache,y}o.prototype._compile=function(b,d){const y=o.wrap(b.replace(/^#!.*/,"")),_=w.getRecorder(),N=s._getCachedDataPath(e,d),S={filename:d};let C;try{const R=s._fs.readFileSync(N);C=R.slice(0,16),S.cachedData=R.slice(16),_.record(60,N)}catch{_.record(61,N)}const i=new s._vm.Script(y,S),a=i.runInThisContext(S),m=s._path.dirname(d),L=u(this),c=[this.exports,L,this,d,m,process,Ae,Buffer],f=a.apply(this.exports,c);return s._handleCachedData(i,y,N,!S.cachedData,w),s._verifyCachedData(i,y,N,C,w),f}}load(l,w,e,s){const o=l.getConfig().getOptionsLiteral(),u=v(l.getRecorder(),o.nodeRequire||q.global.nodeRequire),b=o.nodeInstrumenter||function(y){return y};this._init(u),this._initNodeRequire(u,l);let d=l.getRecorder();if(/^node\|/.test(w)){let y=w.split("|"),_=null;try{_=u(y[1])}catch(N){s(N);return}l.enqueueDefineAnonymousModule([],()=>_),e()}else{w=q.Utilities.fileUriToFilePath(this._env.isWindows,w);const y=this._path.normalize(w),_=this._getElectronRendererScriptPathOrUri(y),N=!!o.nodeCachedData,S=N?this._getCachedDataPath(o.nodeCachedData,w):void 0;this._readSourceAndCachedData(y,S,d,(C,i,a,m)=>{if(C){s(C);return}let L;i.charCodeAt(0)===g._BOM?L=g._PREFIX+i.substring(1)+g._SUFFIX:L=g._PREFIX+i+g._SUFFIX,L=b(L,y);const c={filename:_,cachedData:a},f=this._createAndEvalScript(l,L,c,e,s);this._handleCachedData(f,L,S,N&&!a,l),this._verifyCachedData(f,L,S,m,l)})}}_createAndEvalScript(l,w,e,s,o){const u=l.getRecorder();u.record(31,e.filename);const b=new this._vm.Script(w,e),d=b.runInThisContext(e),y=l.getGlobalAMDDefineFunc();let _=!1;const N=function(){return _=!0,y.apply(null,arguments)};return N.amd=y.amd,d.call(q.global,l.getGlobalAMDRequireFunc(),N,e.filename,this._path.dirname(e.filename)),u.record(32,e.filename),_?s():o(new Error(`Didn't receive define call in ${e.filename}!`)),b}_getElectronRendererScriptPathOrUri(l){if(!this._env.isElectronRenderer)return l;let w=l.match(/^([a-z])\:(.*)/i);return w?`file:///${(w[1].toUpperCase()+":"+w[2]).replace(/\\/g,"/")}`:`file://${l}`}_getCachedDataPath(l,w){const e=this._crypto.createHash("md5").update(w,"utf8").update(l.seed,"utf8").update(process.arch,"").digest("hex"),s=this._path.basename(w).replace(/\.js$/,"");return this._path.join(l.path,`${s}-${e}.code`)}_handleCachedData(l,w,e,s,o){l.cachedDataRejected?this._fs.unlink(e,u=>{o.getRecorder().record(62,e),this._createAndWriteCachedData(l,w,e,o),u&&o.getConfig().onError(u)}):s&&this._createAndWriteCachedData(l,w,e,o)}_createAndWriteCachedData(l,w,e,s){let o=Math.ceil(s.getConfig().getOptionsLiteral().nodeCachedData.writeDelay*(1+Math.random())),u=-1,b=0,d;const y=()=>{setTimeout(()=>{d||(d=this._crypto.createHash("md5").update(w,"utf8").digest());const _=l.createCachedData();if(!(_.length===0||_.length===u||b>=5)){if(_.length<u){y();return}u=_.length,this._fs.writeFile(e,Buffer.concat([d,_]),N=>{N&&s.getConfig().onError(N),s.getRecorder().record(63,e),y()})}},o*Math.pow(4,b++))};y()}_readSourceAndCachedData(l,w,e,s){if(!w)this._fs.readFile(l,{encoding:"utf8"},s);else{let o,u,b,d=2;const y=_=>{_?s(_):--d===0&&s(void 0,o,u,b)};this._fs.readFile(l,{encoding:"utf8"},(_,N)=>{o=N,y(_)}),this._fs.readFile(w,(_,N)=>{!_&&N&&N.length>0?(b=N.slice(0,16),u=N.slice(16),e.record(60,w)):e.record(61,w),y()})}}_verifyCachedData(l,w,e,s,o){s&&(l.cachedDataRejected||setTimeout(()=>{const u=this._crypto.createHash("md5").update(w,"utf8").digest();s.equals(u)||(o.getConfig().onError(new Error(`FAILED TO VERIFY CACHED DATA, deleting stale '${e}' now, but a RESTART IS REQUIRED`)),this._fs.unlink(e,b=>{b&&o.getConfig().onError(b)}))},Math.ceil(5e3*(1+Math.random()))))}}g._BOM=65279,g._PREFIX="(function (require, define, __filename, __dirname) { ",g._SUFFIX=`
});`;function v(h,l){if(l.__$__isRecorded)return l;const w=function(s){h.record(33,s);try{return l(s)}finally{h.record(34,s)}};return w.__$__isRecorded=!0,w}q.ensureRecordedNodeRequire=v;function p(h){return new n(h)}q.createScriptLoader=p})(fe||(fe={}));var fe;(function(q){class n{constructor(h){let l=h.lastIndexOf("/");l!==-1?this.fromModulePath=h.substr(0,l+1):this.fromModulePath=""}static _normalizeModuleId(h){let l=h,w;for(w=/\/\.\//;w.test(l);)l=l.replace(w,"/");for(l=l.replace(/^\.\//g,""),w=/\/(([^\/])|([^\/][^\/\.])|([^\/\.][^\/])|([^\/][^\/][^\/]+))\/\.\.\//;w.test(l);)l=l.replace(w,"/");return l=l.replace(/^(([^\/])|([^\/][^\/\.])|([^\/\.][^\/])|([^\/][^\/][^\/]+))\/\.\.\//,""),l}resolveModule(h){let l=h;return q.Utilities.isAbsolutePath(l)||(q.Utilities.startsWith(l,"./")||q.Utilities.startsWith(l,"../"))&&(l=n._normalizeModuleId(this.fromModulePath+l)),l}}n.ROOT=new n(""),q.ModuleIdResolver=n;class r{constructor(h,l,w,e,s,o){this.id=h,this.strId=l,this.dependencies=w,this._callback=e,this._errorback=s,this.moduleIdResolver=o,this.exports={},this.error=null,this.exportsPassedIn=!1,this.unresolvedDependenciesCount=this.dependencies.length,this._isComplete=!1}static _safeInvokeFunction(h,l){try{return{returnedValue:h.apply(q.global,l),producedError:null}}catch(w){return{returnedValue:null,producedError:w}}}static _invokeFactory(h,l,w,e){return h.shouldInvokeFactory(l)?h.shouldCatchError()?this._safeInvokeFunction(w,e):{returnedValue:w.apply(q.global,e),producedError:null}:{returnedValue:null,producedError:null}}complete(h,l,w,e){this._isComplete=!0;let s=null;if(this._callback)if(typeof this._callback=="function"){h.record(21,this.strId);let o=r._invokeFactory(l,this.strId,this._callback,w);s=o.producedError,h.record(22,this.strId),!s&&typeof o.returnedValue<"u"&&(!this.exportsPassedIn||q.Utilities.isEmpty(this.exports))&&(this.exports=o.returnedValue)}else this.exports=this._callback;if(s){let o=q.ensureError(s);o.phase="factory",o.moduleId=this.strId,o.neededBy=e(this.id),this.error=o,l.onError(o)}this.dependencies=null,this._callback=null,this._errorback=null,this.moduleIdResolver=null}onDependencyError(h){return this._isComplete=!0,this.error=h,this._errorback?(this._errorback(h),!0):!1}isComplete(){return this._isComplete}}q.Module=r;class M{constructor(){this._nextId=0,this._strModuleIdToIntModuleId=new Map,this._intModuleIdToStrModuleId=[],this.getModuleId("exports"),this.getModuleId("module"),this.getModuleId("require")}getMaxModuleId(){return this._nextId}getModuleId(h){let l=this._strModuleIdToIntModuleId.get(h);return typeof l>"u"&&(l=this._nextId++,this._strModuleIdToIntModuleId.set(h,l),this._intModuleIdToStrModuleId[l]=h),l}getStrModuleId(h){return this._intModuleIdToStrModuleId[h]}}class A{constructor(h){this.id=h}}A.EXPORTS=new A(0),A.MODULE=new A(1),A.REQUIRE=new A(2),q.RegularDependency=A;class g{constructor(h,l,w){this.id=h,this.pluginId=l,this.pluginParam=w}}q.PluginDependency=g;class v{constructor(h,l,w,e,s=0){this._env=h,this._scriptLoader=l,this._loaderAvailableTimestamp=s,this._defineFunc=w,this._requireFunc=e,this._moduleIdProvider=new M,this._config=new q.Configuration(this._env),this._hasDependencyCycle=!1,this._modules2=[],this._knownModules2=[],this._inverseDependencies2=[],this._inversePluginDependencies2=new Map,this._currentAnonymousDefineCall=null,this._recorder=null,this._buildInfoPath=[],this._buildInfoDefineStack=[],this._buildInfoDependencies=[],this._requireFunc.moduleManager=this}reset(){return new v(this._env,this._scriptLoader,this._defineFunc,this._requireFunc,this._loaderAvailableTimestamp)}getGlobalAMDDefineFunc(){return this._defineFunc}getGlobalAMDRequireFunc(){return this._requireFunc}static _findRelevantLocationInStack(h,l){let w=o=>o.replace(/\\/g,"/"),e=w(h),s=l.split(/\n/);for(let o=0;o<s.length;o++){let u=s[o].match(/(.*):(\d+):(\d+)\)?$/);if(u){let b=u[1],d=u[2],y=u[3],_=Math.max(b.lastIndexOf(" ")+1,b.lastIndexOf("(")+1);if(b=b.substr(_),b=w(b),b===e){let N={line:parseInt(d,10),col:parseInt(y,10)};return N.line===1&&(N.col-=53),N}}}throw new Error("Could not correlate define call site for needle "+h)}getBuildInfo(){if(!this._config.isBuild())return null;let h=[],l=0;for(let w=0,e=this._modules2.length;w<e;w++){let s=this._modules2[w];if(!s)continue;let o=this._buildInfoPath[s.id]||null,u=this._buildInfoDefineStack[s.id]||null,b=this._buildInfoDependencies[s.id];h[l++]={id:s.strId,path:o,defineLocation:o&&u?v._findRelevantLocationInStack(o,u):null,dependencies:b,shim:null,exports:s.exports}}return h}getRecorder(){return this._recorder||(this._config.shouldRecordStats()?this._recorder=new q.LoaderEventRecorder(this._loaderAvailableTimestamp):this._recorder=q.NullLoaderEventRecorder.INSTANCE),this._recorder}getLoaderEvents(){return this.getRecorder().getEvents()}enqueueDefineAnonymousModule(h,l){if(this._currentAnonymousDefineCall!==null)throw new Error("Can only have one anonymous define call per script file");let w=null;this._config.isBuild()&&(w=new Error("StackLocation").stack||null),this._currentAnonymousDefineCall={stack:w,dependencies:h,callback:l}}defineModule(h,l,w,e,s,o=new n(h)){let u=this._moduleIdProvider.getModuleId(h);if(this._modules2[u]){this._config.isDuplicateMessageIgnoredFor(h)||console.warn("Duplicate definition of module '"+h+"'");return}let b=new r(u,h,this._normalizeDependencies(l,o),w,e,o);this._modules2[u]=b,this._config.isBuild()&&(this._buildInfoDefineStack[u]=s,this._buildInfoDependencies[u]=(b.dependencies||[]).map(d=>this._moduleIdProvider.getStrModuleId(d.id))),this._resolve(b)}_normalizeDependency(h,l){if(h==="exports")return A.EXPORTS;if(h==="module")return A.MODULE;if(h==="require")return A.REQUIRE;let w=h.indexOf("!");if(w>=0){let e=l.resolveModule(h.substr(0,w)),s=l.resolveModule(h.substr(w+1)),o=this._moduleIdProvider.getModuleId(e+"!"+s),u=this._moduleIdProvider.getModuleId(e);return new g(o,u,s)}return new A(this._moduleIdProvider.getModuleId(l.resolveModule(h)))}_normalizeDependencies(h,l){let w=[],e=0;for(let s=0,o=h.length;s<o;s++)w[e++]=this._normalizeDependency(h[s],l);return w}_relativeRequire(h,l,w,e){if(typeof l=="string")return this.synchronousRequire(l,h);this.defineModule(q.Utilities.generateAnonymousModule(),l,w,e,null,h)}synchronousRequire(h,l=new n(h)){let w=this._normalizeDependency(h,l),e=this._modules2[w.id];if(!e)throw new Error("Check dependency list! Synchronous require cannot resolve module '"+h+"'. This is the first mention of this module!");if(!e.isComplete())throw new Error("Check dependency list! Synchronous require cannot resolve module '"+h+"'. This module has not been resolved completely yet.");if(e.error)throw e.error;return e.exports}configure(h,l){let w=this._config.shouldRecordStats();l?this._config=new q.Configuration(this._env,h):this._config=this._config.cloneAndMerge(h),this._config.shouldRecordStats()&&!w&&(this._recorder=null)}getConfig(){return this._config}_onLoad(h){if(this._currentAnonymousDefineCall!==null){let l=this._currentAnonymousDefineCall;this._currentAnonymousDefineCall=null,this.defineModule(this._moduleIdProvider.getStrModuleId(h),l.dependencies,l.callback,null,l.stack)}}_createLoadError(h,l){let w=this._moduleIdProvider.getStrModuleId(h),e=(this._inverseDependencies2[h]||[]).map(o=>this._moduleIdProvider.getStrModuleId(o));const s=q.ensureError(l);return s.phase="loading",s.moduleId=w,s.neededBy=e,s}_onLoadError(h,l){const w=this._createLoadError(h,l);this._modules2[h]||(this._modules2[h]=new r(h,this._moduleIdProvider.getStrModuleId(h),[],()=>{},null,null));let e=[];for(let u=0,b=this._moduleIdProvider.getMaxModuleId();u<b;u++)e[u]=!1;let s=!1,o=[];for(o.push(h),e[h]=!0;o.length>0;){let u=o.shift(),b=this._modules2[u];b&&(s=b.onDependencyError(w)||s);let d=this._inverseDependencies2[u];if(d)for(let y=0,_=d.length;y<_;y++){let N=d[y];e[N]||(o.push(N),e[N]=!0)}}s||this._config.onError(w)}_hasDependencyPath(h,l){let w=this._modules2[h];if(!w)return!1;let e=[];for(let o=0,u=this._moduleIdProvider.getMaxModuleId();o<u;o++)e[o]=!1;let s=[];for(s.push(w),e[h]=!0;s.length>0;){let u=s.shift().dependencies;if(u)for(let b=0,d=u.length;b<d;b++){let y=u[b];if(y.id===l)return!0;let _=this._modules2[y.id];_&&!e[y.id]&&(e[y.id]=!0,s.push(_))}}return!1}_findCyclePath(h,l,w){if(h===l||w===50)return[h];let e=this._modules2[h];if(!e)return null;let s=e.dependencies;if(s)for(let o=0,u=s.length;o<u;o++){let b=this._findCyclePath(s[o].id,l,w+1);if(b!==null)return b.push(h),b}return null}_createRequire(h){let l=(w,e,s)=>this._relativeRequire(h,w,e,s);return l.toUrl=w=>this._config.requireToUrl(h.resolveModule(w)),l.getStats=()=>this.getLoaderEvents(),l.hasDependencyCycle=()=>this._hasDependencyCycle,l.config=(w,e=!1)=>{this.configure(w,e)},l.__$__nodeRequire=q.global.nodeRequire,l}_loadModule(h){if(this._modules2[h]||this._knownModules2[h])return;this._knownModules2[h]=!0;let l=this._moduleIdProvider.getStrModuleId(h),w=this._config.moduleIdToPaths(l),e=/^@[^\/]+\/[^\/]+$/;this._env.isNode&&(l.indexOf("/")===-1||e.test(l))&&w.push("node|"+l);let s=-1,o=u=>{if(s++,s>=w.length)this._onLoadError(h,u);else{let b=w[s],d=this.getRecorder();if(this._config.isBuild()&&b==="empty:"){this._buildInfoPath[h]=b,this.defineModule(this._moduleIdProvider.getStrModuleId(h),[],null,null,null),this._onLoad(h);return}d.record(10,b),this._scriptLoader.load(this,b,()=>{this._config.isBuild()&&(this._buildInfoPath[h]=b),d.record(11,b),this._onLoad(h)},y=>{d.record(12,b),o(y)})}};o(null)}_loadPluginDependency(h,l){if(this._modules2[l.id]||this._knownModules2[l.id])return;this._knownModules2[l.id]=!0;let w=e=>{this.defineModule(this._moduleIdProvider.getStrModuleId(l.id),[],e,null,null)};w.error=e=>{this._config.onError(this._createLoadError(l.id,e))},h.load(l.pluginParam,this._createRequire(n.ROOT),w,this._config.getOptionsLiteral())}_resolve(h){let l=h.dependencies;if(l)for(let w=0,e=l.length;w<e;w++){let s=l[w];if(s===A.EXPORTS){h.exportsPassedIn=!0,h.unresolvedDependenciesCount--;continue}if(s===A.MODULE){h.unresolvedDependenciesCount--;continue}if(s===A.REQUIRE){h.unresolvedDependenciesCount--;continue}let o=this._modules2[s.id];if(o&&o.isComplete()){if(o.error){h.onDependencyError(o.error);return}h.unresolvedDependenciesCount--;continue}if(this._hasDependencyPath(s.id,h.id)){this._hasDependencyCycle=!0,console.warn("There is a dependency cycle between '"+this._moduleIdProvider.getStrModuleId(s.id)+"' and '"+this._moduleIdProvider.getStrModuleId(h.id)+"'. The cyclic path follows:");let u=this._findCyclePath(s.id,h.id,0)||[];u.reverse(),u.push(s.id),console.warn(u.map(b=>this._moduleIdProvider.getStrModuleId(b)).join(` => 
`)),h.unresolvedDependenciesCount--;continue}if(this._inverseDependencies2[s.id]=this._inverseDependencies2[s.id]||[],this._inverseDependencies2[s.id].push(h.id),s instanceof g){let u=this._modules2[s.pluginId];if(u&&u.isComplete()){this._loadPluginDependency(u.exports,s);continue}let b=this._inversePluginDependencies2.get(s.pluginId);b||(b=[],this._inversePluginDependencies2.set(s.pluginId,b)),b.push(s),this._loadModule(s.pluginId);continue}this._loadModule(s.id)}h.unresolvedDependenciesCount===0&&this._onModuleComplete(h)}_onModuleComplete(h){let l=this.getRecorder();if(h.isComplete())return;let w=h.dependencies,e=[];if(w)for(let b=0,d=w.length;b<d;b++){let y=w[b];if(y===A.EXPORTS){e[b]=h.exports;continue}if(y===A.MODULE){e[b]={id:h.strId,config:()=>this._config.getConfigForModule(h.strId)};continue}if(y===A.REQUIRE){e[b]=this._createRequire(h.moduleIdResolver);continue}let _=this._modules2[y.id];if(_){e[b]=_.exports;continue}e[b]=null}const s=b=>(this._inverseDependencies2[b]||[]).map(d=>this._moduleIdProvider.getStrModuleId(d));h.complete(l,this._config,e,s);let o=this._inverseDependencies2[h.id];if(this._inverseDependencies2[h.id]=null,o)for(let b=0,d=o.length;b<d;b++){let y=o[b],_=this._modules2[y];_.unresolvedDependenciesCount--,_.unresolvedDependenciesCount===0&&this._onModuleComplete(_)}let u=this._inversePluginDependencies2.get(h.id);if(u){this._inversePluginDependencies2.delete(h.id);for(let b=0,d=u.length;b<d;b++)this._loadPluginDependency(h.exports,u[b])}}}q.ModuleManager=v})(fe||(fe={}));var X,fe;(function(q){const n=new q.Environment;let r=null;const M=function(p,h,l){typeof p!="string"&&(l=h,h=p,p=null),(typeof h!="object"||!Array.isArray(h))&&(l=h,h=null),h||(h=["require","exports","module"]),p?r.defineModule(p,h,l,null,null):r.enqueueDefineAnonymousModule(h,l)};M.amd={jQuery:!0};const A=function(p,h=!1){r.configure(p,h)},g=function(){if(arguments.length===1){if(arguments[0]instanceof Object&&!Array.isArray(arguments[0])){A(arguments[0]);return}if(typeof arguments[0]=="string")return r.synchronousRequire(arguments[0])}if((arguments.length===2||arguments.length===3)&&Array.isArray(arguments[0])){r.defineModule(q.Utilities.generateAnonymousModule(),arguments[0],arguments[1],arguments[2],null);return}throw new Error("Unrecognized require call")};g.config=A,g.getConfig=function(){return r.getConfig().getOptionsLiteral()},g.reset=function(){r=r.reset()},g.getBuildInfo=function(){return r.getBuildInfo()},g.getStats=function(){return r.getLoaderEvents()},g.define=M;function v(){if(typeof q.global.require<"u"||typeof require<"u"){const p=q.global.require||require;if(typeof p=="function"&&typeof p.resolve=="function"){const h=q.ensureRecordedNodeRequire(r.getRecorder(),p);q.global.nodeRequire=h,g.nodeRequire=h,g.__$__nodeRequire=h}}n.isNode&&!n.isElectronRenderer&&!n.isElectronNodeIntegrationWebWorker?module.exports=g:(n.isElectronRenderer||(q.global.define=M),q.global.require=g)}q.init=v,(typeof q.global.define!="function"||!q.global.define.amd)&&(r=new q.ModuleManager(n,q.createScriptLoader(n),M,g,q.Utilities.getHighPerformanceTimestamp()),typeof q.global.require<"u"&&typeof q.global.require!="function"&&g.config(q.global.require),X=function(){return M.apply(null,arguments)},X.amd=M.amd,typeof doNotInitLoader>"u"&&v())})(fe||(fe={})),X(Z[19],K([0,1]),function(q,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.localize=w,n.localize2=e,n.getConfiguredDefaultLocale=s,n.setPseudoTranslation=o,n.create=u,n.load=b;let r=typeof document<"u"&&document.location&&document.location.hash.indexOf("pseudo=true")>=0;const M="i-default";function A(d,y){let _;return y.length===0?_=d:_=d.replace(/\{(\d+)\}/g,(N,S)=>{const C=S[0],i=y[C];let a=N;return typeof i=="string"?a=i:(typeof i=="number"||typeof i=="boolean"||i===void 0||i===null)&&(a=String(i)),a}),r&&(_="\uFF3B"+_.replace(/[aouei]/g,"$&$&")+"\uFF3D"),_}function g(d,y){let _=d[y];return _||(_=d["*"],_)?_:null}function v(d){return d.charAt(d.length-1)==="/"?d:d+"/"}async function p(d,y,_){const N=v(d)+v(y)+"vscode/"+v(_),S=await fetch(N);if(S.ok)return await S.json();throw new Error(`${S.status} - ${S.statusText}`)}function h(d){return function(y,_){const N=Array.prototype.slice.call(arguments,2);return A(d[y],N)}}function l(d){return(y,_,...N)=>({value:A(d[y],N),original:A(_,N)})}function w(d,y,..._){return A(y,_)}function e(d,y,..._){const N=A(y,_);return{value:N,original:N}}function s(d){}function o(d){r=d}function u(d,y){var _;return{localize:h(y[d]),localize2:l(y[d]),getConfiguredDefaultLocale:(_=y.getConfiguredDefaultLocale)!==null&&_!==void 0?_:N=>{}}}function b(d,y,_,N){var S;const C=(S=N["vs/nls"])!==null&&S!==void 0?S:{};if(!d||d.length===0)return _({localize:w,localize2:e,getConfiguredDefaultLocale:()=>{var c;return(c=C.availableLanguages)===null||c===void 0?void 0:c["*"]}});const i=C.availableLanguages?g(C.availableLanguages,d):null,a=i===null||i===M;let m=".nls";a||(m=m+"."+i);const L=c=>{Array.isArray(c)?(c.localize=h(c),c.localize2=l(c)):(c.localize=h(c[d]),c.localize2=l(c[d])),c.getConfiguredDefaultLocale=()=>{var f;return(f=C.availableLanguages)===null||f===void 0?void 0:f["*"]},_(c)};typeof C.loadBundle=="function"?C.loadBundle(d,i,(c,f)=>{c?y([d+".nls"],L):L(f)}):C.translationServiceUrl&&!a?(async()=>{var c;try{const f=await p(C.translationServiceUrl,i,d);return L(f)}catch(f){if(!i.includes("-"))return console.error(f),y([d+".nls"],L);try{const R=i.split("-")[0],E=await p(C.translationServiceUrl,R,d);return(c=C.availableLanguages)!==null&&c!==void 0||(C.availableLanguages={}),C.availableLanguages["*"]=R,L(E)}catch(R){return console.error(R),y([d+".nls"],L)}}})():y([d+m],L,c=>{if(m===".nls"){console.error("Failed trying to load default language strings",c);return}console.error(`Failed to load message bundle for language ${i}. Falling back to the default language:`,c),y([d+".nls"],L)})}}),function(){const q=globalThis.MonacoEnvironment,n=q&&q.baseUrl?q.baseUrl:"../../../";function r(w,e){var s;if(q?.createTrustedTypesPolicy)try{return q.createTrustedTypesPolicy(w,e)}catch(o){console.warn(o);return}try{return(s=self.trustedTypes)===null||s===void 0?void 0:s.createPolicy(w,e)}catch(o){console.warn(o);return}}const M=r("amdLoader",{createScriptURL:w=>w,createScript:(w,...e)=>{const s=e.slice(0,-1).join(","),o=e.pop().toString();return`(function anonymous(${s}) { ${o}
})`}});function A(){try{return(M?globalThis.eval(M.createScript("","true")):new Function("true")).call(globalThis),!0}catch{return!1}}function g(){return new Promise((w,e)=>{if(typeof globalThis.define=="function"&&globalThis.define.amd)return w();const s=n+"vs/loader.js";if(!(/^((http:)|(https:)|(file:))/.test(s)&&s.substring(0,globalThis.origin.length)!==globalThis.origin)&&A()){fetch(s).then(u=>{if(u.status!==200)throw new Error(u.statusText);return u.text()}).then(u=>{u=`${u}
//# sourceURL=${s}`,(M?globalThis.eval(M.createScript("",u)):new Function(u)).call(globalThis),w()}).then(void 0,e);return}M?importScripts(M.createScriptURL(s)):importScripts(s),w()})}function v(){require.config({baseUrl:n,catchError:!0,trustedTypesPolicy:M,amdModulesPattern:/^vs\//})}function p(w){g().then(()=>{v(),require([w],function(e){setTimeout(function(){const s=e.create((o,u)=>{globalThis.postMessage(o,u)},null);for(globalThis.onmessage=o=>s.onmessage(o.data,o.ports);l.length>0;){const o=l.shift();s.onmessage(o.data,o.ports)}},0)})})}typeof globalThis.define=="function"&&globalThis.define.amd&&v();let h=!0;const l=[];globalThis.onmessage=w=>{if(!h){l.push(w);return}h=!1,p(w.data)}}(),X(Z[7],K([0,1]),function(q,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.Permutation=n.CallbackIterable=n.ArrayQueue=n.booleanComparator=n.numberComparator=n.CompareResult=void 0,n.tail=r,n.tail2=M,n.equals=A,n.removeFastWithoutKeepingOrder=g,n.binarySearch=v,n.binarySearch2=p,n.quickSelect=h,n.groupBy=l,n.groupAdjacentBy=w,n.forEachAdjacent=e,n.forEachWithNeighbors=s,n.coalesce=o,n.coalesceInPlace=u,n.isFalsyOrEmpty=b,n.isNonEmptyArray=d,n.distinct=y,n.firstOrDefault=_,n.range=N,n.arrayInsert=S,n.pushToStart=C,n.pushToEnd=i,n.pushMany=a,n.asArray=m,n.insertInto=L,n.splice=c,n.compareBy=E,n.tieBreakComparators=x,n.reverseOrder=k;function r(I,F=0){return I[I.length-(1+F)]}function M(I){if(I.length===0)throw new Error("Invalid tail call");return[I.slice(0,I.length-1),I[I.length-1]]}function A(I,F,O=(V,H)=>V===H){if(I===F)return!0;if(!I||!F||I.length!==F.length)return!1;for(let V=0,H=I.length;V<H;V++)if(!O(I[V],F[V]))return!1;return!0}function g(I,F){const O=I.length-1;F<O&&(I[F]=I[O]),I.pop()}function v(I,F,O){return p(I.length,V=>O(I[V],F))}function p(I,F){let O=0,V=I-1;for(;O<=V;){const H=(O+V)/2|0,U=F(H);if(U<0)O=H+1;else if(U>0)V=H-1;else return H}return-(O+1)}function h(I,F,O){if(I=I|0,I>=F.length)throw new TypeError("invalid index");const V=F[Math.floor(F.length*Math.random())],H=[],U=[],ie=[];for(const oe of F){const t=O(oe,V);t<0?H.push(oe):t>0?U.push(oe):ie.push(oe)}return I<H.length?h(I,H,O):I<H.length+ie.length?ie[0]:h(I-(H.length+ie.length),U,O)}function l(I,F){const O=[];let V;for(const H of I.slice(0).sort(F))!V||F(V[0],H)!==0?(V=[H],O.push(V)):V.push(H);return O}function*w(I,F){let O,V;for(const H of I)V!==void 0&&F(V,H)?O.push(H):(O&&(yield O),O=[H]),V=H;O&&(yield O)}function e(I,F){for(let O=0;O<=I.length;O++)F(O===0?void 0:I[O-1],O===I.length?void 0:I[O])}function s(I,F){for(let O=0;O<I.length;O++)F(O===0?void 0:I[O-1],I[O],O+1===I.length?void 0:I[O+1])}function o(I){return I.filter(F=>!!F)}function u(I){let F=0;for(let O=0;O<I.length;O++)I[O]&&(I[F]=I[O],F+=1);I.length=F}function b(I){return!Array.isArray(I)||I.length===0}function d(I){return Array.isArray(I)&&I.length>0}function y(I,F=O=>O){const O=new Set;return I.filter(V=>{const H=F(V);return O.has(H)?!1:(O.add(H),!0)})}function _(I,F){return I.length>0?I[0]:F}function N(I,F){let O=typeof F=="number"?I:0;typeof F=="number"?O=I:(O=0,F=I);const V=[];if(O<=F)for(let H=O;H<F;H++)V.push(H);else for(let H=O;H>F;H--)V.push(H);return V}function S(I,F,O){const V=I.slice(0,F),H=I.slice(F);return V.concat(O,H)}function C(I,F){const O=I.indexOf(F);O>-1&&(I.splice(O,1),I.unshift(F))}function i(I,F){const O=I.indexOf(F);O>-1&&(I.splice(O,1),I.push(F))}function a(I,F){for(const O of F)I.push(O)}function m(I){return Array.isArray(I)?I:[I]}function L(I,F,O){const V=f(I,F),H=I.length,U=O.length;I.length=H+U;for(let ie=H-1;ie>=V;ie--)I[ie+U]=I[ie];for(let ie=0;ie<U;ie++)I[ie+V]=O[ie]}function c(I,F,O,V){const H=f(I,F);let U=I.splice(H,O);return U===void 0&&(U=[]),L(I,H,V),U}function f(I,F){return F<0?Math.max(F+I.length,0):Math.min(F,I.length)}var R;(function(I){function F(U){return U<0}I.isLessThan=F;function O(U){return U<=0}I.isLessThanOrEqual=O;function V(U){return U>0}I.isGreaterThan=V;function H(U){return U===0}I.isNeitherLessOrGreaterThan=H,I.greaterThan=1,I.lessThan=-1,I.neitherLessOrGreaterThan=0})(R||(n.CompareResult=R={}));function E(I,F){return(O,V)=>F(I(O),I(V))}function x(...I){return(F,O)=>{for(const V of I){const H=V(F,O);if(!R.isNeitherLessOrGreaterThan(H))return H}return R.neitherLessOrGreaterThan}}const D=(I,F)=>I-F;n.numberComparator=D;const T=(I,F)=>(0,n.numberComparator)(I?1:0,F?1:0);n.booleanComparator=T;function k(I){return(F,O)=>-I(F,O)}class W{constructor(F){this.items=F,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(F){let O=this.firstIdx;for(;O<this.items.length&&F(this.items[O]);)O++;const V=O===this.firstIdx?null:this.items.slice(this.firstIdx,O);return this.firstIdx=O,V}takeFromEndWhile(F){let O=this.lastIdx;for(;O>=0&&F(this.items[O]);)O--;const V=O===this.lastIdx?null:this.items.slice(O+1,this.lastIdx+1);return this.lastIdx=O,V}peek(){if(this.length!==0)return this.items[this.firstIdx]}dequeue(){const F=this.items[this.firstIdx];return this.firstIdx++,F}takeCount(F){const O=this.items.slice(this.firstIdx,this.firstIdx+F);return this.firstIdx+=F,O}}n.ArrayQueue=W;class j{constructor(F){this.iterate=F}toArray(){const F=[];return this.iterate(O=>(F.push(O),!0)),F}filter(F){return new j(O=>this.iterate(V=>F(V)?O(V):!0))}map(F){return new j(O=>this.iterate(V=>O(F(V))))}findLast(F){let O;return this.iterate(V=>(F(V)&&(O=V),!0)),O}findLastMaxBy(F){let O,V=!0;return this.iterate(H=>((V||R.isGreaterThan(F(H,O)))&&(V=!1,O=H),!0)),O}}n.CallbackIterable=j,j.empty=new j(I=>{});class ${constructor(F){this._indexMap=F}static createSortPermutation(F,O){const V=Array.from(F.keys()).sort((H,U)=>O(F[H],F[U]));return new $(V)}apply(F){return F.map((O,V)=>F[this._indexMap[V]])}inverse(){const F=this._indexMap.slice();for(let O=0;O<this._indexMap.length;O++)F[this._indexMap[O]]=O;return new $(F)}}n.Permutation=$}),X(Z[11],K([0,1]),function(q,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.MonotonousArray=void 0,n.findLast=r,n.findLastIdx=M,n.findLastMonotonous=A,n.findLastIdxMonotonous=g,n.findFirstMonotonous=v,n.findFirstIdxMonotonousOrArrLen=p,n.findFirstMaxBy=l,n.findLastMaxBy=w,n.findFirstMinBy=e,n.findMaxIdxBy=s,n.mapFindFirst=o;function r(u,b,d){const y=M(u,b);if(y!==-1)return u[y]}function M(u,b,d=u.length-1){for(let y=d;y>=0;y--){const _=u[y];if(b(_))return y}return-1}function A(u,b){const d=g(u,b);return d===-1?void 0:u[d]}function g(u,b,d=0,y=u.length){let _=d,N=y;for(;_<N;){const S=Math.floor((_+N)/2);b(u[S])?_=S+1:N=S}return _-1}function v(u,b){const d=p(u,b);return d===u.length?void 0:u[d]}function p(u,b,d=0,y=u.length){let _=d,N=y;for(;_<N;){const S=Math.floor((_+N)/2);b(u[S])?N=S:_=S+1}return _}class h{constructor(b){this._array=b,this._findLastMonotonousLastIdx=0}findLastMonotonous(b){if(h.assertInvariants){if(this._prevFindLastPredicate){for(const y of this._array)if(this._prevFindLastPredicate(y)&&!b(y))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this._prevFindLastPredicate=b}const d=g(this._array,b,this._findLastMonotonousLastIdx);return this._findLastMonotonousLastIdx=d+1,d===-1?void 0:this._array[d]}}n.MonotonousArray=h,h.assertInvariants=!1;function l(u,b){if(u.length===0)return;let d=u[0];for(let y=1;y<u.length;y++){const _=u[y];b(_,d)>0&&(d=_)}return d}function w(u,b){if(u.length===0)return;let d=u[0];for(let y=1;y<u.length;y++){const _=u[y];b(_,d)>=0&&(d=_)}return d}function e(u,b){return l(u,(d,y)=>-b(d,y))}function s(u,b){if(u.length===0)return-1;let d=0;for(let y=1;y<u.length;y++){const _=u[y];b(_,u[d])>0&&(d=y)}return d}function o(u,b){for(const d of u){const y=b(d);if(y!==void 0)return y}}}),X(Z[33],K([0,1]),function(q,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.CachedFunction=n.LRUCachedFunction=void 0;class r{constructor(g){this.fn=g,this.lastCache=void 0,this.lastArgKey=void 0}get(g){const v=JSON.stringify(g);return this.lastArgKey!==v&&(this.lastArgKey=v,this.lastCache=this.fn(g)),this.lastCache}}n.LRUCachedFunction=r;class M{get cachedValues(){return this._map}constructor(g){this.fn=g,this._map=new Map}get(g){if(this._map.has(g))return this._map.get(g);const v=this.fn(g);return this._map.set(g,v),v}}n.CachedFunction=M}),X(Z[34],K([0,1]),function(q,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.Color=n.HSVA=n.HSLA=n.RGBA=void 0;function r(p,h){const l=Math.pow(10,h);return Math.round(p*l)/l}class M{constructor(h,l,w,e=1){this._rgbaBrand=void 0,this.r=Math.min(255,Math.max(0,h))|0,this.g=Math.min(255,Math.max(0,l))|0,this.b=Math.min(255,Math.max(0,w))|0,this.a=r(Math.max(Math.min(1,e),0),3)}static equals(h,l){return h.r===l.r&&h.g===l.g&&h.b===l.b&&h.a===l.a}}n.RGBA=M;class A{constructor(h,l,w,e){this._hslaBrand=void 0,this.h=Math.max(Math.min(360,h),0)|0,this.s=r(Math.max(Math.min(1,l),0),3),this.l=r(Math.max(Math.min(1,w),0),3),this.a=r(Math.max(Math.min(1,e),0),3)}static equals(h,l){return h.h===l.h&&h.s===l.s&&h.l===l.l&&h.a===l.a}static fromRGBA(h){const l=h.r/255,w=h.g/255,e=h.b/255,s=h.a,o=Math.max(l,w,e),u=Math.min(l,w,e);let b=0,d=0;const y=(u+o)/2,_=o-u;if(_>0){switch(d=Math.min(y<=.5?_/(2*y):_/(2-2*y),1),o){case l:b=(w-e)/_+(w<e?6:0);break;case w:b=(e-l)/_+2;break;case e:b=(l-w)/_+4;break}b*=60,b=Math.round(b)}return new A(b,d,y,s)}static _hue2rgb(h,l,w){return w<0&&(w+=1),w>1&&(w-=1),w<1/6?h+(l-h)*6*w:w<1/2?l:w<2/3?h+(l-h)*(2/3-w)*6:h}static toRGBA(h){const l=h.h/360,{s:w,l:e,a:s}=h;let o,u,b;if(w===0)o=u=b=e;else{const d=e<.5?e*(1+w):e+w-e*w,y=2*e-d;o=A._hue2rgb(y,d,l+1/3),u=A._hue2rgb(y,d,l),b=A._hue2rgb(y,d,l-1/3)}return new M(Math.round(o*255),Math.round(u*255),Math.round(b*255),s)}}n.HSLA=A;class g{constructor(h,l,w,e){this._hsvaBrand=void 0,this.h=Math.max(Math.min(360,h),0)|0,this.s=r(Math.max(Math.min(1,l),0),3),this.v=r(Math.max(Math.min(1,w),0),3),this.a=r(Math.max(Math.min(1,e),0),3)}static equals(h,l){return h.h===l.h&&h.s===l.s&&h.v===l.v&&h.a===l.a}static fromRGBA(h){const l=h.r/255,w=h.g/255,e=h.b/255,s=Math.max(l,w,e),o=Math.min(l,w,e),u=s-o,b=s===0?0:u/s;let d;return u===0?d=0:s===l?d=((w-e)/u%6+6)%6:s===w?d=(e-l)/u+2:d=(l-w)/u+4,new g(Math.round(d*60),b,s,h.a)}static toRGBA(h){const{h:l,s:w,v:e,a:s}=h,o=e*w,u=o*(1-Math.abs(l/60%2-1)),b=e-o;let[d,y,_]=[0,0,0];return l<60?(d=o,y=u):l<120?(d=u,y=o):l<180?(y=o,_=u):l<240?(y=u,_=o):l<300?(d=u,_=o):l<=360&&(d=o,_=u),d=Math.round((d+b)*255),y=Math.round((y+b)*255),_=Math.round((_+b)*255),new M(d,y,_,s)}}n.HSVA=g;class v{static fromHex(h){return v.Format.CSS.parseHex(h)||v.red}static equals(h,l){return!h&&!l?!0:!h||!l?!1:h.equals(l)}get hsla(){return this._hsla?this._hsla:A.fromRGBA(this.rgba)}get hsva(){return this._hsva?this._hsva:g.fromRGBA(this.rgba)}constructor(h){if(h)if(h instanceof M)this.rgba=h;else if(h instanceof A)this._hsla=h,this.rgba=A.toRGBA(h);else if(h instanceof g)this._hsva=h,this.rgba=g.toRGBA(h);else throw new Error("Invalid color ctor argument");else throw new Error("Color needs a value")}equals(h){return!!h&&M.equals(this.rgba,h.rgba)&&A.equals(this.hsla,h.hsla)&&g.equals(this.hsva,h.hsva)}getRelativeLuminance(){const h=v._relativeLuminanceForComponent(this.rgba.r),l=v._relativeLuminanceForComponent(this.rgba.g),w=v._relativeLuminanceForComponent(this.rgba.b),e=.2126*h+.7152*l+.0722*w;return r(e,4)}static _relativeLuminanceForComponent(h){const l=h/255;return l<=.03928?l/12.92:Math.pow((l+.055)/1.055,2.4)}isLighter(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3>=128}isLighterThan(h){const l=this.getRelativeLuminance(),w=h.getRelativeLuminance();return l>w}isDarkerThan(h){const l=this.getRelativeLuminance(),w=h.getRelativeLuminance();return l<w}lighten(h){return new v(new A(this.hsla.h,this.hsla.s,this.hsla.l+this.hsla.l*h,this.hsla.a))}darken(h){return new v(new A(this.hsla.h,this.hsla.s,this.hsla.l-this.hsla.l*h,this.hsla.a))}transparent(h){const{r:l,g:w,b:e,a:s}=this.rgba;return new v(new M(l,w,e,s*h))}isTransparent(){return this.rgba.a===0}isOpaque(){return this.rgba.a===1}opposite(){return new v(new M(255-this.rgba.r,255-this.rgba.g,255-this.rgba.b,this.rgba.a))}makeOpaque(h){if(this.isOpaque()||h.rgba.a!==1)return this;const{r:l,g:w,b:e,a:s}=this.rgba;return new v(new M(h.rgba.r-s*(h.rgba.r-l),h.rgba.g-s*(h.rgba.g-w),h.rgba.b-s*(h.rgba.b-e),1))}toString(){return this._toString||(this._toString=v.Format.CSS.format(this)),this._toString}static getLighterColor(h,l,w){if(h.isLighterThan(l))return h;w=w||.5;const e=h.getRelativeLuminance(),s=l.getRelativeLuminance();return w=w*(s-e)/s,h.lighten(w)}static getDarkerColor(h,l,w){if(h.isDarkerThan(l))return h;w=w||.5;const e=h.getRelativeLuminance(),s=l.getRelativeLuminance();return w=w*(e-s)/e,h.darken(w)}}n.Color=v,v.white=new v(new M(255,255,255,1)),v.black=new v(new M(0,0,0,1)),v.red=new v(new M(255,0,0,1)),v.blue=new v(new M(0,0,255,1)),v.green=new v(new M(0,255,0,1)),v.cyan=new v(new M(0,255,255,1)),v.lightgrey=new v(new M(211,211,211,1)),v.transparent=new v(new M(0,0,0,0)),function(p){let h;(function(l){let w;(function(e){function s(i){return i.rgba.a===1?`rgb(${i.rgba.r}, ${i.rgba.g}, ${i.rgba.b})`:p.Format.CSS.formatRGBA(i)}e.formatRGB=s;function o(i){return`rgba(${i.rgba.r}, ${i.rgba.g}, ${i.rgba.b}, ${+i.rgba.a.toFixed(2)})`}e.formatRGBA=o;function u(i){return i.hsla.a===1?`hsl(${i.hsla.h}, ${(i.hsla.s*100).toFixed(2)}%, ${(i.hsla.l*100).toFixed(2)}%)`:p.Format.CSS.formatHSLA(i)}e.formatHSL=u;function b(i){return`hsla(${i.hsla.h}, ${(i.hsla.s*100).toFixed(2)}%, ${(i.hsla.l*100).toFixed(2)}%, ${i.hsla.a.toFixed(2)})`}e.formatHSLA=b;function d(i){const a=i.toString(16);return a.length!==2?"0"+a:a}function y(i){return`#${d(i.rgba.r)}${d(i.rgba.g)}${d(i.rgba.b)}`}e.formatHex=y;function _(i,a=!1){return a&&i.rgba.a===1?p.Format.CSS.formatHex(i):`#${d(i.rgba.r)}${d(i.rgba.g)}${d(i.rgba.b)}${d(Math.round(i.rgba.a*255))}`}e.formatHexA=_;function N(i){return i.isOpaque()?p.Format.CSS.formatHex(i):p.Format.CSS.formatRGBA(i)}e.format=N;function S(i){const a=i.length;if(a===0||i.charCodeAt(0)!==35)return null;if(a===7){const m=16*C(i.charCodeAt(1))+C(i.charCodeAt(2)),L=16*C(i.charCodeAt(3))+C(i.charCodeAt(4)),c=16*C(i.charCodeAt(5))+C(i.charCodeAt(6));return new p(new M(m,L,c,1))}if(a===9){const m=16*C(i.charCodeAt(1))+C(i.charCodeAt(2)),L=16*C(i.charCodeAt(3))+C(i.charCodeAt(4)),c=16*C(i.charCodeAt(5))+C(i.charCodeAt(6)),f=16*C(i.charCodeAt(7))+C(i.charCodeAt(8));return new p(new M(m,L,c,f/255))}if(a===4){const m=C(i.charCodeAt(1)),L=C(i.charCodeAt(2)),c=C(i.charCodeAt(3));return new p(new M(16*m+m,16*L+L,16*c+c))}if(a===5){const m=C(i.charCodeAt(1)),L=C(i.charCodeAt(2)),c=C(i.charCodeAt(3)),f=C(i.charCodeAt(4));return new p(new M(16*m+m,16*L+L,16*c+c,(16*f+f)/255))}return null}e.parseHex=S;function C(i){switch(i){case 48:return 0;case 49:return 1;case 50:return 2;case 51:return 3;case 52:return 4;case 53:return 5;case 54:return 6;case 55:return 7;case 56:return 8;case 57:return 9;case 97:return 10;case 65:return 10;case 98:return 11;case 66:return 11;case 99:return 12;case 67:return 12;case 100:return 13;case 68:return 13;case 101:return 14;case 69:return 14;case 102:return 15;case 70:return 15}return 0}})(w=l.CSS||(l.CSS={}))})(h=p.Format||(p.Format={}))}(v||(n.Color=v={}))}),X(Z[35],K([0,1]),function(q,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.DiffChange=void 0;class r{constructor(A,g,v,p){this.originalStart=A,this.originalLength=g,this.modifiedStart=v,this.modifiedLength=p}getOriginalEnd(){return this.originalStart+this.originalLength}getModifiedEnd(){return this.modifiedStart+this.modifiedLength}}n.DiffChange=r}),X(Z[5],K([0,1]),function(q,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.BugIndicatingError=n.ErrorNoTelemetry=n.NotSupportedError=n.CancellationError=n.errorHandler=n.ErrorHandler=void 0,n.onUnexpectedError=M,n.onUnexpectedExternalError=A,n.transformErrorForSerialization=g,n.isCancellationError=p,n.canceled=l,n.illegalArgument=w,n.illegalState=e;class r{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(d){setTimeout(()=>{throw d.stack?o.isErrorNoTelemetry(d)?new o(d.message+`

`+d.stack):new Error(d.message+`

`+d.stack):d},0)}}emit(d){this.listeners.forEach(y=>{y(d)})}onUnexpectedError(d){this.unexpectedErrorHandler(d),this.emit(d)}onUnexpectedExternalError(d){this.unexpectedErrorHandler(d)}}n.ErrorHandler=r,n.errorHandler=new r;function M(b){p(b)||n.errorHandler.onUnexpectedError(b)}function A(b){p(b)||n.errorHandler.onUnexpectedExternalError(b)}function g(b){if(b instanceof Error){const{name:d,message:y}=b,_=b.stacktrace||b.stack;return{$isError:!0,name:d,message:y,stack:_,noTelemetry:o.isErrorNoTelemetry(b)}}return b}const v="Canceled";function p(b){return b instanceof h?!0:b instanceof Error&&b.name===v&&b.message===v}class h extends Error{constructor(){super(v),this.name=this.message}}n.CancellationError=h;function l(){const b=new Error(v);return b.name=b.message,b}function w(b){return b?new Error(`Illegal argument: ${b}`):new Error("Illegal argument")}function e(b){return b?new Error(`Illegal state: ${b}`):new Error("Illegal state")}class s extends Error{constructor(d){super("NotSupported"),d&&(this.message=d)}}n.NotSupportedError=s;class o extends Error{constructor(d){super(d),this.name="CodeExpectedError"}static fromError(d){if(d instanceof o)return d;const y=new o;return y.message=d.message,y.stack=d.stack,y}static isErrorNoTelemetry(d){return d.name==="CodeExpectedError"}}n.ErrorNoTelemetry=o;class u extends Error{constructor(d){super(d||"An unexpected bug occurred."),Object.setPrototypeOf(this,u.prototype)}}n.BugIndicatingError=u}),X(Z[12],K([0,1,5]),function(q,n,r){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.ok=M,n.assertNever=A,n.softAssert=g,n.assertFn=v,n.checkAdjacentItems=p;function M(h,l){if(!h)throw new Error(l?`Assertion failed (${l})`:"Assertion Failed")}function A(h,l="Unreachable"){throw new Error(l)}function g(h){h||(0,r.onUnexpectedError)(new r.BugIndicatingError("Soft Assertion Failed"))}function v(h){if(!h()){debugger;h(),(0,r.onUnexpectedError)(new r.BugIndicatingError("Assertion Failed"))}}function p(h,l){let w=0;for(;w<h.length-1;){const e=h[w],s=h[w+1];if(!l(e,s))return!1;w++}return!0}}),X(Z[20],K([0,1]),function(q,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.createSingleCallFunction=r;function r(M,A){const g=this;let v=!1,p;return function(){if(v)return p;if(v=!0,A)try{p=M.apply(g,arguments)}finally{A()}else p=M.apply(g,arguments);return p}}}),X(Z[21],K([0,1]),function(q,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.Iterable=void 0;var r;(function(M){function A(i){return i&&typeof i=="object"&&typeof i[Symbol.iterator]=="function"}M.is=A;const g=Object.freeze([]);function v(){return g}M.empty=v;function*p(i){yield i}M.single=p;function h(i){return A(i)?i:p(i)}M.wrap=h;function l(i){return i||g}M.from=l;function*w(i){for(let a=i.length-1;a>=0;a--)yield i[a]}M.reverse=w;function e(i){return!i||i[Symbol.iterator]().next().done===!0}M.isEmpty=e;function s(i){return i[Symbol.iterator]().next().value}M.first=s;function o(i,a){for(const m of i)if(a(m))return!0;return!1}M.some=o;function u(i,a){for(const m of i)if(a(m))return m}M.find=u;function*b(i,a){for(const m of i)a(m)&&(yield m)}M.filter=b;function*d(i,a){let m=0;for(const L of i)yield a(L,m++)}M.map=d;function*y(...i){for(const a of i)yield*a}M.concat=y;function _(i,a,m){let L=m;for(const c of i)L=a(L,c);return L}M.reduce=_;function*N(i,a,m=i.length){for(a<0&&(a+=i.length),m<0?m+=i.length:m>i.length&&(m=i.length);a<m;a++)yield i[a]}M.slice=N;function S(i,a=Number.POSITIVE_INFINITY){const m=[];if(a===0)return[m,i];const L=i[Symbol.iterator]();for(let c=0;c<a;c++){const f=L.next();if(f.done)return[m,M.empty()];m.push(f.value)}return[m,{[Symbol.iterator](){return L}}]}M.consume=S;async function C(i){const a=[];for await(const m of i)a.push(m);return Promise.resolve(a)}M.asyncToArray=C})(r||(n.Iterable=r={}))}),X(Z[36],K([0,1]),function(q,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.KeyCodeUtils=n.IMMUTABLE_KEY_CODE_TO_CODE=n.IMMUTABLE_CODE_TO_KEY_CODE=n.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE=n.EVENT_KEY_CODE_MAP=void 0,n.KeyChord=w;class r{constructor(){this._keyCodeToStr=[],this._strToKeyCode=Object.create(null)}define(s,o){this._keyCodeToStr[s]=o,this._strToKeyCode[o.toLowerCase()]=s}keyCodeToStr(s){return this._keyCodeToStr[s]}strToKeyCode(s){return this._strToKeyCode[s.toLowerCase()]||0}}const M=new r,A=new r,g=new r;n.EVENT_KEY_CODE_MAP=new Array(230),n.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE={};const v=[],p=Object.create(null),h=Object.create(null);n.IMMUTABLE_CODE_TO_KEY_CODE=[],n.IMMUTABLE_KEY_CODE_TO_CODE=[];for(let e=0;e<=193;e++)n.IMMUTABLE_CODE_TO_KEY_CODE[e]=-1;for(let e=0;e<=132;e++)n.IMMUTABLE_KEY_CODE_TO_CODE[e]=-1;(function(){const e="",s=[[1,0,"None",0,"unknown",0,"VK_UNKNOWN",e,e],[1,1,"Hyper",0,e,0,e,e,e],[1,2,"Super",0,e,0,e,e,e],[1,3,"Fn",0,e,0,e,e,e],[1,4,"FnLock",0,e,0,e,e,e],[1,5,"Suspend",0,e,0,e,e,e],[1,6,"Resume",0,e,0,e,e,e],[1,7,"Turbo",0,e,0,e,e,e],[1,8,"Sleep",0,e,0,"VK_SLEEP",e,e],[1,9,"WakeUp",0,e,0,e,e,e],[0,10,"KeyA",31,"A",65,"VK_A",e,e],[0,11,"KeyB",32,"B",66,"VK_B",e,e],[0,12,"KeyC",33,"C",67,"VK_C",e,e],[0,13,"KeyD",34,"D",68,"VK_D",e,e],[0,14,"KeyE",35,"E",69,"VK_E",e,e],[0,15,"KeyF",36,"F",70,"VK_F",e,e],[0,16,"KeyG",37,"G",71,"VK_G",e,e],[0,17,"KeyH",38,"H",72,"VK_H",e,e],[0,18,"KeyI",39,"I",73,"VK_I",e,e],[0,19,"KeyJ",40,"J",74,"VK_J",e,e],[0,20,"KeyK",41,"K",75,"VK_K",e,e],[0,21,"KeyL",42,"L",76,"VK_L",e,e],[0,22,"KeyM",43,"M",77,"VK_M",e,e],[0,23,"KeyN",44,"N",78,"VK_N",e,e],[0,24,"KeyO",45,"O",79,"VK_O",e,e],[0,25,"KeyP",46,"P",80,"VK_P",e,e],[0,26,"KeyQ",47,"Q",81,"VK_Q",e,e],[0,27,"KeyR",48,"R",82,"VK_R",e,e],[0,28,"KeyS",49,"S",83,"VK_S",e,e],[0,29,"KeyT",50,"T",84,"VK_T",e,e],[0,30,"KeyU",51,"U",85,"VK_U",e,e],[0,31,"KeyV",52,"V",86,"VK_V",e,e],[0,32,"KeyW",53,"W",87,"VK_W",e,e],[0,33,"KeyX",54,"X",88,"VK_X",e,e],[0,34,"KeyY",55,"Y",89,"VK_Y",e,e],[0,35,"KeyZ",56,"Z",90,"VK_Z",e,e],[0,36,"Digit1",22,"1",49,"VK_1",e,e],[0,37,"Digit2",23,"2",50,"VK_2",e,e],[0,38,"Digit3",24,"3",51,"VK_3",e,e],[0,39,"Digit4",25,"4",52,"VK_4",e,e],[0,40,"Digit5",26,"5",53,"VK_5",e,e],[0,41,"Digit6",27,"6",54,"VK_6",e,e],[0,42,"Digit7",28,"7",55,"VK_7",e,e],[0,43,"Digit8",29,"8",56,"VK_8",e,e],[0,44,"Digit9",30,"9",57,"VK_9",e,e],[0,45,"Digit0",21,"0",48,"VK_0",e,e],[1,46,"Enter",3,"Enter",13,"VK_RETURN",e,e],[1,47,"Escape",9,"Escape",27,"VK_ESCAPE",e,e],[1,48,"Backspace",1,"Backspace",8,"VK_BACK",e,e],[1,49,"Tab",2,"Tab",9,"VK_TAB",e,e],[1,50,"Space",10,"Space",32,"VK_SPACE",e,e],[0,51,"Minus",88,"-",189,"VK_OEM_MINUS","-","OEM_MINUS"],[0,52,"Equal",86,"=",187,"VK_OEM_PLUS","=","OEM_PLUS"],[0,53,"BracketLeft",92,"[",219,"VK_OEM_4","[","OEM_4"],[0,54,"BracketRight",94,"]",221,"VK_OEM_6","]","OEM_6"],[0,55,"Backslash",93,"\\",220,"VK_OEM_5","\\","OEM_5"],[0,56,"IntlHash",0,e,0,e,e,e],[0,57,"Semicolon",85,";",186,"VK_OEM_1",";","OEM_1"],[0,58,"Quote",95,"'",222,"VK_OEM_7","'","OEM_7"],[0,59,"Backquote",91,"`",192,"VK_OEM_3","`","OEM_3"],[0,60,"Comma",87,",",188,"VK_OEM_COMMA",",","OEM_COMMA"],[0,61,"Period",89,".",190,"VK_OEM_PERIOD",".","OEM_PERIOD"],[0,62,"Slash",90,"/",191,"VK_OEM_2","/","OEM_2"],[1,63,"CapsLock",8,"CapsLock",20,"VK_CAPITAL",e,e],[1,64,"F1",59,"F1",112,"VK_F1",e,e],[1,65,"F2",60,"F2",113,"VK_F2",e,e],[1,66,"F3",61,"F3",114,"VK_F3",e,e],[1,67,"F4",62,"F4",115,"VK_F4",e,e],[1,68,"F5",63,"F5",116,"VK_F5",e,e],[1,69,"F6",64,"F6",117,"VK_F6",e,e],[1,70,"F7",65,"F7",118,"VK_F7",e,e],[1,71,"F8",66,"F8",119,"VK_F8",e,e],[1,72,"F9",67,"F9",120,"VK_F9",e,e],[1,73,"F10",68,"F10",121,"VK_F10",e,e],[1,74,"F11",69,"F11",122,"VK_F11",e,e],[1,75,"F12",70,"F12",123,"VK_F12",e,e],[1,76,"PrintScreen",0,e,0,e,e,e],[1,77,"ScrollLock",84,"ScrollLock",145,"VK_SCROLL",e,e],[1,78,"Pause",7,"PauseBreak",19,"VK_PAUSE",e,e],[1,79,"Insert",19,"Insert",45,"VK_INSERT",e,e],[1,80,"Home",14,"Home",36,"VK_HOME",e,e],[1,81,"PageUp",11,"PageUp",33,"VK_PRIOR",e,e],[1,82,"Delete",20,"Delete",46,"VK_DELETE",e,e],[1,83,"End",13,"End",35,"VK_END",e,e],[1,84,"PageDown",12,"PageDown",34,"VK_NEXT",e,e],[1,85,"ArrowRight",17,"RightArrow",39,"VK_RIGHT","Right",e],[1,86,"ArrowLeft",15,"LeftArrow",37,"VK_LEFT","Left",e],[1,87,"ArrowDown",18,"DownArrow",40,"VK_DOWN","Down",e],[1,88,"ArrowUp",16,"UpArrow",38,"VK_UP","Up",e],[1,89,"NumLock",83,"NumLock",144,"VK_NUMLOCK",e,e],[1,90,"NumpadDivide",113,"NumPad_Divide",111,"VK_DIVIDE",e,e],[1,91,"NumpadMultiply",108,"NumPad_Multiply",106,"VK_MULTIPLY",e,e],[1,92,"NumpadSubtract",111,"NumPad_Subtract",109,"VK_SUBTRACT",e,e],[1,93,"NumpadAdd",109,"NumPad_Add",107,"VK_ADD",e,e],[1,94,"NumpadEnter",3,e,0,e,e,e],[1,95,"Numpad1",99,"NumPad1",97,"VK_NUMPAD1",e,e],[1,96,"Numpad2",100,"NumPad2",98,"VK_NUMPAD2",e,e],[1,97,"Numpad3",101,"NumPad3",99,"VK_NUMPAD3",e,e],[1,98,"Numpad4",102,"NumPad4",100,"VK_NUMPAD4",e,e],[1,99,"Numpad5",103,"NumPad5",101,"VK_NUMPAD5",e,e],[1,100,"Numpad6",104,"NumPad6",102,"VK_NUMPAD6",e,e],[1,101,"Numpad7",105,"NumPad7",103,"VK_NUMPAD7",e,e],[1,102,"Numpad8",106,"NumPad8",104,"VK_NUMPAD8",e,e],[1,103,"Numpad9",107,"NumPad9",105,"VK_NUMPAD9",e,e],[1,104,"Numpad0",98,"NumPad0",96,"VK_NUMPAD0",e,e],[1,105,"NumpadDecimal",112,"NumPad_Decimal",110,"VK_DECIMAL",e,e],[0,106,"IntlBackslash",97,"OEM_102",226,"VK_OEM_102",e,e],[1,107,"ContextMenu",58,"ContextMenu",93,e,e,e],[1,108,"Power",0,e,0,e,e,e],[1,109,"NumpadEqual",0,e,0,e,e,e],[1,110,"F13",71,"F13",124,"VK_F13",e,e],[1,111,"F14",72,"F14",125,"VK_F14",e,e],[1,112,"F15",73,"F15",126,"VK_F15",e,e],[1,113,"F16",74,"F16",127,"VK_F16",e,e],[1,114,"F17",75,"F17",128,"VK_F17",e,e],[1,115,"F18",76,"F18",129,"VK_F18",e,e],[1,116,"F19",77,"F19",130,"VK_F19",e,e],[1,117,"F20",78,"F20",131,"VK_F20",e,e],[1,118,"F21",79,"F21",132,"VK_F21",e,e],[1,119,"F22",80,"F22",133,"VK_F22",e,e],[1,120,"F23",81,"F23",134,"VK_F23",e,e],[1,121,"F24",82,"F24",135,"VK_F24",e,e],[1,122,"Open",0,e,0,e,e,e],[1,123,"Help",0,e,0,e,e,e],[1,124,"Select",0,e,0,e,e,e],[1,125,"Again",0,e,0,e,e,e],[1,126,"Undo",0,e,0,e,e,e],[1,127,"Cut",0,e,0,e,e,e],[1,128,"Copy",0,e,0,e,e,e],[1,129,"Paste",0,e,0,e,e,e],[1,130,"Find",0,e,0,e,e,e],[1,131,"AudioVolumeMute",117,"AudioVolumeMute",173,"VK_VOLUME_MUTE",e,e],[1,132,"AudioVolumeUp",118,"AudioVolumeUp",175,"VK_VOLUME_UP",e,e],[1,133,"AudioVolumeDown",119,"AudioVolumeDown",174,"VK_VOLUME_DOWN",e,e],[1,134,"NumpadComma",110,"NumPad_Separator",108,"VK_SEPARATOR",e,e],[0,135,"IntlRo",115,"ABNT_C1",193,"VK_ABNT_C1",e,e],[1,136,"KanaMode",0,e,0,e,e,e],[0,137,"IntlYen",0,e,0,e,e,e],[1,138,"Convert",0,e,0,e,e,e],[1,139,"NonConvert",0,e,0,e,e,e],[1,140,"Lang1",0,e,0,e,e,e],[1,141,"Lang2",0,e,0,e,e,e],[1,142,"Lang3",0,e,0,e,e,e],[1,143,"Lang4",0,e,0,e,e,e],[1,144,"Lang5",0,e,0,e,e,e],[1,145,"Abort",0,e,0,e,e,e],[1,146,"Props",0,e,0,e,e,e],[1,147,"NumpadParenLeft",0,e,0,e,e,e],[1,148,"NumpadParenRight",0,e,0,e,e,e],[1,149,"NumpadBackspace",0,e,0,e,e,e],[1,150,"NumpadMemoryStore",0,e,0,e,e,e],[1,151,"NumpadMemoryRecall",0,e,0,e,e,e],[1,152,"NumpadMemoryClear",0,e,0,e,e,e],[1,153,"NumpadMemoryAdd",0,e,0,e,e,e],[1,154,"NumpadMemorySubtract",0,e,0,e,e,e],[1,155,"NumpadClear",131,"Clear",12,"VK_CLEAR",e,e],[1,156,"NumpadClearEntry",0,e,0,e,e,e],[1,0,e,5,"Ctrl",17,"VK_CONTROL",e,e],[1,0,e,4,"Shift",16,"VK_SHIFT",e,e],[1,0,e,6,"Alt",18,"VK_MENU",e,e],[1,0,e,57,"Meta",91,"VK_COMMAND",e,e],[1,157,"ControlLeft",5,e,0,"VK_LCONTROL",e,e],[1,158,"ShiftLeft",4,e,0,"VK_LSHIFT",e,e],[1,159,"AltLeft",6,e,0,"VK_LMENU",e,e],[1,160,"MetaLeft",57,e,0,"VK_LWIN",e,e],[1,161,"ControlRight",5,e,0,"VK_RCONTROL",e,e],[1,162,"ShiftRight",4,e,0,"VK_RSHIFT",e,e],[1,163,"AltRight",6,e,0,"VK_RMENU",e,e],[1,164,"MetaRight",57,e,0,"VK_RWIN",e,e],[1,165,"BrightnessUp",0,e,0,e,e,e],[1,166,"BrightnessDown",0,e,0,e,e,e],[1,167,"MediaPlay",0,e,0,e,e,e],[1,168,"MediaRecord",0,e,0,e,e,e],[1,169,"MediaFastForward",0,e,0,e,e,e],[1,170,"MediaRewind",0,e,0,e,e,e],[1,171,"MediaTrackNext",124,"MediaTrackNext",176,"VK_MEDIA_NEXT_TRACK",e,e],[1,172,"MediaTrackPrevious",125,"MediaTrackPrevious",177,"VK_MEDIA_PREV_TRACK",e,e],[1,173,"MediaStop",126,"MediaStop",178,"VK_MEDIA_STOP",e,e],[1,174,"Eject",0,e,0,e,e,e],[1,175,"MediaPlayPause",127,"MediaPlayPause",179,"VK_MEDIA_PLAY_PAUSE",e,e],[1,176,"MediaSelect",128,"LaunchMediaPlayer",181,"VK_MEDIA_LAUNCH_MEDIA_SELECT",e,e],[1,177,"LaunchMail",129,"LaunchMail",180,"VK_MEDIA_LAUNCH_MAIL",e,e],[1,178,"LaunchApp2",130,"LaunchApp2",183,"VK_MEDIA_LAUNCH_APP2",e,e],[1,179,"LaunchApp1",0,e,0,"VK_MEDIA_LAUNCH_APP1",e,e],[1,180,"SelectTask",0,e,0,e,e,e],[1,181,"LaunchScreenSaver",0,e,0,e,e,e],[1,182,"BrowserSearch",120,"BrowserSearch",170,"VK_BROWSER_SEARCH",e,e],[1,183,"BrowserHome",121,"BrowserHome",172,"VK_BROWSER_HOME",e,e],[1,184,"BrowserBack",122,"BrowserBack",166,"VK_BROWSER_BACK",e,e],[1,185,"BrowserForward",123,"BrowserForward",167,"VK_BROWSER_FORWARD",e,e],[1,186,"BrowserStop",0,e,0,"VK_BROWSER_STOP",e,e],[1,187,"BrowserRefresh",0,e,0,"VK_BROWSER_REFRESH",e,e],[1,188,"BrowserFavorites",0,e,0,"VK_BROWSER_FAVORITES",e,e],[1,189,"ZoomToggle",0,e,0,e,e,e],[1,190,"MailReply",0,e,0,e,e,e],[1,191,"MailForward",0,e,0,e,e,e],[1,192,"MailSend",0,e,0,e,e,e],[1,0,e,114,"KeyInComposition",229,e,e,e],[1,0,e,116,"ABNT_C2",194,"VK_ABNT_C2",e,e],[1,0,e,96,"OEM_8",223,"VK_OEM_8",e,e],[1,0,e,0,e,0,"VK_KANA",e,e],[1,0,e,0,e,0,"VK_HANGUL",e,e],[1,0,e,0,e,0,"VK_JUNJA",e,e],[1,0,e,0,e,0,"VK_FINAL",e,e],[1,0,e,0,e,0,"VK_HANJA",e,e],[1,0,e,0,e,0,"VK_KANJI",e,e],[1,0,e,0,e,0,"VK_CONVERT",e,e],[1,0,e,0,e,0,"VK_NONCONVERT",e,e],[1,0,e,0,e,0,"VK_ACCEPT",e,e],[1,0,e,0,e,0,"VK_MODECHANGE",e,e],[1,0,e,0,e,0,"VK_SELECT",e,e],[1,0,e,0,e,0,"VK_PRINT",e,e],[1,0,e,0,e,0,"VK_EXECUTE",e,e],[1,0,e,0,e,0,"VK_SNAPSHOT",e,e],[1,0,e,0,e,0,"VK_HELP",e,e],[1,0,e,0,e,0,"VK_APPS",e,e],[1,0,e,0,e,0,"VK_PROCESSKEY",e,e],[1,0,e,0,e,0,"VK_PACKET",e,e],[1,0,e,0,e,0,"VK_DBE_SBCSCHAR",e,e],[1,0,e,0,e,0,"VK_DBE_DBCSCHAR",e,e],[1,0,e,0,e,0,"VK_ATTN",e,e],[1,0,e,0,e,0,"VK_CRSEL",e,e],[1,0,e,0,e,0,"VK_EXSEL",e,e],[1,0,e,0,e,0,"VK_EREOF",e,e],[1,0,e,0,e,0,"VK_PLAY",e,e],[1,0,e,0,e,0,"VK_ZOOM",e,e],[1,0,e,0,e,0,"VK_NONAME",e,e],[1,0,e,0,e,0,"VK_PA1",e,e],[1,0,e,0,e,0,"VK_OEM_CLEAR",e,e]],o=[],u=[];for(const b of s){const[d,y,_,N,S,C,i,a,m]=b;if(u[y]||(u[y]=!0,v[y]=_,p[_]=y,h[_.toLowerCase()]=y,d&&(n.IMMUTABLE_CODE_TO_KEY_CODE[y]=N,N!==0&&N!==3&&N!==5&&N!==4&&N!==6&&N!==57&&(n.IMMUTABLE_KEY_CODE_TO_CODE[N]=y))),!o[N]){if(o[N]=!0,!S)throw new Error(`String representation missing for key code ${N} around scan code ${_}`);M.define(N,S),A.define(N,a||S),g.define(N,m||a||S)}C&&(n.EVENT_KEY_CODE_MAP[C]=N),i&&(n.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE[i]=N)}n.IMMUTABLE_KEY_CODE_TO_CODE[3]=46})();var l;(function(e){function s(_){return M.keyCodeToStr(_)}e.toString=s;function o(_){return M.strToKeyCode(_)}e.fromString=o;function u(_){return A.keyCodeToStr(_)}e.toUserSettingsUS=u;function b(_){return g.keyCodeToStr(_)}e.toUserSettingsGeneral=b;function d(_){return A.strToKeyCode(_)||g.strToKeyCode(_)}e.fromUserSettings=d;function y(_){if(_>=98&&_<=113)return null;switch(_){case 16:return"Up";case 18:return"Down";case 15:return"Left";case 17:return"Right"}return M.keyCodeToStr(_)}e.toElectronAccelerator=y})(l||(n.KeyCodeUtils=l={}));function w(e,s){const o=(s&65535)<<16>>>0;return(e|o)>>>0}}),X(Z[37],K([0,1]),function(q,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.Lazy=void 0;class r{constructor(A){this.executor=A,this._didRun=!1}get value(){if(!this._didRun)try{this._value=this.executor()}catch(A){this._error=A}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}}n.Lazy=r}),X(Z[13],K([0,1,20,21]),function(q,n,r,M){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.DisposableMap=n.ImmortalReference=n.RefCountedDisposable=n.MutableDisposable=n.Disposable=n.DisposableStore=void 0,n.setDisposableTracker=v,n.trackDisposable=p,n.markAsDisposed=h,n.markAsSingleton=e,n.isDisposable=s,n.dispose=o,n.combinedDisposable=u,n.toDisposable=b;const A=!1;let g=null;function v(i){g=i}if(A){const i="__is_disposable_tracked__";v(new class{trackDisposable(a){const m=new Error("Potentially leaked disposable").stack;setTimeout(()=>{a[i]||console.log(m)},3e3)}setParent(a,m){if(a&&a!==y.None)try{a[i]=!0}catch{}}markAsDisposed(a){if(a&&a!==y.None)try{a[i]=!0}catch{}}markAsSingleton(a){}})}function p(i){return g?.trackDisposable(i),i}function h(i){g?.markAsDisposed(i)}function l(i,a){g?.setParent(i,a)}function w(i,a){if(g)for(const m of i)g.setParent(m,a)}function e(i){return g?.markAsSingleton(i),i}function s(i){return typeof i.dispose=="function"&&i.dispose.length===0}function o(i){if(M.Iterable.is(i)){const a=[];for(const m of i)if(m)try{m.dispose()}catch(L){a.push(L)}if(a.length===1)throw a[0];if(a.length>1)throw new AggregateError(a,"Encountered errors while disposing of store");return Array.isArray(i)?[]:i}else if(i)return i.dispose(),i}function u(...i){const a=b(()=>o(i));return w(i,a),a}function b(i){const a=p({dispose:(0,r.createSingleCallFunction)(()=>{h(a),i()})});return a}class d{constructor(){this._toDispose=new Set,this._isDisposed=!1,p(this)}dispose(){this._isDisposed||(h(this),this._isDisposed=!0,this.clear())}get isDisposed(){return this._isDisposed}clear(){if(this._toDispose.size!==0)try{o(this._toDispose)}finally{this._toDispose.clear()}}add(a){if(!a)return a;if(a===this)throw new Error("Cannot register a disposable on itself!");return l(a,this),this._isDisposed?d.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(a),a}deleteAndLeak(a){a&&this._toDispose.has(a)&&(this._toDispose.delete(a),l(a,null))}}n.DisposableStore=d,d.DISABLE_DISPOSED_WARNING=!1;class y{constructor(){this._store=new d,p(this),l(this._store,this)}dispose(){h(this),this._store.dispose()}_register(a){if(a===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(a)}}n.Disposable=y,y.None=Object.freeze({dispose(){}});class _{constructor(){this._isDisposed=!1,p(this)}get value(){return this._isDisposed?void 0:this._value}set value(a){var m;this._isDisposed||a===this._value||((m=this._value)===null||m===void 0||m.dispose(),a&&l(a,this),this._value=a)}clear(){this.value=void 0}dispose(){var a;this._isDisposed=!0,h(this),(a=this._value)===null||a===void 0||a.dispose(),this._value=void 0}}n.MutableDisposable=_;class N{constructor(a){this._disposable=a,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter===0&&this._disposable.dispose(),this}}n.RefCountedDisposable=N;class S{constructor(a){this.object=a}dispose(){}}n.ImmortalReference=S;class C{constructor(){this._store=new Map,this._isDisposed=!1,p(this)}dispose(){h(this),this._isDisposed=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this._store.size)try{o(this._store.values())}finally{this._store.clear()}}get(a){return this._store.get(a)}set(a,m,L=!1){var c;this._isDisposed&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),L||(c=this._store.get(a))===null||c===void 0||c.dispose(),this._store.set(a,m)}deleteAndDispose(a){var m;(m=this._store.get(a))===null||m===void 0||m.dispose(),this._store.delete(a)}[Symbol.iterator](){return this._store[Symbol.iterator]()}}n.DisposableMap=C}),X(Z[22],K([0,1]),function(q,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.LinkedList=void 0;class r{constructor(g){this.element=g,this.next=r.Undefined,this.prev=r.Undefined}}r.Undefined=new r(void 0);class M{constructor(){this._first=r.Undefined,this._last=r.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===r.Undefined}clear(){let g=this._first;for(;g!==r.Undefined;){const v=g.next;g.prev=r.Undefined,g.next=r.Undefined,g=v}this._first=r.Undefined,this._last=r.Undefined,this._size=0}unshift(g){return this._insert(g,!1)}push(g){return this._insert(g,!0)}_insert(g,v){const p=new r(g);if(this._first===r.Undefined)this._first=p,this._last=p;else if(v){const l=this._last;this._last=p,p.prev=l,l.next=p}else{const l=this._first;this._first=p,p.next=l,l.prev=p}this._size+=1;let h=!1;return()=>{h||(h=!0,this._remove(p))}}shift(){if(this._first!==r.Undefined){const g=this._first.element;return this._remove(this._first),g}}pop(){if(this._last!==r.Undefined){const g=this._last.element;return this._remove(this._last),g}}_remove(g){if(g.prev!==r.Undefined&&g.next!==r.Undefined){const v=g.prev;v.next=g.next,g.next.prev=v}else g.prev===r.Undefined&&g.next===r.Undefined?(this._first=r.Undefined,this._last=r.Undefined):g.next===r.Undefined?(this._last=this._last.prev,this._last.next=r.Undefined):g.prev===r.Undefined&&(this._first=this._first.next,this._first.prev=r.Undefined);this._size-=1}*[Symbol.iterator](){let g=this._first;for(;g!==r.Undefined;)yield g.element,g=g.next}}n.LinkedList=M}),X(Z[38],K([0,1]),function(q,n){"use strict";var r,M;Object.defineProperty(n,"__esModule",{value:!0}),n.SetMap=n.BidirectionalMap=n.LRUCache=n.LinkedMap=n.ResourceMap=void 0;class A{constructor(s,o){this.uri=s,this.value=o}}function g(e){return Array.isArray(e)}class v{constructor(s,o){if(this[r]="ResourceMap",s instanceof v)this.map=new Map(s.map),this.toKey=o??v.defaultToKey;else if(g(s)){this.map=new Map,this.toKey=o??v.defaultToKey;for(const[u,b]of s)this.set(u,b)}else this.map=new Map,this.toKey=s??v.defaultToKey}set(s,o){return this.map.set(this.toKey(s),new A(s,o)),this}get(s){var o;return(o=this.map.get(this.toKey(s)))===null||o===void 0?void 0:o.value}has(s){return this.map.has(this.toKey(s))}get size(){return this.map.size}clear(){this.map.clear()}delete(s){return this.map.delete(this.toKey(s))}forEach(s,o){typeof o<"u"&&(s=s.bind(o));for(const[u,b]of this.map)s(b.value,b.uri,this)}*values(){for(const s of this.map.values())yield s.value}*keys(){for(const s of this.map.values())yield s.uri}*entries(){for(const s of this.map.values())yield[s.uri,s.value]}*[(r=Symbol.toStringTag,Symbol.iterator)](){for(const[,s]of this.map)yield[s.uri,s.value]}}n.ResourceMap=v,v.defaultToKey=e=>e.toString();class p{constructor(){this[M]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){var s;return(s=this._head)===null||s===void 0?void 0:s.value}get last(){var s;return(s=this._tail)===null||s===void 0?void 0:s.value}has(s){return this._map.has(s)}get(s,o=0){const u=this._map.get(s);if(u)return o!==0&&this.touch(u,o),u.value}set(s,o,u=0){let b=this._map.get(s);if(b)b.value=o,u!==0&&this.touch(b,u);else{switch(b={key:s,value:o,next:void 0,previous:void 0},u){case 0:this.addItemLast(b);break;case 1:this.addItemFirst(b);break;case 2:this.addItemLast(b);break;default:this.addItemLast(b);break}this._map.set(s,b),this._size++}return this}delete(s){return!!this.remove(s)}remove(s){const o=this._map.get(s);if(o)return this._map.delete(s),this.removeItem(o),this._size--,o.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const s=this._head;return this._map.delete(s.key),this.removeItem(s),this._size--,s.value}forEach(s,o){const u=this._state;let b=this._head;for(;b;){if(o?s.bind(o)(b.value,b.key,this):s(b.value,b.key,this),this._state!==u)throw new Error("LinkedMap got modified during iteration.");b=b.next}}keys(){const s=this,o=this._state;let u=this._head;const b={[Symbol.iterator](){return b},next(){if(s._state!==o)throw new Error("LinkedMap got modified during iteration.");if(u){const d={value:u.key,done:!1};return u=u.next,d}else return{value:void 0,done:!0}}};return b}values(){const s=this,o=this._state;let u=this._head;const b={[Symbol.iterator](){return b},next(){if(s._state!==o)throw new Error("LinkedMap got modified during iteration.");if(u){const d={value:u.value,done:!1};return u=u.next,d}else return{value:void 0,done:!0}}};return b}entries(){const s=this,o=this._state;let u=this._head;const b={[Symbol.iterator](){return b},next(){if(s._state!==o)throw new Error("LinkedMap got modified during iteration.");if(u){const d={value:[u.key,u.value],done:!1};return u=u.next,d}else return{value:void 0,done:!0}}};return b}[(M=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(s){if(s>=this.size)return;if(s===0){this.clear();return}let o=this._head,u=this.size;for(;o&&u>s;)this._map.delete(o.key),o=o.next,u--;this._head=o,this._size=u,o&&(o.previous=void 0),this._state++}addItemFirst(s){if(!this._head&&!this._tail)this._tail=s;else if(this._head)s.next=this._head,this._head.previous=s;else throw new Error("Invalid list");this._head=s,this._state++}addItemLast(s){if(!this._head&&!this._tail)this._head=s;else if(this._tail)s.previous=this._tail,this._tail.next=s;else throw new Error("Invalid list");this._tail=s,this._state++}removeItem(s){if(s===this._head&&s===this._tail)this._head=void 0,this._tail=void 0;else if(s===this._head){if(!s.next)throw new Error("Invalid list");s.next.previous=void 0,this._head=s.next}else if(s===this._tail){if(!s.previous)throw new Error("Invalid list");s.previous.next=void 0,this._tail=s.previous}else{const o=s.next,u=s.previous;if(!o||!u)throw new Error("Invalid list");o.previous=u,u.next=o}s.next=void 0,s.previous=void 0,this._state++}touch(s,o){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(o!==1&&o!==2)){if(o===1){if(s===this._head)return;const u=s.next,b=s.previous;s===this._tail?(b.next=void 0,this._tail=b):(u.previous=b,b.next=u),s.previous=void 0,s.next=this._head,this._head.previous=s,this._head=s,this._state++}else if(o===2){if(s===this._tail)return;const u=s.next,b=s.previous;s===this._head?(u.previous=void 0,this._head=u):(u.previous=b,b.next=u),s.next=void 0,s.previous=this._tail,this._tail.next=s,this._tail=s,this._state++}}}toJSON(){const s=[];return this.forEach((o,u)=>{s.push([u,o])}),s}fromJSON(s){this.clear();for(const[o,u]of s)this.set(o,u)}}n.LinkedMap=p;class h extends p{constructor(s,o=1){super(),this._limit=s,this._ratio=Math.min(Math.max(0,o),1)}get limit(){return this._limit}set limit(s){this._limit=s,this.checkTrim()}get(s,o=2){return super.get(s,o)}peek(s){return super.get(s,0)}set(s,o){return super.set(s,o,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}n.LRUCache=h;class l{constructor(s){if(this._m1=new Map,this._m2=new Map,s)for(const[o,u]of s)this.set(o,u)}clear(){this._m1.clear(),this._m2.clear()}set(s,o){this._m1.set(s,o),this._m2.set(o,s)}get(s){return this._m1.get(s)}getKey(s){return this._m2.get(s)}delete(s){const o=this._m1.get(s);return o===void 0?!1:(this._m1.delete(s),this._m2.delete(o),!0)}keys(){return this._m1.keys()}values(){return this._m1.values()}}n.BidirectionalMap=l;class w{constructor(){this.map=new Map}add(s,o){let u=this.map.get(s);u||(u=new Set,this.map.set(s,u)),u.add(o)}delete(s,o){const u=this.map.get(s);u&&(u.delete(o),u.size===0&&this.map.delete(s))}forEach(s,o){const u=this.map.get(s);u&&u.forEach(o)}get(s){const o=this.map.get(s);return o||new Set}}n.SetMap=w}),X(Z[23],K([0,1]),function(q,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.StopWatch=void 0;const r=globalThis.performance&&typeof globalThis.performance.now=="function";class M{static create(g){return new M(g)}constructor(g){this._now=r&&g===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this._startTime=this._now(),this._stopTime=-1}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}}n.StopWatch=M}),X(Z[9],K([0,1,5,20,13,22,23]),function(q,n,r,M,A,g,v){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.Relay=n.EventBufferer=n.EventMultiplexer=n.MicrotaskEmitter=n.DebounceEmitter=n.PauseableEmitter=n.createEventDeliveryQueue=n.Emitter=n.EventProfiling=n.Event=void 0;const p=!1,h=!1;var l;(function(c){c.None=()=>A.Disposable.None;function f(ee){if(h){const{onDidAddListener:G}=ee,Y=o.create();let J=0;ee.onDidAddListener=()=>{++J===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),Y.print()),G?.()}}}function R(ee,G){return F(ee,()=>{},0,void 0,!0,void 0,G)}c.defer=R;function E(ee){return(G,Y=null,J)=>{let re=!1,ne;return ne=ee(se=>{if(!re)return ne?ne.dispose():re=!0,G.call(Y,se)},null,J),re&&ne.dispose(),ne}}c.once=E;function x(ee,G,Y){return $((J,re=null,ne)=>ee(se=>J.call(re,G(se)),null,ne),Y)}c.map=x;function D(ee,G,Y){return $((J,re=null,ne)=>ee(se=>{G(se),J.call(re,se)},null,ne),Y)}c.forEach=D;function T(ee,G,Y){return $((J,re=null,ne)=>ee(se=>G(se)&&J.call(re,se),null,ne),Y)}c.filter=T;function k(ee){return ee}c.signal=k;function W(...ee){return(G,Y=null,J)=>{const re=(0,A.combinedDisposable)(...ee.map(ne=>ne(se=>G.call(Y,se))));return I(re,J)}}c.any=W;function j(ee,G,Y,J){let re=Y;return x(ee,ne=>(re=G(re,ne),re),J)}c.reduce=j;function $(ee,G){let Y;const J={onWillAddFirstListener(){Y=ee(re.fire,re)},onDidRemoveLastListener(){Y?.dispose()}};G||f(J);const re=new y(J);return G?.add(re),re.event}function I(ee,G){return G instanceof Array?G.push(ee):G&&G.add(ee),ee}function F(ee,G,Y=100,J=!1,re=!1,ne,se){let le,ue,P,B=0,z;const Q={leakWarningThreshold:ne,onWillAddFirstListener(){le=ee(ae=>{B++,ue=G(ue,ae),J&&!P&&(te.fire(ue),ue=void 0),z=()=>{const ce=ue;ue=void 0,P=void 0,(!J||B>1)&&te.fire(ce),B=0},typeof Y=="number"?(clearTimeout(P),P=setTimeout(z,Y)):P===void 0&&(P=0,queueMicrotask(z))})},onWillRemoveListener(){re&&B>0&&z?.()},onDidRemoveLastListener(){z=void 0,le.dispose()}};se||f(Q);const te=new y(Q);return se?.add(te),te.event}c.debounce=F;function O(ee,G=0,Y){return c.debounce(ee,(J,re)=>J?(J.push(re),J):[re],G,void 0,!0,void 0,Y)}c.accumulate=O;function V(ee,G=(J,re)=>J===re,Y){let J=!0,re;return T(ee,ne=>{const se=J||!G(ne,re);return J=!1,re=ne,se},Y)}c.latch=V;function H(ee,G,Y){return[c.filter(ee,G,Y),c.filter(ee,J=>!G(J),Y)]}c.split=H;function U(ee,G=!1,Y=[],J){let re=Y.slice(),ne=ee(ue=>{re?re.push(ue):le.fire(ue)});J&&J.add(ne);const se=()=>{re?.forEach(ue=>le.fire(ue)),re=null},le=new y({onWillAddFirstListener(){ne||(ne=ee(ue=>le.fire(ue)),J&&J.add(ne))},onDidAddFirstListener(){re&&(G?setTimeout(se):se())},onDidRemoveLastListener(){ne&&ne.dispose(),ne=null}});return J&&J.add(le),le.event}c.buffer=U;function ie(ee,G){return(J,re,ne)=>{const se=G(new t);return ee(function(le){const ue=se.evaluate(le);ue!==oe&&J.call(re,ue)},void 0,ne)}}c.chain=ie;const oe=Symbol("HaltChainable");class t{constructor(){this.steps=[]}map(G){return this.steps.push(G),this}forEach(G){return this.steps.push(Y=>(G(Y),Y)),this}filter(G){return this.steps.push(Y=>G(Y)?Y:oe),this}reduce(G,Y){let J=Y;return this.steps.push(re=>(J=G(J,re),J)),this}latch(G=(Y,J)=>Y===J){let Y=!0,J;return this.steps.push(re=>{const ne=Y||!G(re,J);return Y=!1,J=re,ne?re:oe}),this}evaluate(G){for(const Y of this.steps)if(G=Y(G),G===oe)break;return G}}function Le(ee,G,Y=J=>J){const J=(...le)=>se.fire(Y(...le)),re=()=>ee.on(G,J),ne=()=>ee.removeListener(G,J),se=new y({onWillAddFirstListener:re,onDidRemoveLastListener:ne});return se.event}c.fromNodeEventEmitter=Le;function we(ee,G,Y=J=>J){const J=(...le)=>se.fire(Y(...le)),re=()=>ee.addEventListener(G,J),ne=()=>ee.removeEventListener(G,J),se=new y({onWillAddFirstListener:re,onDidRemoveLastListener:ne});return se.event}c.fromDOMEventEmitter=we;function _e(ee){return new Promise(G=>E(ee)(G))}c.toPromise=_e;function Ce(ee){const G=new y;return ee.then(Y=>{G.fire(Y)},()=>{G.fire(void 0)}).finally(()=>{G.dispose()}),G.event}c.fromPromise=Ce;function Se(ee,G,Y){return G(Y),ee(J=>G(J))}c.runAndSubscribe=Se;class ve{constructor(G,Y){this._observable=G,this._counter=0,this._hasChanged=!1;const J={onWillAddFirstListener:()=>{G.addObserver(this)},onDidRemoveLastListener:()=>{G.removeObserver(this)}};Y||f(J),this.emitter=new y(J),Y&&Y.add(this.emitter)}beginUpdate(G){this._counter++}handlePossibleChange(G){}handleChange(G,Y){this._hasChanged=!0}endUpdate(G){this._counter--,this._counter===0&&(this._observable.reportChanges(),this._hasChanged&&(this._hasChanged=!1,this.emitter.fire(this._observable.get())))}}function ye(ee,G){return new ve(ee,G).emitter.event}c.fromObservable=ye;function Ne(ee){return(G,Y,J)=>{let re=0,ne=!1;const se={beginUpdate(){re++},endUpdate(){re--,re===0&&(ee.reportChanges(),ne&&(ne=!1,G.call(Y)))},handlePossibleChange(){},handleChange(){ne=!0}};ee.addObserver(se),ee.reportChanges();const le={dispose(){ee.removeObserver(se)}};return J instanceof A.DisposableStore?J.add(le):Array.isArray(J)&&J.push(le),le}}c.fromObservableLight=Ne})(l||(n.Event=l={}));class w{constructor(f){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${f}_${w._idPool++}`,w.all.add(this)}start(f){this._stopWatch=new v.StopWatch,this.listenerCount=f}stop(){if(this._stopWatch){const f=this._stopWatch.elapsed();this.durations.push(f),this.elapsedOverall+=f,this.invocationCount+=1,this._stopWatch=void 0}}}n.EventProfiling=w,w.all=new Set,w._idPool=0;let e=-1;class s{constructor(f,R=Math.random().toString(18).slice(2,5)){this.threshold=f,this.name=R,this._warnCountdown=0}dispose(){var f;(f=this._stacks)===null||f===void 0||f.clear()}check(f,R){const E=this.threshold;if(E<=0||R<E)return;this._stacks||(this._stacks=new Map);const x=this._stacks.get(f.value)||0;if(this._stacks.set(f.value,x+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=E*.5;let D,T=0;for(const[k,W]of this._stacks)(!D||T<W)&&(D=k,T=W);console.warn(`[${this.name}] potential listener LEAK detected, having ${R} listeners already. MOST frequent listener (${T}):`),console.warn(D)}return()=>{const D=this._stacks.get(f.value)||0;this._stacks.set(f.value,D-1)}}}class o{static create(){var f;return new o((f=new Error().stack)!==null&&f!==void 0?f:"")}constructor(f){this.value=f}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class u{constructor(f){this.value=f}}const b=2,d=(c,f)=>{if(c instanceof u)f(c);else for(let R=0;R<c.length;R++){const E=c[R];E&&f(E)}};class y{constructor(f){var R,E,x,D,T;this._size=0,this._options=f,this._leakageMon=e>0||!((R=this._options)===null||R===void 0)&&R.leakWarningThreshold?new s((x=(E=this._options)===null||E===void 0?void 0:E.leakWarningThreshold)!==null&&x!==void 0?x:e):void 0,this._perfMon=!((D=this._options)===null||D===void 0)&&D._profName?new w(this._options._profName):void 0,this._deliveryQueue=(T=this._options)===null||T===void 0?void 0:T.deliveryQueue}dispose(){var f,R,E,x;if(!this._disposed){if(this._disposed=!0,((f=this._deliveryQueue)===null||f===void 0?void 0:f.current)===this&&this._deliveryQueue.reset(),this._listeners){if(p){const D=this._listeners;queueMicrotask(()=>{d(D,T=>{var k;return(k=T.stack)===null||k===void 0?void 0:k.print()})})}this._listeners=void 0,this._size=0}(E=(R=this._options)===null||R===void 0?void 0:R.onDidRemoveLastListener)===null||E===void 0||E.call(R),(x=this._leakageMon)===null||x===void 0||x.dispose()}}get event(){var f;return(f=this._event)!==null&&f!==void 0||(this._event=(R,E,x)=>{var D,T,k,W,j;if(this._leakageMon&&this._size>this._leakageMon.threshold*3)return console.warn(`[${this._leakageMon.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),A.Disposable.None;if(this._disposed)return A.Disposable.None;E&&(R=R.bind(E));const $=new u(R);let I,F;this._leakageMon&&this._size>=Math.ceil(this._leakageMon.threshold*.2)&&($.stack=o.create(),I=this._leakageMon.check($.stack,this._size+1)),p&&($.stack=F??o.create()),this._listeners?this._listeners instanceof u?((j=this._deliveryQueue)!==null&&j!==void 0||(this._deliveryQueue=new N),this._listeners=[this._listeners,$]):this._listeners.push($):((T=(D=this._options)===null||D===void 0?void 0:D.onWillAddFirstListener)===null||T===void 0||T.call(D,this),this._listeners=$,(W=(k=this._options)===null||k===void 0?void 0:k.onDidAddFirstListener)===null||W===void 0||W.call(k,this)),this._size++;const O=(0,A.toDisposable)(()=>{I?.(),this._removeListener($)});return x instanceof A.DisposableStore?x.add(O):Array.isArray(x)&&x.push(O),O}),this._event}_removeListener(f){var R,E,x,D;if((E=(R=this._options)===null||R===void 0?void 0:R.onWillRemoveListener)===null||E===void 0||E.call(R,this),!this._listeners)return;if(this._size===1){this._listeners=void 0,(D=(x=this._options)===null||x===void 0?void 0:x.onDidRemoveLastListener)===null||D===void 0||D.call(x,this),this._size=0;return}const T=this._listeners,k=T.indexOf(f);if(k===-1)throw console.log("disposed?",this._disposed),console.log("size?",this._size),console.log("arr?",JSON.stringify(this._listeners)),new Error("Attempted to dispose unknown listener");this._size--,T[k]=void 0;const W=this._deliveryQueue.current===this;if(this._size*b<=T.length){let j=0;for(let $=0;$<T.length;$++)T[$]?T[j++]=T[$]:W&&(this._deliveryQueue.end--,j<this._deliveryQueue.i&&this._deliveryQueue.i--);T.length=j}}_deliver(f,R){var E;if(!f)return;const x=((E=this._options)===null||E===void 0?void 0:E.onListenerError)||r.onUnexpectedError;if(!x){f.value(R);return}try{f.value(R)}catch(D){x(D)}}_deliverQueue(f){const R=f.current._listeners;for(;f.i<f.end;)this._deliver(R[f.i++],f.value);f.reset()}fire(f){var R,E,x,D;if(!((R=this._deliveryQueue)===null||R===void 0)&&R.current&&(this._deliverQueue(this._deliveryQueue),(E=this._perfMon)===null||E===void 0||E.stop()),(x=this._perfMon)===null||x===void 0||x.start(this._size),this._listeners)if(this._listeners instanceof u)this._deliver(this._listeners,f);else{const T=this._deliveryQueue;T.enqueue(this,f,this._listeners.length),this._deliverQueue(T)}(D=this._perfMon)===null||D===void 0||D.stop()}hasListeners(){return this._size>0}}n.Emitter=y;const _=()=>new N;n.createEventDeliveryQueue=_;class N{constructor(){this.i=-1,this.end=0}enqueue(f,R,E){this.i=0,this.end=E,this.current=f,this.value=R}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class S extends y{constructor(f){super(f),this._isPaused=0,this._eventQueue=new g.LinkedList,this._mergeFn=f?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused===0)if(this._mergeFn){if(this._eventQueue.size>0){const f=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(f))}}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(f){this._size&&(this._isPaused!==0?this._eventQueue.push(f):super.fire(f))}}n.PauseableEmitter=S;class C extends S{constructor(f){var R;super(f),this._delay=(R=f.delay)!==null&&R!==void 0?R:100}fire(f){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(f)}}n.DebounceEmitter=C;class i extends y{constructor(f){super(f),this._queuedEvents=[],this._mergeFn=f?.merge}fire(f){this.hasListeners()&&(this._queuedEvents.push(f),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(R=>super.fire(R)),this._queuedEvents=[]}))}}n.MicrotaskEmitter=i;class a{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new y({onWillAddFirstListener:()=>this.onFirstListenerAdd(),onDidRemoveLastListener:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(f){const R={event:f,listener:null};this.events.push(R),this.hasListeners&&this.hook(R);const E=()=>{this.hasListeners&&this.unhook(R);const x=this.events.indexOf(R);this.events.splice(x,1)};return(0,A.toDisposable)((0,M.createSingleCallFunction)(E))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(f=>this.hook(f))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(f=>this.unhook(f))}hook(f){f.listener=f.event(R=>this.emitter.fire(R))}unhook(f){var R;(R=f.listener)===null||R===void 0||R.dispose(),f.listener=null}dispose(){var f;this.emitter.dispose();for(const R of this.events)(f=R.listener)===null||f===void 0||f.dispose();this.events=[]}}n.EventMultiplexer=a;class m{constructor(){this.buffers=[]}wrapEvent(f){return(R,E,x)=>f(D=>{const T=this.buffers[this.buffers.length-1];T?T.push(()=>R.call(E,D)):R.call(E,D)},void 0,x)}bufferEvents(f){const R=[];this.buffers.push(R);const E=f();return this.buffers.pop(),R.forEach(x=>x()),E}}n.EventBufferer=m;class L{constructor(){this.listening=!1,this.inputEvent=l.None,this.inputEventListener=A.Disposable.None,this.emitter=new y({onDidAddFirstListener:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onDidRemoveLastListener:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(f){this.inputEvent=f,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=f(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}n.Relay=L}),X(Z[39],K([0,1,9]),function(q,n,r){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.CancellationTokenSource=n.CancellationToken=void 0;const M=Object.freeze(function(p,h){const l=setTimeout(p.bind(h),0);return{dispose(){clearTimeout(l)}}});var A;(function(p){function h(l){return l===p.None||l===p.Cancelled||l instanceof g?!0:!l||typeof l!="object"?!1:typeof l.isCancellationRequested=="boolean"&&typeof l.onCancellationRequested=="function"}p.isCancellationToken=h,p.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:r.Event.None}),p.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:M})})(A||(n.CancellationToken=A={}));class g{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?M:(this._emitter||(this._emitter=new r.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class v{constructor(h){this._token=void 0,this._parentListener=void 0,this._parentListener=h&&h.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new g),this._token}cancel(){this._token?this._token instanceof g&&this._token.cancel():this._token=A.Cancelled}dispose(h=!1){var l;h&&this.cancel(),(l=this._parentListener)===null||l===void 0||l.dispose(),this._token?this._token instanceof g&&this._token.dispose():this._token=A.None}}n.CancellationTokenSource=v}),X(Z[6],K([0,1,33,37]),function(q,n,r,M){"use strict";var A;Object.defineProperty(n,"__esModule",{value:!0}),n.InvisibleCharacters=n.AmbiguousCharacters=n.noBreakWhitespace=n.UTF8_BOM_CHARACTER=n.UNUSUAL_LINE_TERMINATORS=n.GraphemeIterator=n.CodePointIterator=void 0,n.isFalsyOrWhitespace=g,n.format=p,n.htmlAttributeEncodeValue=h,n.escape=l,n.escapeRegExpCharacters=w,n.trim=e,n.ltrim=s,n.rtrim=o,n.convertSimple2RegExpPattern=u,n.stripWildcards=b,n.createRegExp=d,n.regExpLeadsToEndlessLoop=y,n.splitLines=_,n.splitLinesIncludeSeparators=N,n.firstNonWhitespaceIndex=S,n.getLeadingWhitespace=C,n.lastNonWhitespaceIndex=i,n.compare=a,n.compareSubstring=m,n.compareIgnoreCase=L,n.compareSubstringIgnoreCase=c,n.isAsciiDigit=f,n.isLowerAsciiLetter=R,n.isUpperAsciiLetter=E,n.equalsIgnoreCase=x,n.startsWithIgnoreCase=D,n.commonPrefixLength=T,n.commonSuffixLength=k,n.isHighSurrogate=W,n.isLowSurrogate=j,n.computeCodePoint=$,n.getNextCodePoint=I,n.nextCharLength=H,n.prevCharLength=U,n.getCharContainingOffset=ie,n.containsRTL=Le,n.isBasicASCII=_e,n.containsUnusualLineTerminators=Ce,n.isFullWidthCharacter=Se,n.isEmojiImprecise=ve,n.startsWithUTF8BOM=ye,n.containsUppercaseCharacter=Ne,n.singleLetterHash=ee,n.getLeftDeleteOffset=re;function g(P){return!P||typeof P!="string"?!0:P.trim().length===0}const v=/{(\d+)}/g;function p(P,...B){return B.length===0?P:P.replace(v,function(z,Q){const te=parseInt(Q,10);return isNaN(te)||te<0||te>=B.length?z:B[te]})}function h(P){return P.replace(/[<>"'&]/g,B=>{switch(B){case"<":return"&lt;";case">":return"&gt;";case'"':return"&quot;";case"'":return"&apos;";case"&":return"&amp;"}return B})}function l(P){return P.replace(/[<>&]/g,function(B){switch(B){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return B}})}function w(P){return P.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}function e(P,B=" "){const z=s(P,B);return o(z,B)}function s(P,B){if(!P||!B)return P;const z=B.length;if(z===0||P.length===0)return P;let Q=0;for(;P.indexOf(B,Q)===Q;)Q=Q+z;return P.substring(Q)}function o(P,B){if(!P||!B)return P;const z=B.length,Q=P.length;if(z===0||Q===0)return P;let te=Q,ae=-1;for(;ae=P.lastIndexOf(B,te-1),!(ae===-1||ae+z!==te);){if(ae===0)return"";te=ae}return P.substring(0,te)}function u(P){return P.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}function b(P){return P.replace(/\*/g,"")}function d(P,B,z={}){if(!P)throw new Error("Cannot create regex from empty string");B||(P=w(P)),z.wholeWord&&(/\B/.test(P.charAt(0))||(P="\\b"+P),/\B/.test(P.charAt(P.length-1))||(P=P+"\\b"));let Q="";return z.global&&(Q+="g"),z.matchCase||(Q+="i"),z.multiline&&(Q+="m"),z.unicode&&(Q+="u"),new RegExp(P,Q)}function y(P){return P.source==="^"||P.source==="^$"||P.source==="$"||P.source==="^\\s*$"?!1:!!(P.exec("")&&P.lastIndex===0)}function _(P){return P.split(/\r\n|\r|\n/)}function N(P){var B;const z=[],Q=P.split(/(\r\n|\r|\n)/);for(let te=0;te<Math.ceil(Q.length/2);te++)z.push(Q[2*te]+((B=Q[2*te+1])!==null&&B!==void 0?B:""));return z}function S(P){for(let B=0,z=P.length;B<z;B++){const Q=P.charCodeAt(B);if(Q!==32&&Q!==9)return B}return-1}function C(P,B=0,z=P.length){for(let Q=B;Q<z;Q++){const te=P.charCodeAt(Q);if(te!==32&&te!==9)return P.substring(B,Q)}return P.substring(B,z)}function i(P,B=P.length-1){for(let z=B;z>=0;z--){const Q=P.charCodeAt(z);if(Q!==32&&Q!==9)return z}return-1}function a(P,B){return P<B?-1:P>B?1:0}function m(P,B,z=0,Q=P.length,te=0,ae=B.length){for(;z<Q&&te<ae;z++,te++){const ge=P.charCodeAt(z),he=B.charCodeAt(te);if(ge<he)return-1;if(ge>he)return 1}const ce=Q-z,be=ae-te;return ce<be?-1:ce>be?1:0}function L(P,B){return c(P,B,0,P.length,0,B.length)}function c(P,B,z=0,Q=P.length,te=0,ae=B.length){for(;z<Q&&te<ae;z++,te++){let ge=P.charCodeAt(z),he=B.charCodeAt(te);if(ge===he)continue;if(ge>=128||he>=128)return m(P.toLowerCase(),B.toLowerCase(),z,Q,te,ae);R(ge)&&(ge-=32),R(he)&&(he-=32);const de=ge-he;if(de!==0)return de}const ce=Q-z,be=ae-te;return ce<be?-1:ce>be?1:0}function f(P){return P>=48&&P<=57}function R(P){return P>=97&&P<=122}function E(P){return P>=65&&P<=90}function x(P,B){return P.length===B.length&&c(P,B)===0}function D(P,B){const z=B.length;return B.length>P.length?!1:c(P,B,0,z)===0}function T(P,B){const z=Math.min(P.length,B.length);let Q;for(Q=0;Q<z;Q++)if(P.charCodeAt(Q)!==B.charCodeAt(Q))return Q;return z}function k(P,B){const z=Math.min(P.length,B.length);let Q;const te=P.length-1,ae=B.length-1;for(Q=0;Q<z;Q++)if(P.charCodeAt(te-Q)!==B.charCodeAt(ae-Q))return Q;return z}function W(P){return 55296<=P&&P<=56319}function j(P){return 56320<=P&&P<=57343}function $(P,B){return(P-55296<<10)+(B-56320)+65536}function I(P,B,z){const Q=P.charCodeAt(z);if(W(Q)&&z+1<B){const te=P.charCodeAt(z+1);if(j(te))return $(Q,te)}return Q}function F(P,B){const z=P.charCodeAt(B-1);if(j(z)&&B>1){const Q=P.charCodeAt(B-2);if(W(Q))return $(Q,z)}return z}class O{get offset(){return this._offset}constructor(B,z=0){this._str=B,this._len=B.length,this._offset=z}setOffset(B){this._offset=B}prevCodePoint(){const B=F(this._str,this._offset);return this._offset-=B>=65536?2:1,B}nextCodePoint(){const B=I(this._str,this._len,this._offset);return this._offset+=B>=65536?2:1,B}eol(){return this._offset>=this._len}}n.CodePointIterator=O;class V{get offset(){return this._iterator.offset}constructor(B,z=0){this._iterator=new O(B,z)}nextGraphemeLength(){const B=Y.getInstance(),z=this._iterator,Q=z.offset;let te=B.getGraphemeBreakType(z.nextCodePoint());for(;!z.eol();){const ae=z.offset,ce=B.getGraphemeBreakType(z.nextCodePoint());if(G(te,ce)){z.setOffset(ae);break}te=ce}return z.offset-Q}prevGraphemeLength(){const B=Y.getInstance(),z=this._iterator,Q=z.offset;let te=B.getGraphemeBreakType(z.prevCodePoint());for(;z.offset>0;){const ae=z.offset,ce=B.getGraphemeBreakType(z.prevCodePoint());if(G(ce,te)){z.setOffset(ae);break}te=ce}return Q-z.offset}eol(){return this._iterator.eol()}}n.GraphemeIterator=V;function H(P,B){return new V(P,B).nextGraphemeLength()}function U(P,B){return new V(P,B).prevGraphemeLength()}function ie(P,B){B>0&&j(P.charCodeAt(B))&&B--;const z=B+H(P,B);return[z-U(P,z),z]}let oe;function t(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function Le(P){return oe||(oe=t()),oe.test(P)}const we=/^[\t\n\r\x20-\x7E]*$/;function _e(P){return we.test(P)}n.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function Ce(P){return n.UNUSUAL_LINE_TERMINATORS.test(P)}function Se(P){return P>=11904&&P<=55215||P>=63744&&P<=64255||P>=65281&&P<=65374}function ve(P){return P>=127462&&P<=127487||P===8986||P===8987||P===9200||P===9203||P>=9728&&P<=10175||P===11088||P===11093||P>=127744&&P<=128591||P>=128640&&P<=128764||P>=128992&&P<=129008||P>=129280&&P<=129535||P>=129648&&P<=129782}n.UTF8_BOM_CHARACTER="\uFEFF";function ye(P){return!!(P&&P.length>0&&P.charCodeAt(0)===65279)}function Ne(P,B=!1){return P?(B&&(P=P.replace(/\\./g,"")),P.toLowerCase()!==P):!1}function ee(P){return P=P%(2*26),P<26?String.fromCharCode(97+P):String.fromCharCode(65+P-26)}function G(P,B){return P===0?B!==5&&B!==7:P===2&&B===3?!1:P===4||P===2||P===3||B===4||B===2||B===3?!0:!(P===8&&(B===8||B===9||B===11||B===12)||(P===11||P===9)&&(B===9||B===10)||(P===12||P===10)&&B===10||B===5||B===13||B===7||P===1||P===13&&B===14||P===6&&B===6)}class Y{static getInstance(){return Y._INSTANCE||(Y._INSTANCE=new Y),Y._INSTANCE}constructor(){this._data=J()}getGraphemeBreakType(B){if(B<32)return B===10?3:B===13?2:4;if(B<127)return 0;const z=this._data,Q=z.length/3;let te=1;for(;te<=Q;)if(B<z[3*te])te=2*te;else if(B>z[3*te+1])te=2*te+1;else return z[3*te+2];return 0}}Y._INSTANCE=null;function J(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function re(P,B){if(P===0)return 0;const z=ne(P,B);if(z!==void 0)return z;const Q=new O(B,P);return Q.prevCodePoint(),Q.offset}function ne(P,B){const z=new O(B,P);let Q=z.prevCodePoint();for(;se(Q)||Q===65039||Q===8419;){if(z.offset===0)return;Q=z.prevCodePoint()}if(!ve(Q))return;let te=z.offset;return te>0&&z.prevCodePoint()===8205&&(te=z.offset),te}function se(P){return 127995<=P&&P<=127999}n.noBreakWhitespace="\xA0";class le{static getInstance(B){return A.cache.get(Array.from(B))}static getLocales(){return A._locales.value}constructor(B){this.confusableDictionary=B}isAmbiguous(B){return this.confusableDictionary.has(B)}getPrimaryConfusable(B){return this.confusableDictionary.get(B)}getConfusableCodePoints(){return new Set(this.confusableDictionary.keys())}}n.AmbiguousCharacters=le,A=le,le.ambiguousCharacterData=new M.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),le.cache=new r.LRUCachedFunction(P=>{function B(he){const de=new Map;for(let me=0;me<he.length;me+=2)de.set(he[me],he[me+1]);return de}function z(he,de){const me=new Map(he);for(const[pe,Ee]of de)me.set(pe,Ee);return me}function Q(he,de){if(!he)return de;const me=new Map;for(const[pe,Ee]of he)de.has(pe)&&me.set(pe,Ee);return me}const te=A.ambiguousCharacterData.value;let ae=P.filter(he=>!he.startsWith("_")&&he in te);ae.length===0&&(ae=["_default"]);let ce;for(const he of ae){const de=B(te[he]);ce=Q(ce,de)}const be=B(te._common),ge=z(be,ce);return new A(ge)}),le._locales=new M.Lazy(()=>Object.keys(A.ambiguousCharacterData.value).filter(P=>!P.startsWith("_")));class ue{static getRawData(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static getData(){return this._data||(this._data=new Set(ue.getRawData())),this._data}static isInvisibleCharacter(B){return ue.getData().has(B)}static get codePoints(){return ue.getData()}}n.InvisibleCharacters=ue,ue._data=void 0}),X(Z[40],K([0,1,6]),function(q,n,r){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.StringSHA1=void 0,n.hash=M,n.doHash=A,n.numberHash=g,n.stringHash=p,n.toHexString=o;function M(b){return A(b,0)}function A(b,d){switch(typeof b){case"object":return b===null?g(349,d):Array.isArray(b)?h(b,d):l(b,d);case"string":return p(b,d);case"boolean":return v(b,d);case"number":return g(b,d);case"undefined":return g(937,d);default:return g(617,d)}}function g(b,d){return(d<<5)-d+b|0}function v(b,d){return g(b?433:863,d)}function p(b,d){d=g(149417,d);for(let y=0,_=b.length;y<_;y++)d=g(b.charCodeAt(y),d);return d}function h(b,d){return d=g(104579,d),b.reduce((y,_)=>A(_,y),d)}function l(b,d){return d=g(181387,d),Object.keys(b).sort().reduce((y,_)=>(y=p(_,y),A(b[_],y)),d)}function w(b,d,y=32){const _=y-d,N=~((1<<_)-1);return(b<<d|(N&b)>>>_)>>>0}function e(b,d=0,y=b.byteLength,_=0){for(let N=0;N<y;N++)b[d+N]=_}function s(b,d,y="0"){for(;b.length<d;)b=y+b;return b}function o(b,d=32){return b instanceof ArrayBuffer?Array.from(new Uint8Array(b)).map(y=>y.toString(16).padStart(2,"0")).join(""):s((b>>>0).toString(16),d/4)}class u{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(67),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(d){const y=d.length;if(y===0)return;const _=this._buff;let N=this._buffLen,S=this._leftoverHighSurrogate,C,i;for(S!==0?(C=S,i=-1,S=0):(C=d.charCodeAt(0),i=0);;){let a=C;if(r.isHighSurrogate(C))if(i+1<y){const m=d.charCodeAt(i+1);r.isLowSurrogate(m)?(i++,a=r.computeCodePoint(C,m)):a=65533}else{S=C;break}else r.isLowSurrogate(C)&&(a=65533);if(N=this._push(_,N,a),i++,i<y)C=d.charCodeAt(i);else break}this._buffLen=N,this._leftoverHighSurrogate=S}_push(d,y,_){return _<128?d[y++]=_:_<2048?(d[y++]=192|(_&1984)>>>6,d[y++]=128|(_&63)>>>0):_<65536?(d[y++]=224|(_&61440)>>>12,d[y++]=128|(_&4032)>>>6,d[y++]=128|(_&63)>>>0):(d[y++]=240|(_&1835008)>>>18,d[y++]=128|(_&258048)>>>12,d[y++]=128|(_&4032)>>>6,d[y++]=128|(_&63)>>>0),y>=64&&(this._step(),y-=64,this._totalLen+=64,d[0]=d[64],d[1]=d[65],d[2]=d[66]),y}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),o(this._h0)+o(this._h1)+o(this._h2)+o(this._h3)+o(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,e(this._buff,this._buffLen),this._buffLen>56&&(this._step(),e(this._buff));const d=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(d/4294967296),!1),this._buffDV.setUint32(60,d%4294967296,!1),this._step()}_step(){const d=u._bigBlock32,y=this._buffDV;for(let c=0;c<64;c+=4)d.setUint32(c,y.getUint32(c,!1),!1);for(let c=64;c<320;c+=4)d.setUint32(c,w(d.getUint32(c-12,!1)^d.getUint32(c-32,!1)^d.getUint32(c-56,!1)^d.getUint32(c-64,!1),1),!1);let _=this._h0,N=this._h1,S=this._h2,C=this._h3,i=this._h4,a,m,L;for(let c=0;c<80;c++)c<20?(a=N&S|~N&C,m=1518500249):c<40?(a=N^S^C,m=1859775393):c<60?(a=N&S|N&C|S&C,m=2400959708):(a=N^S^C,m=3395469782),L=w(_,5)+a+i+m+d.getUint32(c*4,!1)&4294967295,i=C,C=S,S=w(N,30),N=_,_=L;this._h0=this._h0+_&4294967295,this._h1=this._h1+N&4294967295,this._h2=this._h2+S&4294967295,this._h3=this._h3+C&4294967295,this._h4=this._h4+i&4294967295}}n.StringSHA1=u,u._bigBlock32=new DataView(new ArrayBuffer(320))}),X(Z[24],K([0,1,35,40]),function(q,n,r,M){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.LcsDiff=n.StringDiffSequence=void 0,n.stringDiff=g;class A{constructor(e){this.source=e}getElements(){const e=this.source,s=new Int32Array(e.length);for(let o=0,u=e.length;o<u;o++)s[o]=e.charCodeAt(o);return s}}n.StringDiffSequence=A;function g(w,e,s){return new l(new A(w),new A(e)).ComputeDiff(s).changes}class v{static Assert(e,s){if(!e)throw new Error(s)}}class p{static Copy(e,s,o,u,b){for(let d=0;d<b;d++)o[u+d]=e[s+d]}static Copy2(e,s,o,u,b){for(let d=0;d<b;d++)o[u+d]=e[s+d]}}class h{constructor(){this.m_changes=[],this.m_originalStart=1073741824,this.m_modifiedStart=1073741824,this.m_originalCount=0,this.m_modifiedCount=0}MarkNextChange(){(this.m_originalCount>0||this.m_modifiedCount>0)&&this.m_changes.push(new r.DiffChange(this.m_originalStart,this.m_originalCount,this.m_modifiedStart,this.m_modifiedCount)),this.m_originalCount=0,this.m_modifiedCount=0,this.m_originalStart=1073741824,this.m_modifiedStart=1073741824}AddOriginalElement(e,s){this.m_originalStart=Math.min(this.m_originalStart,e),this.m_modifiedStart=Math.min(this.m_modifiedStart,s),this.m_originalCount++}AddModifiedElement(e,s){this.m_originalStart=Math.min(this.m_originalStart,e),this.m_modifiedStart=Math.min(this.m_modifiedStart,s),this.m_modifiedCount++}getChanges(){return(this.m_originalCount>0||this.m_modifiedCount>0)&&this.MarkNextChange(),this.m_changes}getReverseChanges(){return(this.m_originalCount>0||this.m_modifiedCount>0)&&this.MarkNextChange(),this.m_changes.reverse(),this.m_changes}}class l{constructor(e,s,o=null){this.ContinueProcessingPredicate=o,this._originalSequence=e,this._modifiedSequence=s;const[u,b,d]=l._getElements(e),[y,_,N]=l._getElements(s);this._hasStrings=d&&N,this._originalStringElements=u,this._originalElementsOrHash=b,this._modifiedStringElements=y,this._modifiedElementsOrHash=_,this.m_forwardHistory=[],this.m_reverseHistory=[]}static _isStringArray(e){return e.length>0&&typeof e[0]=="string"}static _getElements(e){const s=e.getElements();if(l._isStringArray(s)){const o=new Int32Array(s.length);for(let u=0,b=s.length;u<b;u++)o[u]=(0,M.stringHash)(s[u],0);return[s,o,!0]}return s instanceof Int32Array?[[],s,!1]:[[],new Int32Array(s),!1]}ElementsAreEqual(e,s){return this._originalElementsOrHash[e]!==this._modifiedElementsOrHash[s]?!1:this._hasStrings?this._originalStringElements[e]===this._modifiedStringElements[s]:!0}ElementsAreStrictEqual(e,s){if(!this.ElementsAreEqual(e,s))return!1;const o=l._getStrictElement(this._originalSequence,e),u=l._getStrictElement(this._modifiedSequence,s);return o===u}static _getStrictElement(e,s){return typeof e.getStrictElement=="function"?e.getStrictElement(s):null}OriginalElementsAreEqual(e,s){return this._originalElementsOrHash[e]!==this._originalElementsOrHash[s]?!1:this._hasStrings?this._originalStringElements[e]===this._originalStringElements[s]:!0}ModifiedElementsAreEqual(e,s){return this._modifiedElementsOrHash[e]!==this._modifiedElementsOrHash[s]?!1:this._hasStrings?this._modifiedStringElements[e]===this._modifiedStringElements[s]:!0}ComputeDiff(e){return this._ComputeDiff(0,this._originalElementsOrHash.length-1,0,this._modifiedElementsOrHash.length-1,e)}_ComputeDiff(e,s,o,u,b){const d=[!1];let y=this.ComputeDiffRecursive(e,s,o,u,d);return b&&(y=this.PrettifyChanges(y)),{quitEarly:d[0],changes:y}}ComputeDiffRecursive(e,s,o,u,b){for(b[0]=!1;e<=s&&o<=u&&this.ElementsAreEqual(e,o);)e++,o++;for(;s>=e&&u>=o&&this.ElementsAreEqual(s,u);)s--,u--;if(e>s||o>u){let C;return o<=u?(v.Assert(e===s+1,"originalStart should only be one more than originalEnd"),C=[new r.DiffChange(e,0,o,u-o+1)]):e<=s?(v.Assert(o===u+1,"modifiedStart should only be one more than modifiedEnd"),C=[new r.DiffChange(e,s-e+1,o,0)]):(v.Assert(e===s+1,"originalStart should only be one more than originalEnd"),v.Assert(o===u+1,"modifiedStart should only be one more than modifiedEnd"),C=[]),C}const d=[0],y=[0],_=this.ComputeRecursionPoint(e,s,o,u,d,y,b),N=d[0],S=y[0];if(_!==null)return _;if(!b[0]){const C=this.ComputeDiffRecursive(e,N,o,S,b);let i=[];return b[0]?i=[new r.DiffChange(N+1,s-(N+1)+1,S+1,u-(S+1)+1)]:i=this.ComputeDiffRecursive(N+1,s,S+1,u,b),this.ConcatenateChanges(C,i)}return[new r.DiffChange(e,s-e+1,o,u-o+1)]}WALKTRACE(e,s,o,u,b,d,y,_,N,S,C,i,a,m,L,c,f,R){let E=null,x=null,D=new h,T=s,k=o,W=a[0]-c[0]-u,j=-1073741824,$=this.m_forwardHistory.length-1;do{const I=W+e;I===T||I<k&&N[I-1]<N[I+1]?(C=N[I+1],m=C-W-u,C<j&&D.MarkNextChange(),j=C,D.AddModifiedElement(C+1,m),W=I+1-e):(C=N[I-1]+1,m=C-W-u,C<j&&D.MarkNextChange(),j=C-1,D.AddOriginalElement(C,m+1),W=I-1-e),$>=0&&(N=this.m_forwardHistory[$],e=N[0],T=1,k=N.length-1)}while(--$>=-1);if(E=D.getReverseChanges(),R[0]){let I=a[0]+1,F=c[0]+1;if(E!==null&&E.length>0){const O=E[E.length-1];I=Math.max(I,O.getOriginalEnd()),F=Math.max(F,O.getModifiedEnd())}x=[new r.DiffChange(I,i-I+1,F,L-F+1)]}else{D=new h,T=d,k=y,W=a[0]-c[0]-_,j=1073741824,$=f?this.m_reverseHistory.length-1:this.m_reverseHistory.length-2;do{const I=W+b;I===T||I<k&&S[I-1]>=S[I+1]?(C=S[I+1]-1,m=C-W-_,C>j&&D.MarkNextChange(),j=C+1,D.AddOriginalElement(C+1,m+1),W=I+1-b):(C=S[I-1],m=C-W-_,C>j&&D.MarkNextChange(),j=C,D.AddModifiedElement(C+1,m+1),W=I-1-b),$>=0&&(S=this.m_reverseHistory[$],b=S[0],T=1,k=S.length-1)}while(--$>=-1);x=D.getChanges()}return this.ConcatenateChanges(E,x)}ComputeRecursionPoint(e,s,o,u,b,d,y){let _=0,N=0,S=0,C=0,i=0,a=0;e--,o--,b[0]=0,d[0]=0,this.m_forwardHistory=[],this.m_reverseHistory=[];const m=s-e+(u-o),L=m+1,c=new Int32Array(L),f=new Int32Array(L),R=u-o,E=s-e,x=e-o,D=s-u,k=(E-R)%2===0;c[R]=e,f[E]=s,y[0]=!1;for(let W=1;W<=m/2+1;W++){let j=0,$=0;S=this.ClipDiagonalBound(R-W,W,R,L),C=this.ClipDiagonalBound(R+W,W,R,L);for(let F=S;F<=C;F+=2){F===S||F<C&&c[F-1]<c[F+1]?_=c[F+1]:_=c[F-1]+1,N=_-(F-R)-x;const O=_;for(;_<s&&N<u&&this.ElementsAreEqual(_+1,N+1);)_++,N++;if(c[F]=_,_+N>j+$&&(j=_,$=N),!k&&Math.abs(F-E)<=W-1&&_>=f[F])return b[0]=_,d[0]=N,O<=f[F]&&1447>0&&W<=1448?this.WALKTRACE(R,S,C,x,E,i,a,D,c,f,_,s,b,N,u,d,k,y):null}const I=(j-e+($-o)-W)/2;if(this.ContinueProcessingPredicate!==null&&!this.ContinueProcessingPredicate(j,I))return y[0]=!0,b[0]=j,d[0]=$,I>0&&1447>0&&W<=1448?this.WALKTRACE(R,S,C,x,E,i,a,D,c,f,_,s,b,N,u,d,k,y):(e++,o++,[new r.DiffChange(e,s-e+1,o,u-o+1)]);i=this.ClipDiagonalBound(E-W,W,E,L),a=this.ClipDiagonalBound(E+W,W,E,L);for(let F=i;F<=a;F+=2){F===i||F<a&&f[F-1]>=f[F+1]?_=f[F+1]-1:_=f[F-1],N=_-(F-E)-D;const O=_;for(;_>e&&N>o&&this.ElementsAreEqual(_,N);)_--,N--;if(f[F]=_,k&&Math.abs(F-R)<=W&&_<=c[F])return b[0]=_,d[0]=N,O>=c[F]&&1447>0&&W<=1448?this.WALKTRACE(R,S,C,x,E,i,a,D,c,f,_,s,b,N,u,d,k,y):null}if(W<=1447){let F=new Int32Array(C-S+2);F[0]=R-S+1,p.Copy2(c,S,F,1,C-S+1),this.m_forwardHistory.push(F),F=new Int32Array(a-i+2),F[0]=E-i+1,p.Copy2(f,i,F,1,a-i+1),this.m_reverseHistory.push(F)}}return this.WALKTRACE(R,S,C,x,E,i,a,D,c,f,_,s,b,N,u,d,k,y)}PrettifyChanges(e){for(let s=0;s<e.length;s++){const o=e[s],u=s<e.length-1?e[s+1].originalStart:this._originalElementsOrHash.length,b=s<e.length-1?e[s+1].modifiedStart:this._modifiedElementsOrHash.length,d=o.originalLength>0,y=o.modifiedLength>0;for(;o.originalStart+o.originalLength<u&&o.modifiedStart+o.modifiedLength<b&&(!d||this.OriginalElementsAreEqual(o.originalStart,o.originalStart+o.originalLength))&&(!y||this.ModifiedElementsAreEqual(o.modifiedStart,o.modifiedStart+o.modifiedLength));){const N=this.ElementsAreStrictEqual(o.originalStart,o.modifiedStart);if(this.ElementsAreStrictEqual(o.originalStart+o.originalLength,o.modifiedStart+o.modifiedLength)&&!N)break;o.originalStart++,o.modifiedStart++}const _=[null];if(s<e.length-1&&this.ChangesOverlap(e[s],e[s+1],_)){e[s]=_[0],e.splice(s+1,1),s--;continue}}for(let s=e.length-1;s>=0;s--){const o=e[s];let u=0,b=0;if(s>0){const C=e[s-1];u=C.originalStart+C.originalLength,b=C.modifiedStart+C.modifiedLength}const d=o.originalLength>0,y=o.modifiedLength>0;let _=0,N=this._boundaryScore(o.originalStart,o.originalLength,o.modifiedStart,o.modifiedLength);for(let C=1;;C++){const i=o.originalStart-C,a=o.modifiedStart-C;if(i<u||a<b||d&&!this.OriginalElementsAreEqual(i,i+o.originalLength)||y&&!this.ModifiedElementsAreEqual(a,a+o.modifiedLength))break;const L=(i===u&&a===b?5:0)+this._boundaryScore(i,o.originalLength,a,o.modifiedLength);L>N&&(N=L,_=C)}o.originalStart-=_,o.modifiedStart-=_;const S=[null];if(s>0&&this.ChangesOverlap(e[s-1],e[s],S)){e[s-1]=S[0],e.splice(s,1),s++;continue}}if(this._hasStrings)for(let s=1,o=e.length;s<o;s++){const u=e[s-1],b=e[s],d=b.originalStart-u.originalStart-u.originalLength,y=u.originalStart,_=b.originalStart+b.originalLength,N=_-y,S=u.modifiedStart,C=b.modifiedStart+b.modifiedLength,i=C-S;if(d<5&&N<20&&i<20){const a=this._findBetterContiguousSequence(y,N,S,i,d);if(a){const[m,L]=a;(m!==u.originalStart+u.originalLength||L!==u.modifiedStart+u.modifiedLength)&&(u.originalLength=m-u.originalStart,u.modifiedLength=L-u.modifiedStart,b.originalStart=m+d,b.modifiedStart=L+d,b.originalLength=_-b.originalStart,b.modifiedLength=C-b.modifiedStart)}}}return e}_findBetterContiguousSequence(e,s,o,u,b){if(s<b||u<b)return null;const d=e+s-b+1,y=o+u-b+1;let _=0,N=0,S=0;for(let C=e;C<d;C++)for(let i=o;i<y;i++){const a=this._contiguousSequenceScore(C,i,b);a>0&&a>_&&(_=a,N=C,S=i)}return _>0?[N,S]:null}_contiguousSequenceScore(e,s,o){let u=0;for(let b=0;b<o;b++){if(!this.ElementsAreEqual(e+b,s+b))return 0;u+=this._originalStringElements[e+b].length}return u}_OriginalIsBoundary(e){return e<=0||e>=this._originalElementsOrHash.length-1?!0:this._hasStrings&&/^\s*$/.test(this._originalStringElements[e])}_OriginalRegionIsBoundary(e,s){if(this._OriginalIsBoundary(e)||this._OriginalIsBoundary(e-1))return!0;if(s>0){const o=e+s;if(this._OriginalIsBoundary(o-1)||this._OriginalIsBoundary(o))return!0}return!1}_ModifiedIsBoundary(e){return e<=0||e>=this._modifiedElementsOrHash.length-1?!0:this._hasStrings&&/^\s*$/.test(this._modifiedStringElements[e])}_ModifiedRegionIsBoundary(e,s){if(this._ModifiedIsBoundary(e)||this._ModifiedIsBoundary(e-1))return!0;if(s>0){const o=e+s;if(this._ModifiedIsBoundary(o-1)||this._ModifiedIsBoundary(o))return!0}return!1}_boundaryScore(e,s,o,u){const b=this._OriginalRegionIsBoundary(e,s)?1:0,d=this._ModifiedRegionIsBoundary(o,u)?1:0;return b+d}ConcatenateChanges(e,s){const o=[];if(e.length===0||s.length===0)return s.length>0?s:e;if(this.ChangesOverlap(e[e.length-1],s[0],o)){const u=new Array(e.length+s.length-1);return p.Copy(e,0,u,0,e.length-1),u[e.length-1]=o[0],p.Copy(s,1,u,e.length,s.length-1),u}else{const u=new Array(e.length+s.length);return p.Copy(e,0,u,0,e.length),p.Copy(s,0,u,e.length,s.length),u}}ChangesOverlap(e,s,o){if(v.Assert(e.originalStart<=s.originalStart,"Left change is not less than or equal to right change"),v.Assert(e.modifiedStart<=s.modifiedStart,"Left change is not less than or equal to right change"),e.originalStart+e.originalLength>=s.originalStart||e.modifiedStart+e.modifiedLength>=s.modifiedStart){const u=e.originalStart;let b=e.originalLength;const d=e.modifiedStart;let y=e.modifiedLength;return e.originalStart+e.originalLength>=s.originalStart&&(b=s.originalStart+s.originalLength-e.originalStart),e.modifiedStart+e.modifiedLength>=s.modifiedStart&&(y=s.modifiedStart+s.modifiedLength-e.modifiedStart),o[0]=new r.DiffChange(u,b,d,y),!0}else return o[0]=null,!1}ClipDiagonalBound(e,s,o,u){if(e>=0&&e<u)return e;const b=o,d=u-o-1,y=s%2===0;if(e<0){const _=b%2===0;return y===_?0:1}else{const _=d%2===0;return y===_?u-1:u-2}}}n.LcsDiff=l}),X(Z[25],K([0,1]),function(q,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.isString=r,n.isObject=M,n.isTypedArray=A,n.isNumber=g,n.isIterable=v,n.isBoolean=p,n.isUndefined=h,n.isDefined=l,n.isUndefinedOrNull=w,n.assertType=e,n.assertIsDefined=s,n.isFunction=o,n.validateConstraints=u,n.validateConstraint=b;function r(d){return typeof d=="string"}function M(d){return typeof d=="object"&&d!==null&&!Array.isArray(d)&&!(d instanceof RegExp)&&!(d instanceof Date)}function A(d){const y=Object.getPrototypeOf(Uint8Array);return typeof d=="object"&&d instanceof y}function g(d){return typeof d=="number"&&!isNaN(d)}function v(d){return!!d&&typeof d[Symbol.iterator]=="function"}function p(d){return d===!0||d===!1}function h(d){return typeof d>"u"}function l(d){return!w(d)}function w(d){return h(d)||d===null}function e(d,y){if(!d)throw new Error(y?`Unexpected type, expected '${y}'`:"Unexpected type")}function s(d){if(w(d))throw new Error("Assertion Failed: argument is undefined or null");return d}function o(d){return typeof d=="function"}function u(d,y){const _=Math.min(d.length,y.length);for(let N=0;N<_;N++)b(d[N],y[N])}function b(d,y){if(r(y)){if(typeof d!==y)throw new Error(`argument does not match constraint: typeof ${y}`)}else if(o(y)){try{if(d instanceof y)return}catch{}if(!w(d)&&d.constructor===y||y.length===1&&y.call(void 0,d)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}}),X(Z[26],K([0,1,25]),function(q,n,r){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.register=A,n.getCodiconFontCharacters=g;const M=Object.create(null);function A(v,p){if((0,r.isString)(p)){const h=M[p];if(h===void 0)throw new Error(`${v} references an unknown codicon: ${p}`);p=h}return M[v]=p,{id:v}}function g(){return M}}),X(Z[41],K([0,1,26]),function(q,n,r){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.codiconsLibrary=void 0,n.codiconsLibrary={add:(0,r.register)("add",6e4),plus:(0,r.register)("plus",6e4),gistNew:(0,r.register)("gist-new",6e4),repoCreate:(0,r.register)("repo-create",6e4),lightbulb:(0,r.register)("lightbulb",60001),lightBulb:(0,r.register)("light-bulb",60001),repo:(0,r.register)("repo",60002),repoDelete:(0,r.register)("repo-delete",60002),gistFork:(0,r.register)("gist-fork",60003),repoForked:(0,r.register)("repo-forked",60003),gitPullRequest:(0,r.register)("git-pull-request",60004),gitPullRequestAbandoned:(0,r.register)("git-pull-request-abandoned",60004),recordKeys:(0,r.register)("record-keys",60005),keyboard:(0,r.register)("keyboard",60005),tag:(0,r.register)("tag",60006),gitPullRequestLabel:(0,r.register)("git-pull-request-label",60006),tagAdd:(0,r.register)("tag-add",60006),tagRemove:(0,r.register)("tag-remove",60006),person:(0,r.register)("person",60007),personFollow:(0,r.register)("person-follow",60007),personOutline:(0,r.register)("person-outline",60007),personFilled:(0,r.register)("person-filled",60007),gitBranch:(0,r.register)("git-branch",60008),gitBranchCreate:(0,r.register)("git-branch-create",60008),gitBranchDelete:(0,r.register)("git-branch-delete",60008),sourceControl:(0,r.register)("source-control",60008),mirror:(0,r.register)("mirror",60009),mirrorPublic:(0,r.register)("mirror-public",60009),star:(0,r.register)("star",60010),starAdd:(0,r.register)("star-add",60010),starDelete:(0,r.register)("star-delete",60010),starEmpty:(0,r.register)("star-empty",60010),comment:(0,r.register)("comment",60011),commentAdd:(0,r.register)("comment-add",60011),alert:(0,r.register)("alert",60012),warning:(0,r.register)("warning",60012),search:(0,r.register)("search",60013),searchSave:(0,r.register)("search-save",60013),logOut:(0,r.register)("log-out",60014),signOut:(0,r.register)("sign-out",60014),logIn:(0,r.register)("log-in",60015),signIn:(0,r.register)("sign-in",60015),eye:(0,r.register)("eye",60016),eyeUnwatch:(0,r.register)("eye-unwatch",60016),eyeWatch:(0,r.register)("eye-watch",60016),circleFilled:(0,r.register)("circle-filled",60017),primitiveDot:(0,r.register)("primitive-dot",60017),closeDirty:(0,r.register)("close-dirty",60017),debugBreakpoint:(0,r.register)("debug-breakpoint",60017),debugBreakpointDisabled:(0,r.register)("debug-breakpoint-disabled",60017),debugHint:(0,r.register)("debug-hint",60017),terminalDecorationSuccess:(0,r.register)("terminal-decoration-success",60017),primitiveSquare:(0,r.register)("primitive-square",60018),edit:(0,r.register)("edit",60019),pencil:(0,r.register)("pencil",60019),info:(0,r.register)("info",60020),issueOpened:(0,r.register)("issue-opened",60020),gistPrivate:(0,r.register)("gist-private",60021),gitForkPrivate:(0,r.register)("git-fork-private",60021),lock:(0,r.register)("lock",60021),mirrorPrivate:(0,r.register)("mirror-private",60021),close:(0,r.register)("close",60022),removeClose:(0,r.register)("remove-close",60022),x:(0,r.register)("x",60022),repoSync:(0,r.register)("repo-sync",60023),sync:(0,r.register)("sync",60023),clone:(0,r.register)("clone",60024),desktopDownload:(0,r.register)("desktop-download",60024),beaker:(0,r.register)("beaker",60025),microscope:(0,r.register)("microscope",60025),vm:(0,r.register)("vm",60026),deviceDesktop:(0,r.register)("device-desktop",60026),file:(0,r.register)("file",60027),fileText:(0,r.register)("file-text",60027),more:(0,r.register)("more",60028),ellipsis:(0,r.register)("ellipsis",60028),kebabHorizontal:(0,r.register)("kebab-horizontal",60028),mailReply:(0,r.register)("mail-reply",60029),reply:(0,r.register)("reply",60029),organization:(0,r.register)("organization",60030),organizationFilled:(0,r.register)("organization-filled",60030),organizationOutline:(0,r.register)("organization-outline",60030),newFile:(0,r.register)("new-file",60031),fileAdd:(0,r.register)("file-add",60031),newFolder:(0,r.register)("new-folder",60032),fileDirectoryCreate:(0,r.register)("file-directory-create",60032),trash:(0,r.register)("trash",60033),trashcan:(0,r.register)("trashcan",60033),history:(0,r.register)("history",60034),clock:(0,r.register)("clock",60034),folder:(0,r.register)("folder",60035),fileDirectory:(0,r.register)("file-directory",60035),symbolFolder:(0,r.register)("symbol-folder",60035),logoGithub:(0,r.register)("logo-github",60036),markGithub:(0,r.register)("mark-github",60036),github:(0,r.register)("github",60036),terminal:(0,r.register)("terminal",60037),console:(0,r.register)("console",60037),repl:(0,r.register)("repl",60037),zap:(0,r.register)("zap",60038),symbolEvent:(0,r.register)("symbol-event",60038),error:(0,r.register)("error",60039),stop:(0,r.register)("stop",60039),variable:(0,r.register)("variable",60040),symbolVariable:(0,r.register)("symbol-variable",60040),array:(0,r.register)("array",60042),symbolArray:(0,r.register)("symbol-array",60042),symbolModule:(0,r.register)("symbol-module",60043),symbolPackage:(0,r.register)("symbol-package",60043),symbolNamespace:(0,r.register)("symbol-namespace",60043),symbolObject:(0,r.register)("symbol-object",60043),symbolMethod:(0,r.register)("symbol-method",60044),symbolFunction:(0,r.register)("symbol-function",60044),symbolConstructor:(0,r.register)("symbol-constructor",60044),symbolBoolean:(0,r.register)("symbol-boolean",60047),symbolNull:(0,r.register)("symbol-null",60047),symbolNumeric:(0,r.register)("symbol-numeric",60048),symbolNumber:(0,r.register)("symbol-number",60048),symbolStructure:(0,r.register)("symbol-structure",60049),symbolStruct:(0,r.register)("symbol-struct",60049),symbolParameter:(0,r.register)("symbol-parameter",60050),symbolTypeParameter:(0,r.register)("symbol-type-parameter",60050),symbolKey:(0,r.register)("symbol-key",60051),symbolText:(0,r.register)("symbol-text",60051),symbolReference:(0,r.register)("symbol-reference",60052),goToFile:(0,r.register)("go-to-file",60052),symbolEnum:(0,r.register)("symbol-enum",60053),symbolValue:(0,r.register)("symbol-value",60053),symbolRuler:(0,r.register)("symbol-ruler",60054),symbolUnit:(0,r.register)("symbol-unit",60054),activateBreakpoints:(0,r.register)("activate-breakpoints",60055),archive:(0,r.register)("archive",60056),arrowBoth:(0,r.register)("arrow-both",60057),arrowDown:(0,r.register)("arrow-down",60058),arrowLeft:(0,r.register)("arrow-left",60059),arrowRight:(0,r.register)("arrow-right",60060),arrowSmallDown:(0,r.register)("arrow-small-down",60061),arrowSmallLeft:(0,r.register)("arrow-small-left",60062),arrowSmallRight:(0,r.register)("arrow-small-right",60063),arrowSmallUp:(0,r.register)("arrow-small-up",60064),arrowUp:(0,r.register)("arrow-up",60065),bell:(0,r.register)("bell",60066),bold:(0,r.register)("bold",60067),book:(0,r.register)("book",60068),bookmark:(0,r.register)("bookmark",60069),debugBreakpointConditionalUnverified:(0,r.register)("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:(0,r.register)("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:(0,r.register)("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:(0,r.register)("debug-breakpoint-data-unverified",60072),debugBreakpointData:(0,r.register)("debug-breakpoint-data",60073),debugBreakpointDataDisabled:(0,r.register)("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:(0,r.register)("debug-breakpoint-log-unverified",60074),debugBreakpointLog:(0,r.register)("debug-breakpoint-log",60075),debugBreakpointLogDisabled:(0,r.register)("debug-breakpoint-log-disabled",60075),briefcase:(0,r.register)("briefcase",60076),broadcast:(0,r.register)("broadcast",60077),browser:(0,r.register)("browser",60078),bug:(0,r.register)("bug",60079),calendar:(0,r.register)("calendar",60080),caseSensitive:(0,r.register)("case-sensitive",60081),check:(0,r.register)("check",60082),checklist:(0,r.register)("checklist",60083),chevronDown:(0,r.register)("chevron-down",60084),chevronLeft:(0,r.register)("chevron-left",60085),chevronRight:(0,r.register)("chevron-right",60086),chevronUp:(0,r.register)("chevron-up",60087),chromeClose:(0,r.register)("chrome-close",60088),chromeMaximize:(0,r.register)("chrome-maximize",60089),chromeMinimize:(0,r.register)("chrome-minimize",60090),chromeRestore:(0,r.register)("chrome-restore",60091),circleOutline:(0,r.register)("circle-outline",60092),circle:(0,r.register)("circle",60092),debugBreakpointUnverified:(0,r.register)("debug-breakpoint-unverified",60092),terminalDecorationIncomplete:(0,r.register)("terminal-decoration-incomplete",60092),circleSlash:(0,r.register)("circle-slash",60093),circuitBoard:(0,r.register)("circuit-board",60094),clearAll:(0,r.register)("clear-all",60095),clippy:(0,r.register)("clippy",60096),closeAll:(0,r.register)("close-all",60097),cloudDownload:(0,r.register)("cloud-download",60098),cloudUpload:(0,r.register)("cloud-upload",60099),code:(0,r.register)("code",60100),collapseAll:(0,r.register)("collapse-all",60101),colorMode:(0,r.register)("color-mode",60102),commentDiscussion:(0,r.register)("comment-discussion",60103),creditCard:(0,r.register)("credit-card",60105),dash:(0,r.register)("dash",60108),dashboard:(0,r.register)("dashboard",60109),database:(0,r.register)("database",60110),debugContinue:(0,r.register)("debug-continue",60111),debugDisconnect:(0,r.register)("debug-disconnect",60112),debugPause:(0,r.register)("debug-pause",60113),debugRestart:(0,r.register)("debug-restart",60114),debugStart:(0,r.register)("debug-start",60115),debugStepInto:(0,r.register)("debug-step-into",60116),debugStepOut:(0,r.register)("debug-step-out",60117),debugStepOver:(0,r.register)("debug-step-over",60118),debugStop:(0,r.register)("debug-stop",60119),debug:(0,r.register)("debug",60120),deviceCameraVideo:(0,r.register)("device-camera-video",60121),deviceCamera:(0,r.register)("device-camera",60122),deviceMobile:(0,r.register)("device-mobile",60123),diffAdded:(0,r.register)("diff-added",60124),diffIgnored:(0,r.register)("diff-ignored",60125),diffModified:(0,r.register)("diff-modified",60126),diffRemoved:(0,r.register)("diff-removed",60127),diffRenamed:(0,r.register)("diff-renamed",60128),diff:(0,r.register)("diff",60129),diffSidebyside:(0,r.register)("diff-sidebyside",60129),discard:(0,r.register)("discard",60130),editorLayout:(0,r.register)("editor-layout",60131),emptyWindow:(0,r.register)("empty-window",60132),exclude:(0,r.register)("exclude",60133),extensions:(0,r.register)("extensions",60134),eyeClosed:(0,r.register)("eye-closed",60135),fileBinary:(0,r.register)("file-binary",60136),fileCode:(0,r.register)("file-code",60137),fileMedia:(0,r.register)("file-media",60138),filePdf:(0,r.register)("file-pdf",60139),fileSubmodule:(0,r.register)("file-submodule",60140),fileSymlinkDirectory:(0,r.register)("file-symlink-directory",60141),fileSymlinkFile:(0,r.register)("file-symlink-file",60142),fileZip:(0,r.register)("file-zip",60143),files:(0,r.register)("files",60144),filter:(0,r.register)("filter",60145),flame:(0,r.register)("flame",60146),foldDown:(0,r.register)("fold-down",60147),foldUp:(0,r.register)("fold-up",60148),fold:(0,r.register)("fold",60149),folderActive:(0,r.register)("folder-active",60150),folderOpened:(0,r.register)("folder-opened",60151),gear:(0,r.register)("gear",60152),gift:(0,r.register)("gift",60153),gistSecret:(0,r.register)("gist-secret",60154),gist:(0,r.register)("gist",60155),gitCommit:(0,r.register)("git-commit",60156),gitCompare:(0,r.register)("git-compare",60157),compareChanges:(0,r.register)("compare-changes",60157),gitMerge:(0,r.register)("git-merge",60158),githubAction:(0,r.register)("github-action",60159),githubAlt:(0,r.register)("github-alt",60160),globe:(0,r.register)("globe",60161),grabber:(0,r.register)("grabber",60162),graph:(0,r.register)("graph",60163),gripper:(0,r.register)("gripper",60164),heart:(0,r.register)("heart",60165),home:(0,r.register)("home",60166),horizontalRule:(0,r.register)("horizontal-rule",60167),hubot:(0,r.register)("hubot",60168),inbox:(0,r.register)("inbox",60169),issueReopened:(0,r.register)("issue-reopened",60171),issues:(0,r.register)("issues",60172),italic:(0,r.register)("italic",60173),jersey:(0,r.register)("jersey",60174),json:(0,r.register)("json",60175),kebabVertical:(0,r.register)("kebab-vertical",60176),key:(0,r.register)("key",60177),law:(0,r.register)("law",60178),lightbulbAutofix:(0,r.register)("lightbulb-autofix",60179),linkExternal:(0,r.register)("link-external",60180),link:(0,r.register)("link",60181),listOrdered:(0,r.register)("list-ordered",60182),listUnordered:(0,r.register)("list-unordered",60183),liveShare:(0,r.register)("live-share",60184),loading:(0,r.register)("loading",60185),location:(0,r.register)("location",60186),mailRead:(0,r.register)("mail-read",60187),mail:(0,r.register)("mail",60188),markdown:(0,r.register)("markdown",60189),megaphone:(0,r.register)("megaphone",60190),mention:(0,r.register)("mention",60191),milestone:(0,r.register)("milestone",60192),gitPullRequestMilestone:(0,r.register)("git-pull-request-milestone",60192),mortarBoard:(0,r.register)("mortar-board",60193),move:(0,r.register)("move",60194),multipleWindows:(0,r.register)("multiple-windows",60195),mute:(0,r.register)("mute",60196),noNewline:(0,r.register)("no-newline",60197),note:(0,r.register)("note",60198),octoface:(0,r.register)("octoface",60199),openPreview:(0,r.register)("open-preview",60200),package:(0,r.register)("package",60201),paintcan:(0,r.register)("paintcan",60202),pin:(0,r.register)("pin",60203),play:(0,r.register)("play",60204),run:(0,r.register)("run",60204),plug:(0,r.register)("plug",60205),preserveCase:(0,r.register)("preserve-case",60206),preview:(0,r.register)("preview",60207),project:(0,r.register)("project",60208),pulse:(0,r.register)("pulse",60209),question:(0,r.register)("question",60210),quote:(0,r.register)("quote",60211),radioTower:(0,r.register)("radio-tower",60212),reactions:(0,r.register)("reactions",60213),references:(0,r.register)("references",60214),refresh:(0,r.register)("refresh",60215),regex:(0,r.register)("regex",60216),remoteExplorer:(0,r.register)("remote-explorer",60217),remote:(0,r.register)("remote",60218),remove:(0,r.register)("remove",60219),replaceAll:(0,r.register)("replace-all",60220),replace:(0,r.register)("replace",60221),repoClone:(0,r.register)("repo-clone",60222),repoForcePush:(0,r.register)("repo-force-push",60223),repoPull:(0,r.register)("repo-pull",60224),repoPush:(0,r.register)("repo-push",60225),report:(0,r.register)("report",60226),requestChanges:(0,r.register)("request-changes",60227),rocket:(0,r.register)("rocket",60228),rootFolderOpened:(0,r.register)("root-folder-opened",60229),rootFolder:(0,r.register)("root-folder",60230),rss:(0,r.register)("rss",60231),ruby:(0,r.register)("ruby",60232),saveAll:(0,r.register)("save-all",60233),saveAs:(0,r.register)("save-as",60234),save:(0,r.register)("save",60235),screenFull:(0,r.register)("screen-full",60236),screenNormal:(0,r.register)("screen-normal",60237),searchStop:(0,r.register)("search-stop",60238),server:(0,r.register)("server",60240),settingsGear:(0,r.register)("settings-gear",60241),settings:(0,r.register)("settings",60242),shield:(0,r.register)("shield",60243),smiley:(0,r.register)("smiley",60244),sortPrecedence:(0,r.register)("sort-precedence",60245),splitHorizontal:(0,r.register)("split-horizontal",60246),splitVertical:(0,r.register)("split-vertical",60247),squirrel:(0,r.register)("squirrel",60248),starFull:(0,r.register)("star-full",60249),starHalf:(0,r.register)("star-half",60250),symbolClass:(0,r.register)("symbol-class",60251),symbolColor:(0,r.register)("symbol-color",60252),symbolConstant:(0,r.register)("symbol-constant",60253),symbolEnumMember:(0,r.register)("symbol-enum-member",60254),symbolField:(0,r.register)("symbol-field",60255),symbolFile:(0,r.register)("symbol-file",60256),symbolInterface:(0,r.register)("symbol-interface",60257),symbolKeyword:(0,r.register)("symbol-keyword",60258),symbolMisc:(0,r.register)("symbol-misc",60259),symbolOperator:(0,r.register)("symbol-operator",60260),symbolProperty:(0,r.register)("symbol-property",60261),wrench:(0,r.register)("wrench",60261),wrenchSubaction:(0,r.register)("wrench-subaction",60261),symbolSnippet:(0,r.register)("symbol-snippet",60262),tasklist:(0,r.register)("tasklist",60263),telescope:(0,r.register)("telescope",60264),textSize:(0,r.register)("text-size",60265),threeBars:(0,r.register)("three-bars",60266),thumbsdown:(0,r.register)("thumbsdown",60267),thumbsup:(0,r.register)("thumbsup",60268),tools:(0,r.register)("tools",60269),triangleDown:(0,r.register)("triangle-down",60270),triangleLeft:(0,r.register)("triangle-left",60271),triangleRight:(0,r.register)("triangle-right",60272),triangleUp:(0,r.register)("triangle-up",60273),twitter:(0,r.register)("twitter",60274),unfold:(0,r.register)("unfold",60275),unlock:(0,r.register)("unlock",60276),unmute:(0,r.register)("unmute",60277),unverified:(0,r.register)("unverified",60278),verified:(0,r.register)("verified",60279),versions:(0,r.register)("versions",60280),vmActive:(0,r.register)("vm-active",60281),vmOutline:(0,r.register)("vm-outline",60282),vmRunning:(0,r.register)("vm-running",60283),watch:(0,r.register)("watch",60284),whitespace:(0,r.register)("whitespace",60285),wholeWord:(0,r.register)("whole-word",60286),window:(0,r.register)("window",60287),wordWrap:(0,r.register)("word-wrap",60288),zoomIn:(0,r.register)("zoom-in",60289),zoomOut:(0,r.register)("zoom-out",60290),listFilter:(0,r.register)("list-filter",60291),listFlat:(0,r.register)("list-flat",60292),listSelection:(0,r.register)("list-selection",60293),selection:(0,r.register)("selection",60293),listTree:(0,r.register)("list-tree",60294),debugBreakpointFunctionUnverified:(0,r.register)("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:(0,r.register)("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:(0,r.register)("debug-breakpoint-function-disabled",60296),debugStackframeActive:(0,r.register)("debug-stackframe-active",60297),circleSmallFilled:(0,r.register)("circle-small-filled",60298),debugStackframeDot:(0,r.register)("debug-stackframe-dot",60298),terminalDecorationMark:(0,r.register)("terminal-decoration-mark",60298),debugStackframe:(0,r.register)("debug-stackframe",60299),debugStackframeFocused:(0,r.register)("debug-stackframe-focused",60299),debugBreakpointUnsupported:(0,r.register)("debug-breakpoint-unsupported",60300),symbolString:(0,r.register)("symbol-string",60301),debugReverseContinue:(0,r.register)("debug-reverse-continue",60302),debugStepBack:(0,r.register)("debug-step-back",60303),debugRestartFrame:(0,r.register)("debug-restart-frame",60304),debugAlt:(0,r.register)("debug-alt",60305),callIncoming:(0,r.register)("call-incoming",60306),callOutgoing:(0,r.register)("call-outgoing",60307),menu:(0,r.register)("menu",60308),expandAll:(0,r.register)("expand-all",60309),feedback:(0,r.register)("feedback",60310),gitPullRequestReviewer:(0,r.register)("git-pull-request-reviewer",60310),groupByRefType:(0,r.register)("group-by-ref-type",60311),ungroupByRefType:(0,r.register)("ungroup-by-ref-type",60312),account:(0,r.register)("account",60313),gitPullRequestAssignee:(0,r.register)("git-pull-request-assignee",60313),bellDot:(0,r.register)("bell-dot",60314),debugConsole:(0,r.register)("debug-console",60315),library:(0,r.register)("library",60316),output:(0,r.register)("output",60317),runAll:(0,r.register)("run-all",60318),syncIgnored:(0,r.register)("sync-ignored",60319),pinned:(0,r.register)("pinned",60320),githubInverted:(0,r.register)("github-inverted",60321),serverProcess:(0,r.register)("server-process",60322),serverEnvironment:(0,r.register)("server-environment",60323),pass:(0,r.register)("pass",60324),issueClosed:(0,r.register)("issue-closed",60324),stopCircle:(0,r.register)("stop-circle",60325),playCircle:(0,r.register)("play-circle",60326),record:(0,r.register)("record",60327),debugAltSmall:(0,r.register)("debug-alt-small",60328),vmConnect:(0,r.register)("vm-connect",60329),cloud:(0,r.register)("cloud",60330),merge:(0,r.register)("merge",60331),export:(0,r.register)("export",60332),graphLeft:(0,r.register)("graph-left",60333),magnet:(0,r.register)("magnet",60334),notebook:(0,r.register)("notebook",60335),redo:(0,r.register)("redo",60336),checkAll:(0,r.register)("check-all",60337),pinnedDirty:(0,r.register)("pinned-dirty",60338),passFilled:(0,r.register)("pass-filled",60339),circleLargeFilled:(0,r.register)("circle-large-filled",60340),circleLarge:(0,r.register)("circle-large",60341),circleLargeOutline:(0,r.register)("circle-large-outline",60341),combine:(0,r.register)("combine",60342),gather:(0,r.register)("gather",60342),table:(0,r.register)("table",60343),variableGroup:(0,r.register)("variable-group",60344),typeHierarchy:(0,r.register)("type-hierarchy",60345),typeHierarchySub:(0,r.register)("type-hierarchy-sub",60346),typeHierarchySuper:(0,r.register)("type-hierarchy-super",60347),gitPullRequestCreate:(0,r.register)("git-pull-request-create",60348),runAbove:(0,r.register)("run-above",60349),runBelow:(0,r.register)("run-below",60350),notebookTemplate:(0,r.register)("notebook-template",60351),debugRerun:(0,r.register)("debug-rerun",60352),workspaceTrusted:(0,r.register)("workspace-trusted",60353),workspaceUntrusted:(0,r.register)("workspace-untrusted",60354),workspaceUnknown:(0,r.register)("workspace-unknown",60355),terminalCmd:(0,r.register)("terminal-cmd",60356),terminalDebian:(0,r.register)("terminal-debian",60357),terminalLinux:(0,r.register)("terminal-linux",60358),terminalPowershell:(0,r.register)("terminal-powershell",60359),terminalTmux:(0,r.register)("terminal-tmux",60360),terminalUbuntu:(0,r.register)("terminal-ubuntu",60361),terminalBash:(0,r.register)("terminal-bash",60362),arrowSwap:(0,r.register)("arrow-swap",60363),copy:(0,r.register)("copy",60364),personAdd:(0,r.register)("person-add",60365),filterFilled:(0,r.register)("filter-filled",60366),wand:(0,r.register)("wand",60367),debugLineByLine:(0,r.register)("debug-line-by-line",60368),inspect:(0,r.register)("inspect",60369),layers:(0,r.register)("layers",60370),layersDot:(0,r.register)("layers-dot",60371),layersActive:(0,r.register)("layers-active",60372),compass:(0,r.register)("compass",60373),compassDot:(0,r.register)("compass-dot",60374),compassActive:(0,r.register)("compass-active",60375),azure:(0,r.register)("azure",60376),issueDraft:(0,r.register)("issue-draft",60377),gitPullRequestClosed:(0,r.register)("git-pull-request-closed",60378),gitPullRequestDraft:(0,r.register)("git-pull-request-draft",60379),debugAll:(0,r.register)("debug-all",60380),debugCoverage:(0,r.register)("debug-coverage",60381),runErrors:(0,r.register)("run-errors",60382),folderLibrary:(0,r.register)("folder-library",60383),debugContinueSmall:(0,r.register)("debug-continue-small",60384),beakerStop:(0,r.register)("beaker-stop",60385),graphLine:(0,r.register)("graph-line",60386),graphScatter:(0,r.register)("graph-scatter",60387),pieChart:(0,r.register)("pie-chart",60388),bracket:(0,r.register)("bracket",60175),bracketDot:(0,r.register)("bracket-dot",60389),bracketError:(0,r.register)("bracket-error",60390),lockSmall:(0,r.register)("lock-small",60391),azureDevops:(0,r.register)("azure-devops",60392),verifiedFilled:(0,r.register)("verified-filled",60393),newline:(0,r.register)("newline",60394),layout:(0,r.register)("layout",60395),layoutActivitybarLeft:(0,r.register)("layout-activitybar-left",60396),layoutActivitybarRight:(0,r.register)("layout-activitybar-right",60397),layoutPanelLeft:(0,r.register)("layout-panel-left",60398),layoutPanelCenter:(0,r.register)("layout-panel-center",60399),layoutPanelJustify:(0,r.register)("layout-panel-justify",60400),layoutPanelRight:(0,r.register)("layout-panel-right",60401),layoutPanel:(0,r.register)("layout-panel",60402),layoutSidebarLeft:(0,r.register)("layout-sidebar-left",60403),layoutSidebarRight:(0,r.register)("layout-sidebar-right",60404),layoutStatusbar:(0,r.register)("layout-statusbar",60405),layoutMenubar:(0,r.register)("layout-menubar",60406),layoutCentered:(0,r.register)("layout-centered",60407),target:(0,r.register)("target",60408),indent:(0,r.register)("indent",60409),recordSmall:(0,r.register)("record-small",60410),errorSmall:(0,r.register)("error-small",60411),terminalDecorationError:(0,r.register)("terminal-decoration-error",60411),arrowCircleDown:(0,r.register)("arrow-circle-down",60412),arrowCircleLeft:(0,r.register)("arrow-circle-left",60413),arrowCircleRight:(0,r.register)("arrow-circle-right",60414),arrowCircleUp:(0,r.register)("arrow-circle-up",60415),layoutSidebarRightOff:(0,r.register)("layout-sidebar-right-off",60416),layoutPanelOff:(0,r.register)("layout-panel-off",60417),layoutSidebarLeftOff:(0,r.register)("layout-sidebar-left-off",60418),blank:(0,r.register)("blank",60419),heartFilled:(0,r.register)("heart-filled",60420),map:(0,r.register)("map",60421),mapFilled:(0,r.register)("map-filled",60422),circleSmall:(0,r.register)("circle-small",60423),bellSlash:(0,r.register)("bell-slash",60424),bellSlashDot:(0,r.register)("bell-slash-dot",60425),commentUnresolved:(0,r.register)("comment-unresolved",60426),gitPullRequestGoToChanges:(0,r.register)("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:(0,r.register)("git-pull-request-new-changes",60428),searchFuzzy:(0,r.register)("search-fuzzy",60429),commentDraft:(0,r.register)("comment-draft",60430),send:(0,r.register)("send",60431),sparkle:(0,r.register)("sparkle",60432),insert:(0,r.register)("insert",60433),mic:(0,r.register)("mic",60434),thumbsdownFilled:(0,r.register)("thumbsdown-filled",60435),thumbsupFilled:(0,r.register)("thumbsup-filled",60436),coffee:(0,r.register)("coffee",60437),snake:(0,r.register)("snake",60438),game:(0,r.register)("game",60439),vr:(0,r.register)("vr",60440),chip:(0,r.register)("chip",60441),piano:(0,r.register)("piano",60442),music:(0,r.register)("music",60443),micFilled:(0,r.register)("mic-filled",60444),repoFetch:(0,r.register)("repo-fetch",60445),copilot:(0,r.register)("copilot",60446),lightbulbSparkle:(0,r.register)("lightbulb-sparkle",60447),robot:(0,r.register)("robot",60448),sparkleFilled:(0,r.register)("sparkle-filled",60449),diffSingle:(0,r.register)("diff-single",60450),diffMultiple:(0,r.register)("diff-multiple",60451),surroundWith:(0,r.register)("surround-with",60452),share:(0,r.register)("share",60453),gitStash:(0,r.register)("git-stash",60454),gitStashApply:(0,r.register)("git-stash-apply",60455),gitStashPop:(0,r.register)("git-stash-pop",60456),vscode:(0,r.register)("vscode",60457),vscodeInsiders:(0,r.register)("vscode-insiders",60458),codeOss:(0,r.register)("code-oss",60459),runCoverage:(0,r.register)("run-coverage",60460),runAllCoverage:(0,r.register)("run-all-coverage",60461),coverage:(0,r.register)("coverage",60462),githubProject:(0,r.register)("github-project",60463)}}),X(Z[42],K([0,1,26,41]),function(q,n,r,M){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.Codicon=n.codiconsDerived=void 0,n.codiconsDerived={dialogError:(0,r.register)("dialog-error","error"),dialogWarning:(0,r.register)("dialog-warning","warning"),dialogInfo:(0,r.register)("dialog-info","info"),dialogClose:(0,r.register)("dialog-close","close"),treeItemExpanded:(0,r.register)("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:(0,r.register)("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:(0,r.register)("tree-filter-on-type-off","list-selection"),treeFilterClear:(0,r.register)("tree-filter-clear","close"),treeItemLoading:(0,r.register)("tree-item-loading","loading"),menuSelection:(0,r.register)("menu-selection","check"),menuSubmenu:(0,r.register)("menu-submenu","chevron-right"),menuBarMore:(0,r.register)("menubar-more","more"),scrollbarButtonLeft:(0,r.register)("scrollbar-button-left","triangle-left"),scrollbarButtonRight:(0,r.register)("scrollbar-button-right","triangle-right"),scrollbarButtonUp:(0,r.register)("scrollbar-button-up","triangle-up"),scrollbarButtonDown:(0,r.register)("scrollbar-button-down","triangle-down"),toolBarMore:(0,r.register)("toolbar-more","more"),quickInputBack:(0,r.register)("quick-input-back","arrow-left"),dropDownButton:(0,r.register)("drop-down-button",60084),symbolCustomColor:(0,r.register)("symbol-customcolor",60252),exportIcon:(0,r.register)("export",60332),workspaceUnspecified:(0,r.register)("workspace-unspecified",60355),newLine:(0,r.register)("newline",60394),thumbsDownFilled:(0,r.register)("thumbsdown-filled",60435),thumbsUpFilled:(0,r.register)("thumbsup-filled",60436),gitFetch:(0,r.register)("git-fetch",60445),lightbulbSparkleAutofix:(0,r.register)("lightbulb-sparkle-autofix",60447),debugBreakpointPending:(0,r.register)("debug-breakpoint-pending",60377)},n.Codicon={...M.codiconsLibrary,...n.codiconsDerived}}),X(Z[14],K([0,1,25]),function(q,n,r){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.deepClone=M,n.deepFreeze=A,n.cloneAndChange=v,n.mixin=h,n.equals=l,n.getAllPropertyNames=w,n.getAllMethodNames=e,n.createProxyObject=s;function M(o){if(!o||typeof o!="object"||o instanceof RegExp)return o;const u=Array.isArray(o)?[]:{};return Object.entries(o).forEach(([b,d])=>{u[b]=d&&typeof d=="object"?M(d):d}),u}function A(o){if(!o||typeof o!="object")return o;const u=[o];for(;u.length>0;){const b=u.shift();Object.freeze(b);for(const d in b)if(g.call(b,d)){const y=b[d];typeof y=="object"&&!Object.isFrozen(y)&&!(0,r.isTypedArray)(y)&&u.push(y)}}return o}const g=Object.prototype.hasOwnProperty;function v(o,u){return p(o,u,new Set)}function p(o,u,b){if((0,r.isUndefinedOrNull)(o))return o;const d=u(o);if(typeof d<"u")return d;if(Array.isArray(o)){const y=[];for(const _ of o)y.push(p(_,u,b));return y}if((0,r.isObject)(o)){if(b.has(o))throw new Error("Cannot clone recursive data-structure");b.add(o);const y={};for(const _ in o)g.call(o,_)&&(y[_]=p(o[_],u,b));return b.delete(o),y}return o}function h(o,u,b=!0){return(0,r.isObject)(o)?((0,r.isObject)(u)&&Object.keys(u).forEach(d=>{d in o?b&&((0,r.isObject)(o[d])&&(0,r.isObject)(u[d])?h(o[d],u[d],b):o[d]=u[d]):o[d]=u[d]}),o):u}function l(o,u){if(o===u)return!0;if(o==null||u===null||u===void 0||typeof o!=typeof u||typeof o!="object"||Array.isArray(o)!==Array.isArray(u))return!1;let b,d;if(Array.isArray(o)){if(o.length!==u.length)return!1;for(b=0;b<o.length;b++)if(!l(o[b],u[b]))return!1}else{const y=[];for(d in o)y.push(d);y.sort();const _=[];for(d in u)_.push(d);if(_.sort(),!l(y,_))return!1;for(b=0;b<y.length;b++)if(!l(o[y[b]],u[y[b]]))return!1}return!0}function w(o){let u=[];for(;Object.prototype!==o;)u=u.concat(Object.getOwnPropertyNames(o)),o=Object.getPrototypeOf(o);return u}function e(o){const u=[];for(const b of w(o))typeof o[b]=="function"&&u.push(b);return u}function s(o,u){const b=y=>function(){const _=Array.prototype.slice.call(arguments,0);return u(y,_)},d={};for(const y of o)d[y]=b(y);return d}}),X(Z[27],K([0,1]),function(q,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.toUint8=r,n.toUint32=M;function r(A){return A<0?0:A>255?255:A|0}function M(A){return A<0?0:A>4294967295?4294967295:A|0}}),X(Z[28],K([0,1,27]),function(q,n,r){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.CharacterSet=n.CharacterClassifier=void 0;class M{constructor(v){const p=(0,r.toUint8)(v);this._defaultValue=p,this._asciiMap=M._createAsciiMap(p),this._map=new Map}static _createAsciiMap(v){const p=new Uint8Array(256);return p.fill(v),p}set(v,p){const h=(0,r.toUint8)(p);v>=0&&v<256?this._asciiMap[v]=h:this._map.set(v,h)}get(v){return v>=0&&v<256?this._asciiMap[v]:this._map.get(v)||this._defaultValue}clear(){this._asciiMap.fill(this._defaultValue),this._map.clear()}}n.CharacterClassifier=M;class A{constructor(){this._actual=new M(0)}add(v){this._actual.set(v,1)}has(v){return this._actual.get(v)===1}clear(){return this._actual.clear()}}n.CharacterSet=A}),X(Z[3],K([0,1,5]),function(q,n,r){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.OffsetRangeSet=n.OffsetRange=void 0;class M{static addRange(v,p){let h=0;for(;h<p.length&&p[h].endExclusive<v.start;)h++;let l=h;for(;l<p.length&&p[l].start<=v.endExclusive;)l++;if(h===l)p.splice(h,0,v);else{const w=Math.min(v.start,p[h].start),e=Math.max(v.endExclusive,p[l-1].endExclusive);p.splice(h,l-h,new M(w,e))}}static ofLength(v){return new M(0,v)}static ofStartAndLength(v,p){return new M(v,v+p)}constructor(v,p){if(this.start=v,this.endExclusive=p,v>p)throw new r.BugIndicatingError(`Invalid range: ${this.toString()}`)}get isEmpty(){return this.start===this.endExclusive}delta(v){return new M(this.start+v,this.endExclusive+v)}deltaStart(v){return new M(this.start+v,this.endExclusive)}deltaEnd(v){return new M(this.start,this.endExclusive+v)}get length(){return this.endExclusive-this.start}toString(){return`[${this.start}, ${this.endExclusive})`}contains(v){return this.start<=v&&v<this.endExclusive}join(v){return new M(Math.min(this.start,v.start),Math.max(this.endExclusive,v.endExclusive))}intersect(v){const p=Math.max(this.start,v.start),h=Math.min(this.endExclusive,v.endExclusive);if(p<=h)return new M(p,h)}intersects(v){const p=Math.max(this.start,v.start),h=Math.min(this.endExclusive,v.endExclusive);return p<h}isBefore(v){return this.endExclusive<=v.start}isAfter(v){return this.start>=v.endExclusive}slice(v){return v.slice(this.start,this.endExclusive)}substring(v){return v.substring(this.start,this.endExclusive)}clip(v){if(this.isEmpty)throw new r.BugIndicatingError(`Invalid clipping range: ${this.toString()}`);return Math.max(this.start,Math.min(this.endExclusive-1,v))}clipCyclic(v){if(this.isEmpty)throw new r.BugIndicatingError(`Invalid clipping range: ${this.toString()}`);return v<this.start?this.endExclusive-(this.start-v)%this.length:v>=this.endExclusive?this.start+(v-this.start)%this.length:v}forEach(v){for(let p=this.start;p<this.endExclusive;p++)v(p)}}n.OffsetRange=M;class A{constructor(){this._sortedRanges=[]}addRange(v){let p=0;for(;p<this._sortedRanges.length&&this._sortedRanges[p].endExclusive<v.start;)p++;let h=p;for(;h<this._sortedRanges.length&&this._sortedRanges[h].start<=v.endExclusive;)h++;if(p===h)this._sortedRanges.splice(p,0,v);else{const l=Math.min(v.start,this._sortedRanges[p].start),w=Math.max(v.endExclusive,this._sortedRanges[h-1].endExclusive);this._sortedRanges.splice(p,h-p,new M(l,w))}}toString(){return this._sortedRanges.map(v=>v.toString()).join(", ")}intersectsStrict(v){let p=0;for(;p<this._sortedRanges.length&&this._sortedRanges[p].endExclusive<=v.start;)p++;return p<this._sortedRanges.length&&this._sortedRanges[p].start<v.endExclusive}intersectWithRange(v){const p=new A;for(const h of this._sortedRanges){const l=h.intersect(v);l&&p.addRange(l)}return p}intersectWithRangeLength(v){return this.intersectWithRange(v).length}get length(){return this._sortedRanges.reduce((v,p)=>v+p.length,0)}}n.OffsetRangeSet=A}),X(Z[4],K([0,1]),function(q,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.Position=void 0;class r{constructor(A,g){this.lineNumber=A,this.column=g}with(A=this.lineNumber,g=this.column){return A===this.lineNumber&&g===this.column?this:new r(A,g)}delta(A=0,g=0){return this.with(this.lineNumber+A,this.column+g)}equals(A){return r.equals(this,A)}static equals(A,g){return!A&&!g?!0:!!A&&!!g&&A.lineNumber===g.lineNumber&&A.column===g.column}isBefore(A){return r.isBefore(this,A)}static isBefore(A,g){return A.lineNumber<g.lineNumber?!0:g.lineNumber<A.lineNumber?!1:A.column<g.column}isBeforeOrEqual(A){return r.isBeforeOrEqual(this,A)}static isBeforeOrEqual(A,g){return A.lineNumber<g.lineNumber?!0:g.lineNumber<A.lineNumber?!1:A.column<=g.column}static compare(A,g){const v=A.lineNumber|0,p=g.lineNumber|0;if(v===p){const h=A.column|0,l=g.column|0;return h-l}return v-p}clone(){return new r(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(A){return new r(A.lineNumber,A.column)}static isIPosition(A){return A&&typeof A.lineNumber=="number"&&typeof A.column=="number"}toJSON(){return{lineNumber:this.lineNumber,column:this.column}}}n.Position=r}),X(Z[2],K([0,1,4]),function(q,n,r){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.Range=void 0;class M{constructor(g,v,p,h){g>p||g===p&&v>h?(this.startLineNumber=p,this.startColumn=h,this.endLineNumber=g,this.endColumn=v):(this.startLineNumber=g,this.startColumn=v,this.endLineNumber=p,this.endColumn=h)}isEmpty(){return M.isEmpty(this)}static isEmpty(g){return g.startLineNumber===g.endLineNumber&&g.startColumn===g.endColumn}containsPosition(g){return M.containsPosition(this,g)}static containsPosition(g,v){return!(v.lineNumber<g.startLineNumber||v.lineNumber>g.endLineNumber||v.lineNumber===g.startLineNumber&&v.column<g.startColumn||v.lineNumber===g.endLineNumber&&v.column>g.endColumn)}static strictContainsPosition(g,v){return!(v.lineNumber<g.startLineNumber||v.lineNumber>g.endLineNumber||v.lineNumber===g.startLineNumber&&v.column<=g.startColumn||v.lineNumber===g.endLineNumber&&v.column>=g.endColumn)}containsRange(g){return M.containsRange(this,g)}static containsRange(g,v){return!(v.startLineNumber<g.startLineNumber||v.endLineNumber<g.startLineNumber||v.startLineNumber>g.endLineNumber||v.endLineNumber>g.endLineNumber||v.startLineNumber===g.startLineNumber&&v.startColumn<g.startColumn||v.endLineNumber===g.endLineNumber&&v.endColumn>g.endColumn)}strictContainsRange(g){return M.strictContainsRange(this,g)}static strictContainsRange(g,v){return!(v.startLineNumber<g.startLineNumber||v.endLineNumber<g.startLineNumber||v.startLineNumber>g.endLineNumber||v.endLineNumber>g.endLineNumber||v.startLineNumber===g.startLineNumber&&v.startColumn<=g.startColumn||v.endLineNumber===g.endLineNumber&&v.endColumn>=g.endColumn)}plusRange(g){return M.plusRange(this,g)}static plusRange(g,v){let p,h,l,w;return v.startLineNumber<g.startLineNumber?(p=v.startLineNumber,h=v.startColumn):v.startLineNumber===g.startLineNumber?(p=v.startLineNumber,h=Math.min(v.startColumn,g.startColumn)):(p=g.startLineNumber,h=g.startColumn),v.endLineNumber>g.endLineNumber?(l=v.endLineNumber,w=v.endColumn):v.endLineNumber===g.endLineNumber?(l=v.endLineNumber,w=Math.max(v.endColumn,g.endColumn)):(l=g.endLineNumber,w=g.endColumn),new M(p,h,l,w)}intersectRanges(g){return M.intersectRanges(this,g)}static intersectRanges(g,v){let p=g.startLineNumber,h=g.startColumn,l=g.endLineNumber,w=g.endColumn;const e=v.startLineNumber,s=v.startColumn,o=v.endLineNumber,u=v.endColumn;return p<e?(p=e,h=s):p===e&&(h=Math.max(h,s)),l>o?(l=o,w=u):l===o&&(w=Math.min(w,u)),p>l||p===l&&h>w?null:new M(p,h,l,w)}equalsRange(g){return M.equalsRange(this,g)}static equalsRange(g,v){return!g&&!v?!0:!!g&&!!v&&g.startLineNumber===v.startLineNumber&&g.startColumn===v.startColumn&&g.endLineNumber===v.endLineNumber&&g.endColumn===v.endColumn}getEndPosition(){return M.getEndPosition(this)}static getEndPosition(g){return new r.Position(g.endLineNumber,g.endColumn)}getStartPosition(){return M.getStartPosition(this)}static getStartPosition(g){return new r.Position(g.startLineNumber,g.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(g,v){return new M(this.startLineNumber,this.startColumn,g,v)}setStartPosition(g,v){return new M(g,v,this.endLineNumber,this.endColumn)}collapseToStart(){return M.collapseToStart(this)}static collapseToStart(g){return new M(g.startLineNumber,g.startColumn,g.startLineNumber,g.startColumn)}collapseToEnd(){return M.collapseToEnd(this)}static collapseToEnd(g){return new M(g.endLineNumber,g.endColumn,g.endLineNumber,g.endColumn)}delta(g){return new M(this.startLineNumber+g,this.startColumn,this.endLineNumber+g,this.endColumn)}static fromPositions(g,v=g){return new M(g.lineNumber,g.column,v.lineNumber,v.column)}static lift(g){return g?new M(g.startLineNumber,g.startColumn,g.endLineNumber,g.endColumn):null}static isIRange(g){return g&&typeof g.startLineNumber=="number"&&typeof g.startColumn=="number"&&typeof g.endLineNumber=="number"&&typeof g.endColumn=="number"}static areIntersectingOrTouching(g,v){return!(g.endLineNumber<v.startLineNumber||g.endLineNumber===v.startLineNumber&&g.endColumn<v.startColumn||v.endLineNumber<g.startLineNumber||v.endLineNumber===g.startLineNumber&&v.endColumn<g.startColumn)}static areIntersecting(g,v){return!(g.endLineNumber<v.startLineNumber||g.endLineNumber===v.startLineNumber&&g.endColumn<=v.startColumn||v.endLineNumber<g.startLineNumber||v.endLineNumber===g.startLineNumber&&v.endColumn<=g.startColumn)}static compareRangesUsingStarts(g,v){if(g&&v){const l=g.startLineNumber|0,w=v.startLineNumber|0;if(l===w){const e=g.startColumn|0,s=v.startColumn|0;if(e===s){const o=g.endLineNumber|0,u=v.endLineNumber|0;if(o===u){const b=g.endColumn|0,d=v.endColumn|0;return b-d}return o-u}return e-s}return l-w}return(g?1:0)-(v?1:0)}static compareRangesUsingEnds(g,v){return g.endLineNumber===v.endLineNumber?g.endColumn===v.endColumn?g.startLineNumber===v.startLineNumber?g.startColumn-v.startColumn:g.startLineNumber-v.startLineNumber:g.endColumn-v.endColumn:g.endLineNumber-v.endLineNumber}static spansMultipleLines(g){return g.endLineNumber>g.startLineNumber}toJSON(){return this}}n.Range=M}),X(Z[10],K([0,1,5,3,2,11]),function(q,n,r,M,A,g){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.LineRangeSet=n.LineRange=void 0;class v{static fromRangeInclusive(l){return new v(l.startLineNumber,l.endLineNumber+1)}static joinMany(l){if(l.length===0)return[];let w=new p(l[0].slice());for(let e=1;e<l.length;e++)w=w.getUnion(new p(l[e].slice()));return w.ranges}static ofLength(l,w){return new v(l,l+w)}static deserialize(l){return new v(l[0],l[1])}constructor(l,w){if(l>w)throw new r.BugIndicatingError(`startLineNumber ${l} cannot be after endLineNumberExclusive ${w}`);this.startLineNumber=l,this.endLineNumberExclusive=w}contains(l){return this.startLineNumber<=l&&l<this.endLineNumberExclusive}get isEmpty(){return this.startLineNumber===this.endLineNumberExclusive}delta(l){return new v(this.startLineNumber+l,this.endLineNumberExclusive+l)}deltaLength(l){return new v(this.startLineNumber,this.endLineNumberExclusive+l)}get length(){return this.endLineNumberExclusive-this.startLineNumber}join(l){return new v(Math.min(this.startLineNumber,l.startLineNumber),Math.max(this.endLineNumberExclusive,l.endLineNumberExclusive))}toString(){return`[${this.startLineNumber},${this.endLineNumberExclusive})`}intersect(l){const w=Math.max(this.startLineNumber,l.startLineNumber),e=Math.min(this.endLineNumberExclusive,l.endLineNumberExclusive);if(w<=e)return new v(w,e)}intersectsStrict(l){return this.startLineNumber<l.endLineNumberExclusive&&l.startLineNumber<this.endLineNumberExclusive}overlapOrTouch(l){return this.startLineNumber<=l.endLineNumberExclusive&&l.startLineNumber<=this.endLineNumberExclusive}equals(l){return this.startLineNumber===l.startLineNumber&&this.endLineNumberExclusive===l.endLineNumberExclusive}toInclusiveRange(){return this.isEmpty?null:new A.Range(this.startLineNumber,1,this.endLineNumberExclusive-1,Number.MAX_SAFE_INTEGER)}toExclusiveRange(){return new A.Range(this.startLineNumber,1,this.endLineNumberExclusive,1)}mapToLineArray(l){const w=[];for(let e=this.startLineNumber;e<this.endLineNumberExclusive;e++)w.push(l(e));return w}forEach(l){for(let w=this.startLineNumber;w<this.endLineNumberExclusive;w++)l(w)}serialize(){return[this.startLineNumber,this.endLineNumberExclusive]}includes(l){return this.startLineNumber<=l&&l<this.endLineNumberExclusive}toOffsetRange(){return new M.OffsetRange(this.startLineNumber-1,this.endLineNumberExclusive-1)}}n.LineRange=v;class p{constructor(l=[]){this._normalizedRanges=l}get ranges(){return this._normalizedRanges}addRange(l){if(l.length===0)return;const w=(0,g.findFirstIdxMonotonousOrArrLen)(this._normalizedRanges,s=>s.endLineNumberExclusive>=l.startLineNumber),e=(0,g.findLastIdxMonotonous)(this._normalizedRanges,s=>s.startLineNumber<=l.endLineNumberExclusive)+1;if(w===e)this._normalizedRanges.splice(w,0,l);else if(w===e-1){const s=this._normalizedRanges[w];this._normalizedRanges[w]=s.join(l)}else{const s=this._normalizedRanges[w].join(this._normalizedRanges[e-1]).join(l);this._normalizedRanges.splice(w,e-w,s)}}contains(l){const w=(0,g.findLastMonotonous)(this._normalizedRanges,e=>e.startLineNumber<=l);return!!w&&w.endLineNumberExclusive>l}intersects(l){const w=(0,g.findLastMonotonous)(this._normalizedRanges,e=>e.startLineNumber<l.endLineNumberExclusive);return!!w&&w.endLineNumberExclusive>l.startLineNumber}getUnion(l){if(this._normalizedRanges.length===0)return l;if(l._normalizedRanges.length===0)return this;const w=[];let e=0,s=0,o=null;for(;e<this._normalizedRanges.length||s<l._normalizedRanges.length;){let u=null;if(e<this._normalizedRanges.length&&s<l._normalizedRanges.length){const b=this._normalizedRanges[e],d=l._normalizedRanges[s];b.startLineNumber<d.startLineNumber?(u=b,e++):(u=d,s++)}else e<this._normalizedRanges.length?(u=this._normalizedRanges[e],e++):(u=l._normalizedRanges[s],s++);o===null?o=u:o.endLineNumberExclusive>=u.startLineNumber?o=new v(o.startLineNumber,Math.max(o.endLineNumberExclusive,u.endLineNumberExclusive)):(w.push(o),o=u)}return o!==null&&w.push(o),new p(w)}subtractFrom(l){const w=(0,g.findFirstIdxMonotonousOrArrLen)(this._normalizedRanges,u=>u.endLineNumberExclusive>=l.startLineNumber),e=(0,g.findLastIdxMonotonous)(this._normalizedRanges,u=>u.startLineNumber<=l.endLineNumberExclusive)+1;if(w===e)return new p([l]);const s=[];let o=l.startLineNumber;for(let u=w;u<e;u++){const b=this._normalizedRanges[u];b.startLineNumber>o&&s.push(new v(o,b.startLineNumber)),o=b.endLineNumberExclusive}return o<l.endLineNumberExclusive&&s.push(new v(o,l.endLineNumberExclusive)),new p(s)}toString(){return this._normalizedRanges.map(l=>l.toString()).join(", ")}getIntersection(l){const w=[];let e=0,s=0;for(;e<this._normalizedRanges.length&&s<l._normalizedRanges.length;){const o=this._normalizedRanges[e],u=l._normalizedRanges[s],b=o.intersect(u);b&&!b.isEmpty&&w.push(b),o.endLineNumberExclusive<u.endLineNumberExclusive?e++:s++}return new p(w)}getWithDelta(l){return new p(this._normalizedRanges.map(w=>w.delta(l)))}}n.LineRangeSet=p}),X(Z[43],K([0,1,4,2]),function(q,n,r,M){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.Selection=void 0;class A extends M.Range{constructor(v,p,h,l){super(v,p,h,l),this.selectionStartLineNumber=v,this.selectionStartColumn=p,this.positionLineNumber=h,this.positionColumn=l}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(v){return A.selectionsEqual(this,v)}static selectionsEqual(v,p){return v.selectionStartLineNumber===p.selectionStartLineNumber&&v.selectionStartColumn===p.selectionStartColumn&&v.positionLineNumber===p.positionLineNumber&&v.positionColumn===p.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(v,p){return this.getDirection()===0?new A(this.startLineNumber,this.startColumn,v,p):new A(v,p,this.startLineNumber,this.startColumn)}getPosition(){return new r.Position(this.positionLineNumber,this.positionColumn)}getSelectionStart(){return new r.Position(this.selectionStartLineNumber,this.selectionStartColumn)}setStartPosition(v,p){return this.getDirection()===0?new A(v,p,this.endLineNumber,this.endColumn):new A(this.endLineNumber,this.endColumn,v,p)}static fromPositions(v,p=v){return new A(v.lineNumber,v.column,p.lineNumber,p.column)}static fromRange(v,p){return p===0?new A(v.startLineNumber,v.startColumn,v.endLineNumber,v.endColumn):new A(v.endLineNumber,v.endColumn,v.startLineNumber,v.startColumn)}static liftSelection(v){return new A(v.selectionStartLineNumber,v.selectionStartColumn,v.positionLineNumber,v.positionColumn)}static selectionsArrEqual(v,p){if(v&&!p||!v&&p)return!1;if(!v&&!p)return!0;if(v.length!==p.length)return!1;for(let h=0,l=v.length;h<l;h++)if(!this.selectionsEqual(v[h],p[h]))return!1;return!0}static isISelection(v){return v&&typeof v.selectionStartLineNumber=="number"&&typeof v.selectionStartColumn=="number"&&typeof v.positionLineNumber=="number"&&typeof v.positionColumn=="number"}static createWithDirection(v,p,h,l,w){return w===0?new A(v,p,h,l):new A(h,l,v,p)}}n.Selection=A}),X(Z[44],K([0,1,28]),function(q,n,r){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.getMapForWordSeparators=n.WordCharacterClassifier=void 0;class M extends r.CharacterClassifier{constructor(v){super(0);for(let p=0,h=v.length;p<h;p++)this.set(v.charCodeAt(p),2);this.set(32,1),this.set(9,1)}}n.WordCharacterClassifier=M;function A(g){const v={};return p=>(v.hasOwnProperty(p)||(v[p]=g(p)),v[p])}n.getMapForWordSeparators=A(g=>new M(g))}),X(Z[29],K([0,1,21,22]),function(q,n,r,M){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.DEFAULT_WORD_REGEXP=n.USUAL_WORD_SEPARATORS=void 0,n.ensureValidWordDefinition=g,n.getWordAtText=p,n.USUAL_WORD_SEPARATORS="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function A(l=""){let w="(-?\\d*\\.\\d\\w*)|([^";for(const e of n.USUAL_WORD_SEPARATORS)l.indexOf(e)>=0||(w+="\\"+e);return w+="\\s]+)",new RegExp(w,"g")}n.DEFAULT_WORD_REGEXP=A();function g(l){let w=n.DEFAULT_WORD_REGEXP;if(l&&l instanceof RegExp)if(l.global)w=l;else{let e="g";l.ignoreCase&&(e+="i"),l.multiline&&(e+="m"),l.unicode&&(e+="u"),w=new RegExp(l.source,e)}return w.lastIndex=0,w}const v=new M.LinkedList;v.unshift({maxLen:1e3,windowSize:15,timeBudget:150});function p(l,w,e,s,o){if(w=g(w),o||(o=r.Iterable.first(v)),e.length>o.maxLen){let _=l-o.maxLen/2;return _<0?_=0:s+=_,e=e.substring(_,l+o.maxLen/2),p(l,w,e,s,o)}const u=Date.now(),b=l-1-s;let d=-1,y=null;for(let _=1;!(Date.now()-u>=o.timeBudget);_++){const N=b-o.windowSize*_;w.lastIndex=Math.max(0,N);const S=h(w,e,b,d);if(!S&&y||(y=S,N<=0))break;d=N}if(y){const _={word:y[0],startColumn:s+1+y.index,endColumn:s+1+y.index+y[0].length};return w.lastIndex=0,_}return null}function h(l,w,e,s){let o;for(;o=l.exec(w);){const u=o.index||0;if(u<=e&&l.lastIndex>=e)return o;if(s>0&&u>s)return null}return null}}),X(Z[8],K([0,1,7,5,3]),function(q,n,r,M,A){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.DateTimeout=n.InfiniteTimeout=n.OffsetPair=n.SequenceDiff=n.DiffAlgorithmResult=void 0;class g{static trivial(e,s){return new g([new v(A.OffsetRange.ofLength(e.length),A.OffsetRange.ofLength(s.length))],!1)}static trivialTimedOut(e,s){return new g([new v(A.OffsetRange.ofLength(e.length),A.OffsetRange.ofLength(s.length))],!0)}constructor(e,s){this.diffs=e,this.hitTimeout=s}}n.DiffAlgorithmResult=g;class v{static invert(e,s){const o=[];return(0,r.forEachAdjacent)(e,(u,b)=>{o.push(v.fromOffsetPairs(u?u.getEndExclusives():p.zero,b?b.getStarts():new p(s,(u?u.seq2Range.endExclusive-u.seq1Range.endExclusive:0)+s)))}),o}static fromOffsetPairs(e,s){return new v(new A.OffsetRange(e.offset1,s.offset1),new A.OffsetRange(e.offset2,s.offset2))}constructor(e,s){this.seq1Range=e,this.seq2Range=s}swap(){return new v(this.seq2Range,this.seq1Range)}toString(){return`${this.seq1Range} <-> ${this.seq2Range}`}join(e){return new v(this.seq1Range.join(e.seq1Range),this.seq2Range.join(e.seq2Range))}delta(e){return e===0?this:new v(this.seq1Range.delta(e),this.seq2Range.delta(e))}deltaStart(e){return e===0?this:new v(this.seq1Range.deltaStart(e),this.seq2Range.deltaStart(e))}deltaEnd(e){return e===0?this:new v(this.seq1Range.deltaEnd(e),this.seq2Range.deltaEnd(e))}intersect(e){const s=this.seq1Range.intersect(e.seq1Range),o=this.seq2Range.intersect(e.seq2Range);if(!(!s||!o))return new v(s,o)}getStarts(){return new p(this.seq1Range.start,this.seq2Range.start)}getEndExclusives(){return new p(this.seq1Range.endExclusive,this.seq2Range.endExclusive)}}n.SequenceDiff=v;class p{constructor(e,s){this.offset1=e,this.offset2=s}toString(){return`${this.offset1} <-> ${this.offset2}`}delta(e){return e===0?this:new p(this.offset1+e,this.offset2+e)}equals(e){return this.offset1===e.offset1&&this.offset2===e.offset2}}n.OffsetPair=p,p.zero=new p(0,0),p.max=new p(Number.MAX_SAFE_INTEGER,Number.MAX_SAFE_INTEGER);class h{isValid(){return!0}}n.InfiniteTimeout=h,h.instance=new h;class l{constructor(e){if(this.timeout=e,this.startTime=Date.now(),this.valid=!0,e<=0)throw new M.BugIndicatingError("timeout must be positive")}isValid(){if(!(Date.now()-this.startTime<this.timeout)&&this.valid){this.valid=!1;debugger}return this.valid}}n.DateTimeout=l}),X(Z[30],K([0,1,3,8]),function(q,n,r,M){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.MyersDiffAlgorithm=void 0;class A{compute(l,w,e=M.InfiniteTimeout.instance){if(l.length===0||w.length===0)return M.DiffAlgorithmResult.trivial(l,w);const s=l,o=w;function u(a,m){for(;a<s.length&&m<o.length&&s.getElement(a)===o.getElement(m);)a++,m++;return a}let b=0;const d=new v;d.set(0,u(0,0));const y=new p;y.set(0,d.get(0)===0?null:new g(null,0,0,d.get(0)));let _=0;e:for(;;){if(b++,!e.isValid())return M.DiffAlgorithmResult.trivialTimedOut(s,o);const a=-Math.min(b,o.length+b%2),m=Math.min(b,s.length+b%2);for(_=a;_<=m;_+=2){let L=0;const c=_===m?-1:d.get(_+1),f=_===a?-1:d.get(_-1)+1;L++;const R=Math.min(Math.max(c,f),s.length),E=R-_;if(L++,R>s.length||E>o.length)continue;const x=u(R,E);d.set(_,x);const D=R===c?y.get(_+1):y.get(_-1);if(y.set(_,x!==R?new g(D,R,E,x-R):D),d.get(_)===s.length&&d.get(_)-_===o.length)break e}}let N=y.get(_);const S=[];let C=s.length,i=o.length;for(;;){const a=N?N.x+N.length:0,m=N?N.y+N.length:0;if((a!==C||m!==i)&&S.push(new M.SequenceDiff(new r.OffsetRange(a,C),new r.OffsetRange(m,i))),!N)break;C=N.x,i=N.y,N=N.prev}return S.reverse(),new M.DiffAlgorithmResult(S,!1)}}n.MyersDiffAlgorithm=A;class g{constructor(l,w,e,s){this.prev=l,this.x=w,this.y=e,this.length=s}}class v{constructor(){this.positiveArr=new Int32Array(10),this.negativeArr=new Int32Array(10)}get(l){return l<0?(l=-l-1,this.negativeArr[l]):this.positiveArr[l]}set(l,w){if(l<0){if(l=-l-1,l>=this.negativeArr.length){const e=this.negativeArr;this.negativeArr=new Int32Array(e.length*2),this.negativeArr.set(e)}this.negativeArr[l]=w}else{if(l>=this.positiveArr.length){const e=this.positiveArr;this.positiveArr=new Int32Array(e.length*2),this.positiveArr.set(e)}this.positiveArr[l]=w}}}class p{constructor(){this.positiveArr=[],this.negativeArr=[]}get(l){return l<0?(l=-l-1,this.negativeArr[l]):this.positiveArr[l]}set(l,w){l<0?(l=-l-1,this.negativeArr[l]=w):this.positiveArr[l]=w}}}),X(Z[45],K([0,1,7,3,8]),function(q,n,r,M,A){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.optimizeSequenceDiffs=g,n.removeShortMatches=l,n.extendDiffsToEntireWordIfAppropriate=w,n.removeVeryShortMatchingLinesBetweenDiffs=s,n.removeVeryShortMatchingTextBetweenLongDiffs=o;function g(u,b,d){let y=d;return y=v(u,b,y),y=v(u,b,y),y=p(u,b,y),y}function v(u,b,d){if(d.length===0)return d;const y=[];y.push(d[0]);for(let N=1;N<d.length;N++){const S=y[y.length-1];let C=d[N];if(C.seq1Range.isEmpty||C.seq2Range.isEmpty){const i=C.seq1Range.start-S.seq1Range.endExclusive;let a;for(a=1;a<=i&&!(u.getElement(C.seq1Range.start-a)!==u.getElement(C.seq1Range.endExclusive-a)||b.getElement(C.seq2Range.start-a)!==b.getElement(C.seq2Range.endExclusive-a));a++);if(a--,a===i){y[y.length-1]=new A.SequenceDiff(new M.OffsetRange(S.seq1Range.start,C.seq1Range.endExclusive-i),new M.OffsetRange(S.seq2Range.start,C.seq2Range.endExclusive-i));continue}C=C.delta(-a)}y.push(C)}const _=[];for(let N=0;N<y.length-1;N++){const S=y[N+1];let C=y[N];if(C.seq1Range.isEmpty||C.seq2Range.isEmpty){const i=S.seq1Range.start-C.seq1Range.endExclusive;let a;for(a=0;a<i&&!(!u.isStronglyEqual(C.seq1Range.start+a,C.seq1Range.endExclusive+a)||!b.isStronglyEqual(C.seq2Range.start+a,C.seq2Range.endExclusive+a));a++);if(a===i){y[N+1]=new A.SequenceDiff(new M.OffsetRange(C.seq1Range.start+i,S.seq1Range.endExclusive),new M.OffsetRange(C.seq2Range.start+i,S.seq2Range.endExclusive));continue}a>0&&(C=C.delta(a))}_.push(C)}return y.length>0&&_.push(y[y.length-1]),_}function p(u,b,d){if(!u.getBoundaryScore||!b.getBoundaryScore)return d;for(let y=0;y<d.length;y++){const _=y>0?d[y-1]:void 0,N=d[y],S=y+1<d.length?d[y+1]:void 0,C=new M.OffsetRange(_?_.seq1Range.endExclusive+1:0,S?S.seq1Range.start-1:u.length),i=new M.OffsetRange(_?_.seq2Range.endExclusive+1:0,S?S.seq2Range.start-1:b.length);N.seq1Range.isEmpty?d[y]=h(N,u,b,C,i):N.seq2Range.isEmpty&&(d[y]=h(N.swap(),b,u,i,C).swap())}return d}function h(u,b,d,y,_){let S=1;for(;u.seq1Range.start-S>=y.start&&u.seq2Range.start-S>=_.start&&d.isStronglyEqual(u.seq2Range.start-S,u.seq2Range.endExclusive-S)&&S<100;)S++;S--;let C=0;for(;u.seq1Range.start+C<y.endExclusive&&u.seq2Range.endExclusive+C<_.endExclusive&&d.isStronglyEqual(u.seq2Range.start+C,u.seq2Range.endExclusive+C)&&C<100;)C++;if(S===0&&C===0)return u;let i=0,a=-1;for(let m=-S;m<=C;m++){const L=u.seq2Range.start+m,c=u.seq2Range.endExclusive+m,f=u.seq1Range.start+m,R=b.getBoundaryScore(f)+d.getBoundaryScore(L)+d.getBoundaryScore(c);R>a&&(a=R,i=m)}return u.delta(i)}function l(u,b,d){const y=[];for(const _ of d){const N=y[y.length-1];if(!N){y.push(_);continue}_.seq1Range.start-N.seq1Range.endExclusive<=2||_.seq2Range.start-N.seq2Range.endExclusive<=2?y[y.length-1]=new A.SequenceDiff(N.seq1Range.join(_.seq1Range),N.seq2Range.join(_.seq2Range)):y.push(_)}return y}function w(u,b,d){const y=A.SequenceDiff.invert(d,u.length),_=[];let N=new A.OffsetPair(0,0);function S(i,a){if(i.offset1<N.offset1||i.offset2<N.offset2)return;const m=u.findWordContaining(i.offset1),L=b.findWordContaining(i.offset2);if(!m||!L)return;let c=new A.SequenceDiff(m,L);const f=c.intersect(a);let R=f.seq1Range.length,E=f.seq2Range.length;for(;y.length>0;){const x=y[0];if(!(x.seq1Range.intersects(c.seq1Range)||x.seq2Range.intersects(c.seq2Range)))break;const T=u.findWordContaining(x.seq1Range.start),k=b.findWordContaining(x.seq2Range.start),W=new A.SequenceDiff(T,k),j=W.intersect(x);if(R+=j.seq1Range.length,E+=j.seq2Range.length,c=c.join(W),c.seq1Range.endExclusive>=x.seq1Range.endExclusive)y.shift();else break}R+E<(c.seq1Range.length+c.seq2Range.length)*2/3&&_.push(c),N=c.getEndExclusives()}for(;y.length>0;){const i=y.shift();i.seq1Range.isEmpty||(S(i.getStarts(),i),S(i.getEndExclusives().delta(-1),i))}return e(d,_)}function e(u,b){const d=[];for(;u.length>0||b.length>0;){const y=u[0],_=b[0];let N;y&&(!_||y.seq1Range.start<_.seq1Range.start)?N=u.shift():N=b.shift(),d.length>0&&d[d.length-1].seq1Range.endExclusive>=N.seq1Range.start?d[d.length-1]=d[d.length-1].join(N):d.push(N)}return d}function s(u,b,d){let y=d;if(y.length===0)return y;let _=0,N;do{N=!1;const S=[y[0]];for(let C=1;C<y.length;C++){let m=function(c,f){const R=new M.OffsetRange(a.seq1Range.endExclusive,i.seq1Range.start);return u.getText(R).replace(/\s/g,"").length<=4&&(c.seq1Range.length+c.seq2Range.length>5||f.seq1Range.length+f.seq2Range.length>5)};const i=y[C],a=S[S.length-1];m(a,i)?(N=!0,S[S.length-1]=S[S.length-1].join(i)):S.push(i)}y=S}while(_++<10&&N);return y}function o(u,b,d){let y=d;if(y.length===0)return y;let _=0,N;do{N=!1;const C=[y[0]];for(let i=1;i<y.length;i++){let L=function(f,R){const E=new M.OffsetRange(m.seq1Range.endExclusive,a.seq1Range.start);if(u.countLinesIn(E)>5||E.length>500)return!1;const D=u.getText(E).trim();if(D.length>20||D.split(/\r\n|\r|\n/).length>1)return!1;const T=u.countLinesIn(f.seq1Range),k=f.seq1Range.length,W=b.countLinesIn(f.seq2Range),j=f.seq2Range.length,$=u.countLinesIn(R.seq1Range),I=R.seq1Range.length,F=b.countLinesIn(R.seq2Range),O=R.seq2Range.length,V=2*40+50;function H(U){return Math.min(U,V)}return Math.pow(Math.pow(H(T*40+k),1.5)+Math.pow(H(W*40+j),1.5),1.5)+Math.pow(Math.pow(H($*40+I),1.5)+Math.pow(H(F*40+O),1.5),1.5)>(V**1.5)**1.5*1.3};const a=y[i],m=C[C.length-1];L(m,a)?(N=!0,C[C.length-1]=C[C.length-1].join(a)):C.push(a)}y=C}while(_++<10&&N);const S=[];return(0,r.forEachWithNeighbors)(y,(C,i,a)=>{let m=i;function L(D){return D.length>0&&D.trim().length<=3&&i.seq1Range.length+i.seq2Range.length>100}const c=u.extendToFullLines(i.seq1Range),f=u.getText(new M.OffsetRange(c.start,i.seq1Range.start));L(f)&&(m=m.deltaStart(-f.length));const R=u.getText(new M.OffsetRange(i.seq1Range.endExclusive,c.endExclusive));L(R)&&(m=m.deltaEnd(R.length));const E=A.SequenceDiff.fromOffsetPairs(C?C.getEndExclusives():A.OffsetPair.zero,a?a.getStarts():A.OffsetPair.max),x=m.intersect(E);S.length>0&&x.getStarts().equals(S[S.length-1].getEndExclusives())?S[S.length-1]=S[S.length-1].join(x):S.push(x)}),S}}),X(Z[46],K([0,1]),function(q,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.LineSequence=void 0;class r{constructor(g,v){this.trimmedHash=g,this.lines=v}getElement(g){return this.trimmedHash[g]}get length(){return this.trimmedHash.length}getBoundaryScore(g){const v=g===0?0:M(this.lines[g-1]),p=g===this.lines.length?0:M(this.lines[g]);return 1e3-(v+p)}getText(g){return this.lines.slice(g.start,g.endExclusive).join(`
`)}isStronglyEqual(g,v){return this.lines[g]===this.lines[v]}}n.LineSequence=r;function M(A){let g=0;for(;g<A.length&&(A.charCodeAt(g)===32||A.charCodeAt(g)===9);)g++;return g}}),X(Z[15],K([0,1]),function(q,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.LineRangeFragment=n.Array2D=void 0,n.isSpace=M;class r{constructor(v,p){this.width=v,this.height=p,this.array=[],this.array=new Array(v*p)}get(v,p){return this.array[v+p*this.width]}set(v,p,h){this.array[v+p*this.width]=h}}n.Array2D=r;function M(g){return g===32||g===9}class A{static getKey(v){let p=this.chrKeys.get(v);return p===void 0&&(p=this.chrKeys.size,this.chrKeys.set(v,p)),p}constructor(v,p,h){this.range=v,this.lines=p,this.source=h,this.histogram=[];let l=0;for(let w=v.startLineNumber-1;w<v.endLineNumberExclusive-1;w++){const e=p[w];for(let o=0;o<e.length;o++){l++;const u=e[o],b=A.getKey(u);this.histogram[b]=(this.histogram[b]||0)+1}l++;const s=A.getKey(`
`);this.histogram[s]=(this.histogram[s]||0)+1}this.totalCount=l}computeSimilarity(v){var p,h;let l=0;const w=Math.max(this.histogram.length,v.histogram.length);for(let e=0;e<w;e++)l+=Math.abs(((p=this.histogram[e])!==null&&p!==void 0?p:0)-((h=v.histogram[e])!==null&&h!==void 0?h:0));return 1-l/(this.totalCount+v.totalCount)}}n.LineRangeFragment=A,A.chrKeys=new Map}),X(Z[47],K([0,1,3,8,15]),function(q,n,r,M,A){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.DynamicProgrammingDiffing=void 0;class g{compute(p,h,l=M.InfiniteTimeout.instance,w){if(p.length===0||h.length===0)return M.DiffAlgorithmResult.trivial(p,h);const e=new A.Array2D(p.length,h.length),s=new A.Array2D(p.length,h.length),o=new A.Array2D(p.length,h.length);for(let S=0;S<p.length;S++)for(let C=0;C<h.length;C++){if(!l.isValid())return M.DiffAlgorithmResult.trivialTimedOut(p,h);const i=S===0?0:e.get(S-1,C),a=C===0?0:e.get(S,C-1);let m;p.getElement(S)===h.getElement(C)?(S===0||C===0?m=0:m=e.get(S-1,C-1),S>0&&C>0&&s.get(S-1,C-1)===3&&(m+=o.get(S-1,C-1)),m+=w?w(S,C):1):m=-1;const L=Math.max(i,a,m);if(L===m){const c=S>0&&C>0?o.get(S-1,C-1):0;o.set(S,C,c+1),s.set(S,C,3)}else L===i?(o.set(S,C,0),s.set(S,C,1)):L===a&&(o.set(S,C,0),s.set(S,C,2));e.set(S,C,L)}const u=[];let b=p.length,d=h.length;function y(S,C){(S+1!==b||C+1!==d)&&u.push(new M.SequenceDiff(new r.OffsetRange(S+1,b),new r.OffsetRange(C+1,d))),b=S,d=C}let _=p.length-1,N=h.length-1;for(;_>=0&&N>=0;)s.get(_,N)===3?(y(_,N),_--,N--):s.get(_,N)===1?_--:N--;return y(-1,-1),u.reverse(),new M.DiffAlgorithmResult(u,!1)}}n.DynamicProgrammingDiffing=g}),X(Z[31],K([0,1,11,3,4,2,15]),function(q,n,r,M,A,g,v){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.LinesSliceCharSequence=void 0;class p{constructor(o,u,b){this.lines=o,this.considerWhitespaceChanges=b,this.elements=[],this.firstCharOffsetByLine=[],this.additionalOffsetByLine=[];let d=!1;u.start>0&&u.endExclusive>=o.length&&(u=new M.OffsetRange(u.start-1,u.endExclusive),d=!0),this.lineRange=u,this.firstCharOffsetByLine[0]=0;for(let y=this.lineRange.start;y<this.lineRange.endExclusive;y++){let _=o[y],N=0;if(d)N=_.length,_="",d=!1;else if(!b){const S=_.trimStart();N=_.length-S.length,_=S.trimEnd()}this.additionalOffsetByLine.push(N);for(let S=0;S<_.length;S++)this.elements.push(_.charCodeAt(S));y<o.length-1&&(this.elements.push(10),this.firstCharOffsetByLine[y-this.lineRange.start+1]=this.elements.length)}this.additionalOffsetByLine.push(0)}toString(){return`Slice: "${this.text}"`}get text(){return this.getText(new M.OffsetRange(0,this.length))}getText(o){return this.elements.slice(o.start,o.endExclusive).map(u=>String.fromCharCode(u)).join("")}getElement(o){return this.elements[o]}get length(){return this.elements.length}getBoundaryScore(o){const u=e(o>0?this.elements[o-1]:-1),b=e(o<this.elements.length?this.elements[o]:-1);if(u===7&&b===8)return 0;if(u===8)return 150;let d=0;return u!==b&&(d+=10,u===0&&b===1&&(d+=1)),d+=w(u),d+=w(b),d}translateOffset(o){if(this.lineRange.isEmpty)return new A.Position(this.lineRange.start+1,1);const u=(0,r.findLastIdxMonotonous)(this.firstCharOffsetByLine,b=>b<=o);return new A.Position(this.lineRange.start+u+1,o-this.firstCharOffsetByLine[u]+this.additionalOffsetByLine[u]+1)}translateRange(o){return g.Range.fromPositions(this.translateOffset(o.start),this.translateOffset(o.endExclusive))}findWordContaining(o){if(o<0||o>=this.elements.length||!h(this.elements[o]))return;let u=o;for(;u>0&&h(this.elements[u-1]);)u--;let b=o;for(;b<this.elements.length&&h(this.elements[b]);)b++;return new M.OffsetRange(u,b)}countLinesIn(o){return this.translateOffset(o.endExclusive).lineNumber-this.translateOffset(o.start).lineNumber}isStronglyEqual(o,u){return this.elements[o]===this.elements[u]}extendToFullLines(o){var u,b;const d=(u=(0,r.findLastMonotonous)(this.firstCharOffsetByLine,_=>_<=o.start))!==null&&u!==void 0?u:0,y=(b=(0,r.findFirstMonotonous)(this.firstCharOffsetByLine,_=>o.endExclusive<=_))!==null&&b!==void 0?b:this.elements.length;return new M.OffsetRange(d,y)}}n.LinesSliceCharSequence=p;function h(s){return s>=97&&s<=122||s>=65&&s<=90||s>=48&&s<=57}const l={0:0,1:0,2:0,3:10,4:2,5:30,6:3,7:10,8:10};function w(s){return l[s]}function e(s){return s===10?8:s===13?7:(0,v.isSpace)(s)?6:s>=97&&s<=122?0:s>=65&&s<=90?1:s>=48&&s<=57?2:s===-1?3:s===44||s===59?5:4}}),X(Z[32],K([0,1]),function(q,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.MovedText=n.LinesDiff=void 0;class r{constructor(g,v,p){this.changes=g,this.moves=v,this.hitTimeout=p}}n.LinesDiff=r;class M{constructor(g,v){this.lineRangeMapping=g,this.changes=v}}n.MovedText=M}),X(Z[16],K([0,1,10]),function(q,n,r){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.RangeMapping=n.DetailedLineRangeMapping=n.LineRangeMapping=void 0;class M{static inverse(p,h,l){const w=[];let e=1,s=1;for(const u of p){const b=new M(new r.LineRange(e,u.original.startLineNumber),new r.LineRange(s,u.modified.startLineNumber));b.modified.isEmpty||w.push(b),e=u.original.endLineNumberExclusive,s=u.modified.endLineNumberExclusive}const o=new M(new r.LineRange(e,h+1),new r.LineRange(s,l+1));return o.modified.isEmpty||w.push(o),w}static clip(p,h,l){const w=[];for(const e of p){const s=e.original.intersect(h),o=e.modified.intersect(l);s&&!s.isEmpty&&o&&!o.isEmpty&&w.push(new M(s,o))}return w}constructor(p,h){this.original=p,this.modified=h}toString(){return`{${this.original.toString()}->${this.modified.toString()}}`}flip(){return new M(this.modified,this.original)}join(p){return new M(this.original.join(p.original),this.modified.join(p.modified))}}n.LineRangeMapping=M;class A extends M{constructor(p,h,l){super(p,h),this.innerChanges=l}flip(){var p;return new A(this.modified,this.original,(p=this.innerChanges)===null||p===void 0?void 0:p.map(h=>h.flip()))}}n.DetailedLineRangeMapping=A;class g{constructor(p,h){this.originalRange=p,this.modifiedRange=h}toString(){return`{${this.originalRange.toString()}->${this.modifiedRange.toString()}}`}flip(){return new g(this.modifiedRange,this.originalRange)}}n.RangeMapping=g}),X(Z[48],K([0,1,8,16,7,11,38,10,3,31,15,30]),function(q,n,r,M,A,g,v,p,h,l,w,e){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.computeMovedLines=s;function s(N,S,C,i,a,m){let{moves:L,excludedChanges:c}=u(N,S,C,m);if(!m.isValid())return[];const f=N.filter(E=>!c.has(E)),R=b(f,i,a,S,C,m);return(0,A.pushMany)(L,R),L=y(L),L=L.filter(E=>{const x=E.original.toOffsetRange().slice(S).map(T=>T.trim());return x.join(`
`).length>=15&&o(x,T=>T.length>=2)>=2}),L=_(N,L),L}function o(N,S){let C=0;for(const i of N)S(i)&&C++;return C}function u(N,S,C,i){const a=[],m=N.filter(f=>f.modified.isEmpty&&f.original.length>=3).map(f=>new w.LineRangeFragment(f.original,S,f)),L=new Set(N.filter(f=>f.original.isEmpty&&f.modified.length>=3).map(f=>new w.LineRangeFragment(f.modified,C,f))),c=new Set;for(const f of m){let R=-1,E;for(const x of L){const D=f.computeSimilarity(x);D>R&&(R=D,E=x)}if(R>.9&&E&&(L.delete(E),a.push(new M.LineRangeMapping(f.range,E.range)),c.add(f.source),c.add(E.source)),!i.isValid())return{moves:a,excludedChanges:c}}return{moves:a,excludedChanges:c}}function b(N,S,C,i,a,m){const L=[],c=new v.SetMap;for(const D of N)for(let T=D.original.startLineNumber;T<D.original.endLineNumberExclusive-2;T++){const k=`${S[T-1]}:${S[T+1-1]}:${S[T+2-1]}`;c.add(k,{range:new p.LineRange(T,T+3)})}const f=[];N.sort((0,A.compareBy)(D=>D.modified.startLineNumber,A.numberComparator));for(const D of N){let T=[];for(let k=D.modified.startLineNumber;k<D.modified.endLineNumberExclusive-2;k++){const W=`${C[k-1]}:${C[k+1-1]}:${C[k+2-1]}`,j=new p.LineRange(k,k+3),$=[];c.forEach(W,({range:I})=>{for(const O of T)if(O.originalLineRange.endLineNumberExclusive+1===I.endLineNumberExclusive&&O.modifiedLineRange.endLineNumberExclusive+1===j.endLineNumberExclusive){O.originalLineRange=new p.LineRange(O.originalLineRange.startLineNumber,I.endLineNumberExclusive),O.modifiedLineRange=new p.LineRange(O.modifiedLineRange.startLineNumber,j.endLineNumberExclusive),$.push(O);return}const F={modifiedLineRange:j,originalLineRange:I};f.push(F),$.push(F)}),T=$}if(!m.isValid())return[]}f.sort((0,A.reverseOrder)((0,A.compareBy)(D=>D.modifiedLineRange.length,A.numberComparator)));const R=new p.LineRangeSet,E=new p.LineRangeSet;for(const D of f){const T=D.modifiedLineRange.startLineNumber-D.originalLineRange.startLineNumber,k=R.subtractFrom(D.modifiedLineRange),W=E.subtractFrom(D.originalLineRange).getWithDelta(T),j=k.getIntersection(W);for(const $ of j.ranges){if($.length<3)continue;const I=$,F=$.delta(-T);L.push(new M.LineRangeMapping(F,I)),R.addRange(I),E.addRange(F)}}L.sort((0,A.compareBy)(D=>D.original.startLineNumber,A.numberComparator));const x=new g.MonotonousArray(N);for(let D=0;D<L.length;D++){const T=L[D],k=x.findLastMonotonous(H=>H.original.startLineNumber<=T.original.startLineNumber),W=(0,g.findLastMonotonous)(N,H=>H.modified.startLineNumber<=T.modified.startLineNumber),j=Math.max(T.original.startLineNumber-k.original.startLineNumber,T.modified.startLineNumber-W.modified.startLineNumber),$=x.findLastMonotonous(H=>H.original.startLineNumber<T.original.endLineNumberExclusive),I=(0,g.findLastMonotonous)(N,H=>H.modified.startLineNumber<T.modified.endLineNumberExclusive),F=Math.max($.original.endLineNumberExclusive-T.original.endLineNumberExclusive,I.modified.endLineNumberExclusive-T.modified.endLineNumberExclusive);let O;for(O=0;O<j;O++){const H=T.original.startLineNumber-O-1,U=T.modified.startLineNumber-O-1;if(H>i.length||U>a.length||R.contains(U)||E.contains(H)||!d(i[H-1],a[U-1],m))break}O>0&&(E.addRange(new p.LineRange(T.original.startLineNumber-O,T.original.startLineNumber)),R.addRange(new p.LineRange(T.modified.startLineNumber-O,T.modified.startLineNumber)));let V;for(V=0;V<F;V++){const H=T.original.endLineNumberExclusive+V,U=T.modified.endLineNumberExclusive+V;if(H>i.length||U>a.length||R.contains(U)||E.contains(H)||!d(i[H-1],a[U-1],m))break}V>0&&(E.addRange(new p.LineRange(T.original.endLineNumberExclusive,T.original.endLineNumberExclusive+V)),R.addRange(new p.LineRange(T.modified.endLineNumberExclusive,T.modified.endLineNumberExclusive+V))),(O>0||V>0)&&(L[D]=new M.LineRangeMapping(new p.LineRange(T.original.startLineNumber-O,T.original.endLineNumberExclusive+V),new p.LineRange(T.modified.startLineNumber-O,T.modified.endLineNumberExclusive+V)))}return L}function d(N,S,C){if(N.trim()===S.trim())return!0;if(N.length>300&&S.length>300)return!1;const a=new e.MyersDiffAlgorithm().compute(new l.LinesSliceCharSequence([N],new h.OffsetRange(0,1),!1),new l.LinesSliceCharSequence([S],new h.OffsetRange(0,1),!1),C);let m=0;const L=r.SequenceDiff.invert(a.diffs,N.length);for(const E of L)E.seq1Range.forEach(x=>{(0,w.isSpace)(N.charCodeAt(x))||m++});function c(E){let x=0;for(let D=0;D<N.length;D++)(0,w.isSpace)(E.charCodeAt(D))||x++;return x}const f=c(N.length>S.length?N:S);return m/f>.6&&f>10}function y(N){if(N.length===0)return N;N.sort((0,A.compareBy)(C=>C.original.startLineNumber,A.numberComparator));const S=[N[0]];for(let C=1;C<N.length;C++){const i=S[S.length-1],a=N[C],m=a.original.startLineNumber-i.original.endLineNumberExclusive,L=a.modified.startLineNumber-i.modified.endLineNumberExclusive;if(m>=0&&L>=0&&m+L<=2){S[S.length-1]=i.join(a);continue}S.push(a)}return S}function _(N,S){const C=new g.MonotonousArray(N);return S=S.filter(i=>{const a=C.findLastMonotonous(c=>c.original.startLineNumber<i.original.endLineNumberExclusive)||new M.LineRangeMapping(new p.LineRange(1,1),new p.LineRange(1,1)),m=(0,g.findLastMonotonous)(N,c=>c.modified.startLineNumber<i.modified.endLineNumberExclusive);return a!==m}),S}}),X(Z[49],K([0,1,7,12,10,3,2,8,47,30,48,45,46,31,32,16]),function(q,n,r,M,A,g,v,p,h,l,w,e,s,o,u,b){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.DefaultLinesDiffComputer=void 0,n.lineRangeMappingFromRangeMappings=y,n.getLineRangeMapping=_;class d{constructor(){this.dynamicProgrammingDiffing=new h.DynamicProgrammingDiffing,this.myersDiffingAlgorithm=new l.MyersDiffAlgorithm}computeDiff(S,C,i){if(S.length<=1&&(0,r.equals)(S,C,(V,H)=>V===H))return new u.LinesDiff([],[],!1);if(S.length===1&&S[0].length===0||C.length===1&&C[0].length===0)return new u.LinesDiff([new b.DetailedLineRangeMapping(new A.LineRange(1,S.length+1),new A.LineRange(1,C.length+1),[new b.RangeMapping(new v.Range(1,1,S.length,S[0].length+1),new v.Range(1,1,C.length,C[0].length+1))])],[],!1);const a=i.maxComputationTimeMs===0?p.InfiniteTimeout.instance:new p.DateTimeout(i.maxComputationTimeMs),m=!i.ignoreTrimWhitespace,L=new Map;function c(V){let H=L.get(V);return H===void 0&&(H=L.size,L.set(V,H)),H}const f=S.map(V=>c(V.trim())),R=C.map(V=>c(V.trim())),E=new s.LineSequence(f,S),x=new s.LineSequence(R,C),D=E.length+x.length<1700?this.dynamicProgrammingDiffing.compute(E,x,a,(V,H)=>S[V]===C[H]?C[H].length===0?.1:1+Math.log(1+C[H].length):.99):this.myersDiffingAlgorithm.compute(E,x);let T=D.diffs,k=D.hitTimeout;T=(0,e.optimizeSequenceDiffs)(E,x,T),T=(0,e.removeVeryShortMatchingLinesBetweenDiffs)(E,x,T);const W=[],j=V=>{if(m)for(let H=0;H<V;H++){const U=$+H,ie=I+H;if(S[U]!==C[ie]){const oe=this.refineDiff(S,C,new p.SequenceDiff(new g.OffsetRange(U,U+1),new g.OffsetRange(ie,ie+1)),a,m);for(const t of oe.mappings)W.push(t);oe.hitTimeout&&(k=!0)}}};let $=0,I=0;for(const V of T){(0,M.assertFn)(()=>V.seq1Range.start-$===V.seq2Range.start-I);const H=V.seq1Range.start-$;j(H),$=V.seq1Range.endExclusive,I=V.seq2Range.endExclusive;const U=this.refineDiff(S,C,V,a,m);U.hitTimeout&&(k=!0);for(const ie of U.mappings)W.push(ie)}j(S.length-$);const F=y(W,S,C);let O=[];return i.computeMoves&&(O=this.computeMoves(F,S,C,f,R,a,m)),(0,M.assertFn)(()=>{function V(U,ie){if(U.lineNumber<1||U.lineNumber>ie.length)return!1;const oe=ie[U.lineNumber-1];return!(U.column<1||U.column>oe.length+1)}function H(U,ie){return!(U.startLineNumber<1||U.startLineNumber>ie.length+1||U.endLineNumberExclusive<1||U.endLineNumberExclusive>ie.length+1)}for(const U of F){if(!U.innerChanges)return!1;for(const ie of U.innerChanges)if(!(V(ie.modifiedRange.getStartPosition(),C)&&V(ie.modifiedRange.getEndPosition(),C)&&V(ie.originalRange.getStartPosition(),S)&&V(ie.originalRange.getEndPosition(),S)))return!1;if(!H(U.modified,C)||!H(U.original,S))return!1}return!0}),new u.LinesDiff(F,O,k)}computeMoves(S,C,i,a,m,L,c){return(0,w.computeMovedLines)(S,C,i,a,m,L).map(E=>{const x=this.refineDiff(C,i,new p.SequenceDiff(E.original.toOffsetRange(),E.modified.toOffsetRange()),L,c),D=y(x.mappings,C,i,!0);return new u.MovedText(E,D)})}refineDiff(S,C,i,a,m){const L=new o.LinesSliceCharSequence(S,i.seq1Range,m),c=new o.LinesSliceCharSequence(C,i.seq2Range,m),f=L.length+c.length<500?this.dynamicProgrammingDiffing.compute(L,c,a):this.myersDiffingAlgorithm.compute(L,c,a);let R=f.diffs;return R=(0,e.optimizeSequenceDiffs)(L,c,R),R=(0,e.extendDiffsToEntireWordIfAppropriate)(L,c,R),R=(0,e.removeShortMatches)(L,c,R),R=(0,e.removeVeryShortMatchingTextBetweenLongDiffs)(L,c,R),{mappings:R.map(x=>new b.RangeMapping(L.translateRange(x.seq1Range),c.translateRange(x.seq2Range))),hitTimeout:f.hitTimeout}}}n.DefaultLinesDiffComputer=d;function y(N,S,C,i=!1){const a=[];for(const m of(0,r.groupAdjacentBy)(N.map(L=>_(L,S,C)),(L,c)=>L.original.overlapOrTouch(c.original)||L.modified.overlapOrTouch(c.modified))){const L=m[0],c=m[m.length-1];a.push(new b.DetailedLineRangeMapping(L.original.join(c.original),L.modified.join(c.modified),m.map(f=>f.innerChanges[0])))}return(0,M.assertFn)(()=>!i&&a.length>0&&(a[0].modified.startLineNumber!==a[0].original.startLineNumber||C.length-a[a.length-1].modified.endLineNumberExclusive!==S.length-a[a.length-1].original.endLineNumberExclusive)?!1:(0,M.checkAdjacentItems)(a,(m,L)=>L.original.startLineNumber-m.original.endLineNumberExclusive===L.modified.startLineNumber-m.modified.endLineNumberExclusive&&m.original.endLineNumberExclusive<L.original.startLineNumber&&m.modified.endLineNumberExclusive<L.modified.startLineNumber)),a}function _(N,S,C){let i=0,a=0;N.modifiedRange.endColumn===1&&N.originalRange.endColumn===1&&N.originalRange.startLineNumber+i<=N.originalRange.endLineNumber&&N.modifiedRange.startLineNumber+i<=N.modifiedRange.endLineNumber&&(a=-1),N.modifiedRange.startColumn-1>=C[N.modifiedRange.startLineNumber-1].length&&N.originalRange.startColumn-1>=S[N.originalRange.startLineNumber-1].length&&N.originalRange.startLineNumber<=N.originalRange.endLineNumber+a&&N.modifiedRange.startLineNumber<=N.modifiedRange.endLineNumber+a&&(i=1);const m=new A.LineRange(N.originalRange.startLineNumber+i,N.originalRange.endLineNumber+1+a),L=new A.LineRange(N.modifiedRange.startLineNumber+i,N.modifiedRange.endLineNumber+1+a);return new b.DetailedLineRangeMapping(m,L,[N])}}),X(Z[50],K([0,1,24,32,16,6,2,12,10]),function(q,n,r,M,A,g,v,p,h){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.DiffComputer=n.LegacyLinesDiffComputer=void 0;const l=3;class w{computeDiff(i,a,m){var L;const f=new y(i,a,{maxComputationTime:m.maxComputationTimeMs,shouldIgnoreTrimWhitespace:m.ignoreTrimWhitespace,shouldComputeCharChanges:!0,shouldMakePrettyDiff:!0,shouldPostProcessCharChanges:!0}).computeDiff(),R=[];let E=null;for(const x of f.changes){let D;x.originalEndLineNumber===0?D=new h.LineRange(x.originalStartLineNumber+1,x.originalStartLineNumber+1):D=new h.LineRange(x.originalStartLineNumber,x.originalEndLineNumber+1);let T;x.modifiedEndLineNumber===0?T=new h.LineRange(x.modifiedStartLineNumber+1,x.modifiedStartLineNumber+1):T=new h.LineRange(x.modifiedStartLineNumber,x.modifiedEndLineNumber+1);let k=new A.DetailedLineRangeMapping(D,T,(L=x.charChanges)===null||L===void 0?void 0:L.map(W=>new A.RangeMapping(new v.Range(W.originalStartLineNumber,W.originalStartColumn,W.originalEndLineNumber,W.originalEndColumn),new v.Range(W.modifiedStartLineNumber,W.modifiedStartColumn,W.modifiedEndLineNumber,W.modifiedEndColumn))));E&&(E.modified.endLineNumberExclusive===k.modified.startLineNumber||E.original.endLineNumberExclusive===k.original.startLineNumber)&&(k=new A.DetailedLineRangeMapping(E.original.join(k.original),E.modified.join(k.modified),E.innerChanges&&k.innerChanges?E.innerChanges.concat(k.innerChanges):void 0),R.pop()),R.push(k),E=k}return(0,p.assertFn)(()=>(0,p.checkAdjacentItems)(R,(x,D)=>D.original.startLineNumber-x.original.endLineNumberExclusive===D.modified.startLineNumber-x.modified.endLineNumberExclusive&&x.original.endLineNumberExclusive<D.original.startLineNumber&&x.modified.endLineNumberExclusive<D.modified.startLineNumber)),new M.LinesDiff(R,[],f.quitEarly)}}n.LegacyLinesDiffComputer=w;function e(C,i,a,m){return new r.LcsDiff(C,i,a).ComputeDiff(m)}class s{constructor(i){const a=[],m=[];for(let L=0,c=i.length;L<c;L++)a[L]=_(i[L],1),m[L]=N(i[L],1);this.lines=i,this._startColumns=a,this._endColumns=m}getElements(){const i=[];for(let a=0,m=this.lines.length;a<m;a++)i[a]=this.lines[a].substring(this._startColumns[a]-1,this._endColumns[a]-1);return i}getStrictElement(i){return this.lines[i]}getStartLineNumber(i){return i+1}getEndLineNumber(i){return i+1}createCharSequence(i,a,m){const L=[],c=[],f=[];let R=0;for(let E=a;E<=m;E++){const x=this.lines[E],D=i?this._startColumns[E]:1,T=i?this._endColumns[E]:x.length+1;for(let k=D;k<T;k++)L[R]=x.charCodeAt(k-1),c[R]=E+1,f[R]=k,R++;!i&&E<m&&(L[R]=10,c[R]=E+1,f[R]=x.length+1,R++)}return new o(L,c,f)}}class o{constructor(i,a,m){this._charCodes=i,this._lineNumbers=a,this._columns=m}toString(){return"["+this._charCodes.map((i,a)=>(i===10?"\\n":String.fromCharCode(i))+`-(${this._lineNumbers[a]},${this._columns[a]})`).join(", ")+"]"}_assertIndex(i,a){if(i<0||i>=a.length)throw new Error("Illegal index")}getElements(){return this._charCodes}getStartLineNumber(i){return i>0&&i===this._lineNumbers.length?this.getEndLineNumber(i-1):(this._assertIndex(i,this._lineNumbers),this._lineNumbers[i])}getEndLineNumber(i){return i===-1?this.getStartLineNumber(i+1):(this._assertIndex(i,this._lineNumbers),this._charCodes[i]===10?this._lineNumbers[i]+1:this._lineNumbers[i])}getStartColumn(i){return i>0&&i===this._columns.length?this.getEndColumn(i-1):(this._assertIndex(i,this._columns),this._columns[i])}getEndColumn(i){return i===-1?this.getStartColumn(i+1):(this._assertIndex(i,this._columns),this._charCodes[i]===10?1:this._columns[i]+1)}}class u{constructor(i,a,m,L,c,f,R,E){this.originalStartLineNumber=i,this.originalStartColumn=a,this.originalEndLineNumber=m,this.originalEndColumn=L,this.modifiedStartLineNumber=c,this.modifiedStartColumn=f,this.modifiedEndLineNumber=R,this.modifiedEndColumn=E}static createFromDiffChange(i,a,m){const L=a.getStartLineNumber(i.originalStart),c=a.getStartColumn(i.originalStart),f=a.getEndLineNumber(i.originalStart+i.originalLength-1),R=a.getEndColumn(i.originalStart+i.originalLength-1),E=m.getStartLineNumber(i.modifiedStart),x=m.getStartColumn(i.modifiedStart),D=m.getEndLineNumber(i.modifiedStart+i.modifiedLength-1),T=m.getEndColumn(i.modifiedStart+i.modifiedLength-1);return new u(L,c,f,R,E,x,D,T)}}function b(C){if(C.length<=1)return C;const i=[C[0]];let a=i[0];for(let m=1,L=C.length;m<L;m++){const c=C[m],f=c.originalStart-(a.originalStart+a.originalLength),R=c.modifiedStart-(a.modifiedStart+a.modifiedLength);Math.min(f,R)<l?(a.originalLength=c.originalStart+c.originalLength-a.originalStart,a.modifiedLength=c.modifiedStart+c.modifiedLength-a.modifiedStart):(i.push(c),a=c)}return i}class d{constructor(i,a,m,L,c){this.originalStartLineNumber=i,this.originalEndLineNumber=a,this.modifiedStartLineNumber=m,this.modifiedEndLineNumber=L,this.charChanges=c}static createFromDiffResult(i,a,m,L,c,f,R){let E,x,D,T,k;if(a.originalLength===0?(E=m.getStartLineNumber(a.originalStart)-1,x=0):(E=m.getStartLineNumber(a.originalStart),x=m.getEndLineNumber(a.originalStart+a.originalLength-1)),a.modifiedLength===0?(D=L.getStartLineNumber(a.modifiedStart)-1,T=0):(D=L.getStartLineNumber(a.modifiedStart),T=L.getEndLineNumber(a.modifiedStart+a.modifiedLength-1)),f&&a.originalLength>0&&a.originalLength<20&&a.modifiedLength>0&&a.modifiedLength<20&&c()){const W=m.createCharSequence(i,a.originalStart,a.originalStart+a.originalLength-1),j=L.createCharSequence(i,a.modifiedStart,a.modifiedStart+a.modifiedLength-1);if(W.getElements().length>0&&j.getElements().length>0){let $=e(W,j,c,!0).changes;R&&($=b($)),k=[];for(let I=0,F=$.length;I<F;I++)k.push(u.createFromDiffChange($[I],W,j))}}return new d(E,x,D,T,k)}}class y{constructor(i,a,m){this.shouldComputeCharChanges=m.shouldComputeCharChanges,this.shouldPostProcessCharChanges=m.shouldPostProcessCharChanges,this.shouldIgnoreTrimWhitespace=m.shouldIgnoreTrimWhitespace,this.shouldMakePrettyDiff=m.shouldMakePrettyDiff,this.originalLines=i,this.modifiedLines=a,this.original=new s(i),this.modified=new s(a),this.continueLineDiff=S(m.maxComputationTime),this.continueCharDiff=S(m.maxComputationTime===0?0:Math.min(m.maxComputationTime,5e3))}computeDiff(){if(this.original.lines.length===1&&this.original.lines[0].length===0)return this.modified.lines.length===1&&this.modified.lines[0].length===0?{quitEarly:!1,changes:[]}:{quitEarly:!1,changes:[{originalStartLineNumber:1,originalEndLineNumber:1,modifiedStartLineNumber:1,modifiedEndLineNumber:this.modified.lines.length,charChanges:void 0}]};if(this.modified.lines.length===1&&this.modified.lines[0].length===0)return{quitEarly:!1,changes:[{originalStartLineNumber:1,originalEndLineNumber:this.original.lines.length,modifiedStartLineNumber:1,modifiedEndLineNumber:1,charChanges:void 0}]};const i=e(this.original,this.modified,this.continueLineDiff,this.shouldMakePrettyDiff),a=i.changes,m=i.quitEarly;if(this.shouldIgnoreTrimWhitespace){const R=[];for(let E=0,x=a.length;E<x;E++)R.push(d.createFromDiffResult(this.shouldIgnoreTrimWhitespace,a[E],this.original,this.modified,this.continueCharDiff,this.shouldComputeCharChanges,this.shouldPostProcessCharChanges));return{quitEarly:m,changes:R}}const L=[];let c=0,f=0;for(let R=-1,E=a.length;R<E;R++){const x=R+1<E?a[R+1]:null,D=x?x.originalStart:this.originalLines.length,T=x?x.modifiedStart:this.modifiedLines.length;for(;c<D&&f<T;){const k=this.originalLines[c],W=this.modifiedLines[f];if(k!==W){{let j=_(k,1),$=_(W,1);for(;j>1&&$>1;){const I=k.charCodeAt(j-2),F=W.charCodeAt($-2);if(I!==F)break;j--,$--}(j>1||$>1)&&this._pushTrimWhitespaceCharChange(L,c+1,1,j,f+1,1,$)}{let j=N(k,1),$=N(W,1);const I=k.length+1,F=W.length+1;for(;j<I&&$<F;){const O=k.charCodeAt(j-1),V=k.charCodeAt($-1);if(O!==V)break;j++,$++}(j<I||$<F)&&this._pushTrimWhitespaceCharChange(L,c+1,j,I,f+1,$,F)}}c++,f++}x&&(L.push(d.createFromDiffResult(this.shouldIgnoreTrimWhitespace,x,this.original,this.modified,this.continueCharDiff,this.shouldComputeCharChanges,this.shouldPostProcessCharChanges)),c+=x.originalLength,f+=x.modifiedLength)}return{quitEarly:m,changes:L}}_pushTrimWhitespaceCharChange(i,a,m,L,c,f,R){if(this._mergeTrimWhitespaceCharChange(i,a,m,L,c,f,R))return;let E;this.shouldComputeCharChanges&&(E=[new u(a,m,a,L,c,f,c,R)]),i.push(new d(a,a,c,c,E))}_mergeTrimWhitespaceCharChange(i,a,m,L,c,f,R){const E=i.length;if(E===0)return!1;const x=i[E-1];return x.originalEndLineNumber===0||x.modifiedEndLineNumber===0?!1:x.originalEndLineNumber===a&&x.modifiedEndLineNumber===c?(this.shouldComputeCharChanges&&x.charChanges&&x.charChanges.push(new u(a,m,a,L,c,f,c,R)),!0):x.originalEndLineNumber+1===a&&x.modifiedEndLineNumber+1===c?(x.originalEndLineNumber=a,x.modifiedEndLineNumber=c,this.shouldComputeCharChanges&&x.charChanges&&x.charChanges.push(new u(a,m,a,L,c,f,c,R)),!0):!1}}n.DiffComputer=y;function _(C,i){const a=g.firstNonWhitespaceIndex(C);return a===-1?i:a+1}function N(C,i){const a=g.lastNonWhitespaceIndex(C);return a===-1?i:a+2}function S(C){if(C===0)return()=>!0;const i=Date.now();return()=>Date.now()-i<C}}),X(Z[51],K([0,1,50,49]),function(q,n,r,M){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.linesDiffComputers=void 0,n.linesDiffComputers={getLegacy:()=>new r.LegacyLinesDiffComputer,getDefault:()=>new M.DefaultLinesDiffComputer}}),X(Z[52],K([0,1,34]),function(q,n,r){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.computeDefaultDocumentColors=e;function M(s){const o=[];for(const u of s){const b=Number(u);(b||b===0&&u.replace(/\s/g,"")!=="")&&o.push(b)}return o}function A(s,o,u,b){return{red:s/255,blue:u/255,green:o/255,alpha:b}}function g(s,o){const u=o.index,b=o[0].length;if(!u)return;const d=s.positionAt(u);return{startLineNumber:d.lineNumber,startColumn:d.column,endLineNumber:d.lineNumber,endColumn:d.column+b}}function v(s,o){if(!s)return;const u=r.Color.Format.CSS.parseHex(o);if(u)return{range:s,color:A(u.rgba.r,u.rgba.g,u.rgba.b,u.rgba.a)}}function p(s,o,u){if(!s||o.length!==1)return;const d=o[0].values(),y=M(d);return{range:s,color:A(y[0],y[1],y[2],u?y[3]:1)}}function h(s,o,u){if(!s||o.length!==1)return;const d=o[0].values(),y=M(d),_=new r.Color(new r.HSLA(y[0],y[1]/100,y[2]/100,u?y[3]:1));return{range:s,color:A(_.rgba.r,_.rgba.g,_.rgba.b,_.rgba.a)}}function l(s,o){return typeof s=="string"?[...s.matchAll(o)]:s.findMatches(o)}function w(s){const o=[],b=l(s,/\b(rgb|rgba|hsl|hsla)(\([0-9\s,.\%]*\))|(#)([A-Fa-f0-9]{3})\b|(#)([A-Fa-f0-9]{4})\b|(#)([A-Fa-f0-9]{6})\b|(#)([A-Fa-f0-9]{8})\b/gm);if(b.length>0)for(const d of b){const y=d.filter(C=>C!==void 0),_=y[1],N=y[2];if(!N)continue;let S;if(_==="rgb"){const C=/^\(\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*\)$/gm;S=p(g(s,d),l(N,C),!1)}else if(_==="rgba"){const C=/^\(\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(0[.][0-9]+|[.][0-9]+|[01][.]|[01])\s*\)$/gm;S=p(g(s,d),l(N,C),!0)}else if(_==="hsl"){const C=/^\(\s*(36[0]|3[0-5][0-9]|[12][0-9][0-9]|[1-9]?[0-9])\s*,\s*(100|\d{1,2}[.]\d*|\d{1,2})%\s*,\s*(100|\d{1,2}[.]\d*|\d{1,2})%\s*\)$/gm;S=h(g(s,d),l(N,C),!1)}else if(_==="hsla"){const C=/^\(\s*(36[0]|3[0-5][0-9]|[12][0-9][0-9]|[1-9]?[0-9])\s*,\s*(100|\d{1,2}[.]\d*|\d{1,2})%\s*,\s*(100|\d{1,2}[.]\d*|\d{1,2})%\s*,\s*(0[.][0-9]+|[.][0-9]+|[01][.]|[01])\s*\)$/gm;S=h(g(s,d),l(N,C),!0)}else _==="#"&&(S=v(g(s,d),_+N));S&&o.push(S)}return o}function e(s){return!s||typeof s.getValue!="function"||typeof s.positionAt!="function"?[]:w(s)}}),X(Z[53],K([0,1,28]),function(q,n,r){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.LinkComputer=n.StateMachine=void 0,n.computeLinks=w;class M{constructor(s,o,u){const b=new Uint8Array(s*o);for(let d=0,y=s*o;d<y;d++)b[d]=u;this._data=b,this.rows=s,this.cols=o}get(s,o){return this._data[s*this.cols+o]}set(s,o,u){this._data[s*this.cols+o]=u}}class A{constructor(s){let o=0,u=0;for(let d=0,y=s.length;d<y;d++){const[_,N,S]=s[d];N>o&&(o=N),_>u&&(u=_),S>u&&(u=S)}o++,u++;const b=new M(u,o,0);for(let d=0,y=s.length;d<y;d++){const[_,N,S]=s[d];b.set(_,N,S)}this._states=b,this._maxCharCode=o}nextState(s,o){return o<0||o>=this._maxCharCode?0:this._states.get(s,o)}}n.StateMachine=A;let g=null;function v(){return g===null&&(g=new A([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),g}let p=null;function h(){if(p===null){p=new r.CharacterClassifier(0);const e=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let o=0;o<e.length;o++)p.set(e.charCodeAt(o),1);const s=".,;:";for(let o=0;o<s.length;o++)p.set(s.charCodeAt(o),2)}return p}class l{static _createLink(s,o,u,b,d){let y=d-1;do{const _=o.charCodeAt(y);if(s.get(_)!==2)break;y--}while(y>b);if(b>0){const _=o.charCodeAt(b-1),N=o.charCodeAt(y);(_===40&&N===41||_===91&&N===93||_===123&&N===125)&&y--}return{range:{startLineNumber:u,startColumn:b+1,endLineNumber:u,endColumn:y+2},url:o.substring(b,y+1)}}static computeLinks(s,o=v()){const u=h(),b=[];for(let d=1,y=s.getLineCount();d<=y;d++){const _=s.getLineContent(d),N=_.length;let S=0,C=0,i=0,a=1,m=!1,L=!1,c=!1,f=!1;for(;S<N;){let R=!1;const E=_.charCodeAt(S);if(a===13){let x;switch(E){case 40:m=!0,x=0;break;case 41:x=m?0:1;break;case 91:c=!0,L=!0,x=0;break;case 93:c=!1,x=L?0:1;break;case 123:f=!0,x=0;break;case 125:x=f?0:1;break;case 39:case 34:case 96:i===E?x=1:i===39||i===34||i===96?x=0:x=1;break;case 42:x=i===42?1:0;break;case 124:x=i===124?1:0;break;case 32:x=c?0:1;break;default:x=u.get(E)}x===1&&(b.push(l._createLink(u,_,d,C,S)),R=!0)}else if(a===12){let x;E===91?(L=!0,x=0):x=u.get(E),x===1?R=!0:a=13}else a=o.nextState(a,E),a===0&&(R=!0);R&&(a=1,m=!1,L=!1,f=!1,C=S+1,i=E),S++}a===13&&b.push(l._createLink(u,_,d,C,N))}return b}}n.LinkComputer=l;function w(e){return!e||typeof e.getLineCount!="function"||typeof e.getLineContent!="function"?[]:l.computeLinks(e)}}),X(Z[54],K([0,1]),function(q,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.BasicInplaceReplace=void 0;class r{constructor(){this._defaultValueSet=[["true","false"],["True","False"],["Private","Public","Friend","ReadOnly","Partial","Protected","WriteOnly"],["public","protected","private"]]}navigateValueSet(A,g,v,p,h){if(A&&g){const l=this.doNavigateValueSet(g,h);if(l)return{range:A,value:l}}if(v&&p){const l=this.doNavigateValueSet(p,h);if(l)return{range:v,value:l}}return null}doNavigateValueSet(A,g){const v=this.numberReplace(A,g);return v!==null?v:this.textReplace(A,g)}numberReplace(A,g){const v=Math.pow(10,A.length-(A.lastIndexOf(".")+1));let p=Number(A);const h=parseFloat(A);return!isNaN(p)&&!isNaN(h)&&p===h?p===0&&!g?null:(p=Math.floor(p*v),p+=g?v:-v,String(p/v)):null}textReplace(A,g){return this.valueSetsReplace(this._defaultValueSet,A,g)}valueSetsReplace(A,g,v){let p=null;for(let h=0,l=A.length;p===null&&h<l;h++)p=this.valueSetReplace(A[h],g,v);return p}valueSetReplace(A,g,v){let p=A.indexOf(g);return p>=0?(p+=v?1:-1,p<0?p=A.length-1:p%=A.length,A[p]):null}}n.BasicInplaceReplace=r,r.INSTANCE=new r}),X(Z[55],K([0,1,14]),function(q,n,r){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.ApplyEditsResult=n.SearchData=n.ValidAnnotatedEditOperation=n.FindMatch=n.TextModelResolvedOptions=n.InjectedTextCursorStops=n.MinimapPosition=n.GlyphMarginLane=n.OverviewRulerLane=void 0,n.isITextSnapshot=l,n.shouldSynchronizeModel=o;var M;(function(u){u[u.Left=1]="Left",u[u.Center=2]="Center",u[u.Right=4]="Right",u[u.Full=7]="Full"})(M||(n.OverviewRulerLane=M={}));var A;(function(u){u[u.Left=1]="Left",u[u.Center=2]="Center",u[u.Right=3]="Right"})(A||(n.GlyphMarginLane=A={}));var g;(function(u){u[u.Inline=1]="Inline",u[u.Gutter=2]="Gutter"})(g||(n.MinimapPosition=g={}));var v;(function(u){u[u.Both=0]="Both",u[u.Right=1]="Right",u[u.Left=2]="Left",u[u.None=3]="None"})(v||(n.InjectedTextCursorStops=v={}));class p{get originalIndentSize(){return this._indentSizeIsTabSize?"tabSize":this.indentSize}constructor(b){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,b.tabSize|0),b.indentSize==="tabSize"?(this.indentSize=this.tabSize,this._indentSizeIsTabSize=!0):(this.indentSize=Math.max(1,b.indentSize|0),this._indentSizeIsTabSize=!1),this.insertSpaces=!!b.insertSpaces,this.defaultEOL=b.defaultEOL|0,this.trimAutoWhitespace=!!b.trimAutoWhitespace,this.bracketPairColorizationOptions=b.bracketPairColorizationOptions}equals(b){return this.tabSize===b.tabSize&&this._indentSizeIsTabSize===b._indentSizeIsTabSize&&this.indentSize===b.indentSize&&this.insertSpaces===b.insertSpaces&&this.defaultEOL===b.defaultEOL&&this.trimAutoWhitespace===b.trimAutoWhitespace&&(0,r.equals)(this.bracketPairColorizationOptions,b.bracketPairColorizationOptions)}createChangeEvent(b){return{tabSize:this.tabSize!==b.tabSize,indentSize:this.indentSize!==b.indentSize,insertSpaces:this.insertSpaces!==b.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==b.trimAutoWhitespace}}}n.TextModelResolvedOptions=p;class h{constructor(b,d){this._findMatchBrand=void 0,this.range=b,this.matches=d}}n.FindMatch=h;function l(u){return u&&typeof u.read=="function"}class w{constructor(b,d,y,_,N,S){this.identifier=b,this.range=d,this.text=y,this.forceMoveMarkers=_,this.isAutoWhitespaceEdit=N,this._isTracked=S}}n.ValidAnnotatedEditOperation=w;class e{constructor(b,d,y){this.regex=b,this.wordSeparators=d,this.simpleSearch=y}}n.SearchData=e;class s{constructor(b,d,y){this.reverseEdits=b,this.changes=d,this.trimAutoWhitespaceLineNumbers=y}}n.ApplyEditsResult=s;function o(u){return!u.isTooLargeForSyncing()&&!u.isForSimpleWidget}}),X(Z[56],K([0,1,7,27]),function(q,n,r,M){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.PrefixSumIndexOfResult=n.ConstantTimePrefixSumComputer=n.PrefixSumComputer=void 0;class A{constructor(h){this.values=h,this.prefixSum=new Uint32Array(h.length),this.prefixSumValidIndex=new Int32Array(1),this.prefixSumValidIndex[0]=-1}insertValues(h,l){h=(0,M.toUint32)(h);const w=this.values,e=this.prefixSum,s=l.length;return s===0?!1:(this.values=new Uint32Array(w.length+s),this.values.set(w.subarray(0,h),0),this.values.set(w.subarray(h),h+s),this.values.set(l,h),h-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=h-1),this.prefixSum=new Uint32Array(this.values.length),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(e.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}setValue(h,l){return h=(0,M.toUint32)(h),l=(0,M.toUint32)(l),this.values[h]===l?!1:(this.values[h]=l,h-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=h-1),!0)}removeValues(h,l){h=(0,M.toUint32)(h),l=(0,M.toUint32)(l);const w=this.values,e=this.prefixSum;if(h>=w.length)return!1;const s=w.length-h;return l>=s&&(l=s),l===0?!1:(this.values=new Uint32Array(w.length-l),this.values.set(w.subarray(0,h),0),this.values.set(w.subarray(h+l),h),this.prefixSum=new Uint32Array(this.values.length),h-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=h-1),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(e.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}getTotalSum(){return this.values.length===0?0:this._getPrefixSum(this.values.length-1)}getPrefixSum(h){return h<0?0:(h=(0,M.toUint32)(h),this._getPrefixSum(h))}_getPrefixSum(h){if(h<=this.prefixSumValidIndex[0])return this.prefixSum[h];let l=this.prefixSumValidIndex[0]+1;l===0&&(this.prefixSum[0]=this.values[0],l++),h>=this.values.length&&(h=this.values.length-1);for(let w=l;w<=h;w++)this.prefixSum[w]=this.prefixSum[w-1]+this.values[w];return this.prefixSumValidIndex[0]=Math.max(this.prefixSumValidIndex[0],h),this.prefixSum[h]}getIndexOf(h){h=Math.floor(h),this.getTotalSum();let l=0,w=this.values.length-1,e=0,s=0,o=0;for(;l<=w;)if(e=l+(w-l)/2|0,s=this.prefixSum[e],o=s-this.values[e],h<o)w=e-1;else if(h>=s)l=e+1;else break;return new v(e,h-o)}}n.PrefixSumComputer=A;class g{constructor(h){this._values=h,this._isValid=!1,this._validEndIndex=-1,this._prefixSum=[],this._indexBySum=[]}getTotalSum(){return this._ensureValid(),this._indexBySum.length}getPrefixSum(h){return this._ensureValid(),h===0?0:this._prefixSum[h-1]}getIndexOf(h){this._ensureValid();const l=this._indexBySum[h],w=l>0?this._prefixSum[l-1]:0;return new v(l,h-w)}removeValues(h,l){this._values.splice(h,l),this._invalidate(h)}insertValues(h,l){this._values=(0,r.arrayInsert)(this._values,h,l),this._invalidate(h)}_invalidate(h){this._isValid=!1,this._validEndIndex=Math.min(this._validEndIndex,h-1)}_ensureValid(){if(!this._isValid){for(let h=this._validEndIndex+1,l=this._values.length;h<l;h++){const w=this._values[h],e=h>0?this._prefixSum[h-1]:0;this._prefixSum[h]=e+w;for(let s=0;s<w;s++)this._indexBySum[e+s]=h}this._prefixSum.length=this._values.length,this._indexBySum.length=this._prefixSum[this._prefixSum.length-1],this._isValid=!0,this._validEndIndex=this._values.length-1}}setValue(h,l){this._values[h]!==l&&(this._values[h]=l,this._invalidate(h))}}n.ConstantTimePrefixSumComputer=g;class v{constructor(h,l){this.index=h,this.remainder=l,this._prefixSumIndexOfResultBrand=void 0,this.index=h,this.remainder=l}}n.PrefixSumIndexOfResult=v}),X(Z[57],K([0,1,6,4,56]),function(q,n,r,M,A){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.MirrorTextModel=void 0;class g{constructor(p,h,l,w){this._uri=p,this._lines=h,this._eol=l,this._versionId=w,this._lineStarts=null,this._cachedTextValue=null}dispose(){this._lines.length=0}get version(){return this._versionId}getText(){return this._cachedTextValue===null&&(this._cachedTextValue=this._lines.join(this._eol)),this._cachedTextValue}onEvents(p){p.eol&&p.eol!==this._eol&&(this._eol=p.eol,this._lineStarts=null);const h=p.changes;for(const l of h)this._acceptDeleteRange(l.range),this._acceptInsertText(new M.Position(l.range.startLineNumber,l.range.startColumn),l.text);this._versionId=p.versionId,this._cachedTextValue=null}_ensureLineStarts(){if(!this._lineStarts){const p=this._eol.length,h=this._lines.length,l=new Uint32Array(h);for(let w=0;w<h;w++)l[w]=this._lines[w].length+p;this._lineStarts=new A.PrefixSumComputer(l)}}_setLineText(p,h){this._lines[p]=h,this._lineStarts&&this._lineStarts.setValue(p,this._lines[p].length+this._eol.length)}_acceptDeleteRange(p){if(p.startLineNumber===p.endLineNumber){if(p.startColumn===p.endColumn)return;this._setLineText(p.startLineNumber-1,this._lines[p.startLineNumber-1].substring(0,p.startColumn-1)+this._lines[p.startLineNumber-1].substring(p.endColumn-1));return}this._setLineText(p.startLineNumber-1,this._lines[p.startLineNumber-1].substring(0,p.startColumn-1)+this._lines[p.endLineNumber-1].substring(p.endColumn-1)),this._lines.splice(p.startLineNumber,p.endLineNumber-p.startLineNumber),this._lineStarts&&this._lineStarts.removeValues(p.startLineNumber,p.endLineNumber-p.startLineNumber)}_acceptInsertText(p,h){if(h.length===0)return;const l=(0,r.splitLines)(h);if(l.length===1){this._setLineText(p.lineNumber-1,this._lines[p.lineNumber-1].substring(0,p.column-1)+l[0]+this._lines[p.lineNumber-1].substring(p.column-1));return}l[l.length-1]+=this._lines[p.lineNumber-1].substring(p.column-1),this._setLineText(p.lineNumber-1,this._lines[p.lineNumber-1].substring(0,p.column-1)+l[0]);const w=new Uint32Array(l.length-1);for(let e=1;e<l.length;e++)this._lines.splice(p.lineNumber+e-1,0,l[e]),w[e-1]=l[e].length+this._eol.length;this._lineStarts&&this._lineStarts.insertValues(p.lineNumber,w)}}n.MirrorTextModel=g}),X(Z[58],K([0,1,6,44,4,2,55]),function(q,n,r,M,A,g,v){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.Searcher=n.TextModelSearch=n.SearchParams=void 0,n.isMultilineRegexSource=l,n.createFindMatch=w,n.isValidMatch=b;const p=999;class h{constructor(_,N,S,C){this.searchString=_,this.isRegex=N,this.matchCase=S,this.wordSeparators=C}parseSearchRequest(){if(this.searchString==="")return null;let _;this.isRegex?_=l(this.searchString):_=this.searchString.indexOf(`
`)>=0;let N=null;try{N=r.createRegExp(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:_,global:!0,unicode:!0})}catch{return null}if(!N)return null;let S=!this.isRegex&&!_;return S&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(S=this.matchCase),new v.SearchData(N,this.wordSeparators?(0,M.getMapForWordSeparators)(this.wordSeparators):null,S?this.searchString:null)}}n.SearchParams=h;function l(y){if(!y||y.length===0)return!1;for(let _=0,N=y.length;_<N;_++){const S=y.charCodeAt(_);if(S===10)return!0;if(S===92){if(_++,_>=N)break;const C=y.charCodeAt(_);if(C===110||C===114||C===87)return!0}}return!1}function w(y,_,N){if(!N)return new v.FindMatch(y,null);const S=[];for(let C=0,i=_.length;C<i;C++)S[C]=_[C];return new v.FindMatch(y,S)}class e{constructor(_){const N=[];let S=0;for(let C=0,i=_.length;C<i;C++)_.charCodeAt(C)===10&&(N[S++]=C);this._lineFeedsOffsets=N}findLineFeedCountBeforeOffset(_){const N=this._lineFeedsOffsets;let S=0,C=N.length-1;if(C===-1||_<=N[0])return 0;for(;S<C;){const i=S+((C-S)/2>>0);N[i]>=_?C=i-1:N[i+1]>=_?(S=i,C=i):S=i+1}return S+1}}class s{static findMatches(_,N,S,C,i){const a=N.parseSearchRequest();return a?a.regex.multiline?this._doFindMatchesMultiline(_,S,new d(a.wordSeparators,a.regex),C,i):this._doFindMatchesLineByLine(_,S,a,C,i):[]}static _getMultilineMatchRange(_,N,S,C,i,a){let m,L=0;C?(L=C.findLineFeedCountBeforeOffset(i),m=N+i+L):m=N+i;let c;if(C){const x=C.findLineFeedCountBeforeOffset(i+a.length)-L;c=m+a.length+x}else c=m+a.length;const f=_.getPositionAt(m),R=_.getPositionAt(c);return new g.Range(f.lineNumber,f.column,R.lineNumber,R.column)}static _doFindMatchesMultiline(_,N,S,C,i){const a=_.getOffsetAt(N.getStartPosition()),m=_.getValueInRange(N,1),L=_.getEOL()===`\r
`?new e(m):null,c=[];let f=0,R;for(S.reset(0);R=S.next(m);)if(c[f++]=w(this._getMultilineMatchRange(_,a,m,L,R.index,R[0]),R,C),f>=i)return c;return c}static _doFindMatchesLineByLine(_,N,S,C,i){const a=[];let m=0;if(N.startLineNumber===N.endLineNumber){const c=_.getLineContent(N.startLineNumber).substring(N.startColumn-1,N.endColumn-1);return m=this._findMatchesInLine(S,c,N.startLineNumber,N.startColumn-1,m,a,C,i),a}const L=_.getLineContent(N.startLineNumber).substring(N.startColumn-1);m=this._findMatchesInLine(S,L,N.startLineNumber,N.startColumn-1,m,a,C,i);for(let c=N.startLineNumber+1;c<N.endLineNumber&&m<i;c++)m=this._findMatchesInLine(S,_.getLineContent(c),c,0,m,a,C,i);if(m<i){const c=_.getLineContent(N.endLineNumber).substring(0,N.endColumn-1);m=this._findMatchesInLine(S,c,N.endLineNumber,0,m,a,C,i)}return a}static _findMatchesInLine(_,N,S,C,i,a,m,L){const c=_.wordSeparators;if(!m&&_.simpleSearch){const E=_.simpleSearch,x=E.length,D=N.length;let T=-x;for(;(T=N.indexOf(E,T+x))!==-1;)if((!c||b(c,N,D,T,x))&&(a[i++]=new v.FindMatch(new g.Range(S,T+1+C,S,T+1+x+C),null),i>=L))return i;return i}const f=new d(_.wordSeparators,_.regex);let R;f.reset(0);do if(R=f.next(N),R&&(a[i++]=w(new g.Range(S,R.index+1+C,S,R.index+1+R[0].length+C),R,m),i>=L))return i;while(R);return i}static findNextMatch(_,N,S,C){const i=N.parseSearchRequest();if(!i)return null;const a=new d(i.wordSeparators,i.regex);return i.regex.multiline?this._doFindNextMatchMultiline(_,S,a,C):this._doFindNextMatchLineByLine(_,S,a,C)}static _doFindNextMatchMultiline(_,N,S,C){const i=new A.Position(N.lineNumber,1),a=_.getOffsetAt(i),m=_.getLineCount(),L=_.getValueInRange(new g.Range(i.lineNumber,i.column,m,_.getLineMaxColumn(m)),1),c=_.getEOL()===`\r
`?new e(L):null;S.reset(N.column-1);const f=S.next(L);return f?w(this._getMultilineMatchRange(_,a,L,c,f.index,f[0]),f,C):N.lineNumber!==1||N.column!==1?this._doFindNextMatchMultiline(_,new A.Position(1,1),S,C):null}static _doFindNextMatchLineByLine(_,N,S,C){const i=_.getLineCount(),a=N.lineNumber,m=_.getLineContent(a),L=this._findFirstMatchInLine(S,m,a,N.column,C);if(L)return L;for(let c=1;c<=i;c++){const f=(a+c-1)%i,R=_.getLineContent(f+1),E=this._findFirstMatchInLine(S,R,f+1,1,C);if(E)return E}return null}static _findFirstMatchInLine(_,N,S,C,i){_.reset(C-1);const a=_.next(N);return a?w(new g.Range(S,a.index+1,S,a.index+1+a[0].length),a,i):null}static findPreviousMatch(_,N,S,C){const i=N.parseSearchRequest();if(!i)return null;const a=new d(i.wordSeparators,i.regex);return i.regex.multiline?this._doFindPreviousMatchMultiline(_,S,a,C):this._doFindPreviousMatchLineByLine(_,S,a,C)}static _doFindPreviousMatchMultiline(_,N,S,C){const i=this._doFindMatchesMultiline(_,new g.Range(1,1,N.lineNumber,N.column),S,C,10*p);if(i.length>0)return i[i.length-1];const a=_.getLineCount();return N.lineNumber!==a||N.column!==_.getLineMaxColumn(a)?this._doFindPreviousMatchMultiline(_,new A.Position(a,_.getLineMaxColumn(a)),S,C):null}static _doFindPreviousMatchLineByLine(_,N,S,C){const i=_.getLineCount(),a=N.lineNumber,m=_.getLineContent(a).substring(0,N.column-1),L=this._findLastMatchInLine(S,m,a,C);if(L)return L;for(let c=1;c<=i;c++){const f=(i+a-c-1)%i,R=_.getLineContent(f+1),E=this._findLastMatchInLine(S,R,f+1,C);if(E)return E}return null}static _findLastMatchInLine(_,N,S,C){let i=null,a;for(_.reset(0);a=_.next(N);)i=w(new g.Range(S,a.index+1,S,a.index+1+a[0].length),a,C);return i}}n.TextModelSearch=s;function o(y,_,N,S,C){if(S===0)return!0;const i=_.charCodeAt(S-1);if(y.get(i)!==0||i===13||i===10)return!0;if(C>0){const a=_.charCodeAt(S);if(y.get(a)!==0)return!0}return!1}function u(y,_,N,S,C){if(S+C===N)return!0;const i=_.charCodeAt(S+C);if(y.get(i)!==0||i===13||i===10)return!0;if(C>0){const a=_.charCodeAt(S+C-1);if(y.get(a)!==0)return!0}return!1}function b(y,_,N,S,C){return o(y,_,N,S,C)&&u(y,_,N,S,C)}class d{constructor(_,N){this._wordSeparators=_,this._searchRegex=N,this._prevMatchStartIndex=-1,this._prevMatchLength=0}reset(_){this._searchRegex.lastIndex=_,this._prevMatchStartIndex=-1,this._prevMatchLength=0}next(_){const N=_.length;let S;do{if(this._prevMatchStartIndex+this._prevMatchLength===N||(S=this._searchRegex.exec(_),!S))return null;const C=S.index,i=S[0].length;if(C===this._prevMatchStartIndex&&i===this._prevMatchLength){if(i===0){r.getNextCodePoint(_,N,this._searchRegex.lastIndex)>65535?this._searchRegex.lastIndex+=2:this._searchRegex.lastIndex+=1;continue}return null}if(this._prevMatchStartIndex=C,this._prevMatchLength=i,!this._wordSeparators||b(this._wordSeparators,_,N,C,i))return S}while(S);return null}}n.Searcher=d}),X(Z[59],K([0,1,2,58,6,12,29]),function(q,n,r,M,A,g,v){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.UnicodeTextModelHighlighter=void 0;class p{static computeUnicodeHighlights(s,o,u){const b=u?u.startLineNumber:1,d=u?u.endLineNumber:s.getLineCount(),y=new l(o),_=y.getCandidateCodePoints();let N;_==="allNonBasicAscii"?N=new RegExp("[^\\t\\n\\r\\x20-\\x7E]","g"):N=new RegExp(`${h(Array.from(_))}`,"g");const S=new M.Searcher(null,N),C=[];let i=!1,a,m=0,L=0,c=0;e:for(let f=b,R=d;f<=R;f++){const E=s.getLineContent(f),x=E.length;S.reset(0);do if(a=S.next(E),a){let D=a.index,T=a.index+a[0].length;if(D>0){const $=E.charCodeAt(D-1);A.isHighSurrogate($)&&D--}if(T+1<x){const $=E.charCodeAt(T-1);A.isHighSurrogate($)&&T++}const k=E.substring(D,T);let W=(0,v.getWordAtText)(D+1,v.DEFAULT_WORD_REGEXP,E,0);W&&W.endColumn<=D+1&&(W=null);const j=y.shouldHighlightNonBasicASCII(k,W?W.word:null);if(j!==0){if(j===3?m++:j===2?L++:j===1?c++:(0,g.assertNever)(j),C.length>=1e3){i=!0;break e}C.push(new r.Range(f,D+1,f,T+1))}}while(a)}return{ranges:C,hasMore:i,ambiguousCharacterCount:m,invisibleCharacterCount:L,nonBasicAsciiCharacterCount:c}}static computeUnicodeHighlightReason(s,o){const u=new l(o);switch(u.shouldHighlightNonBasicASCII(s,null)){case 0:return null;case 2:return{kind:1};case 3:{const d=s.codePointAt(0),y=u.ambiguousCharacters.getPrimaryConfusable(d),_=A.AmbiguousCharacters.getLocales().filter(N=>!A.AmbiguousCharacters.getInstance(new Set([...o.allowedLocales,N])).isAmbiguous(d));return{kind:0,confusableWith:String.fromCodePoint(y),notAmbiguousInLocales:_}}case 1:return{kind:2}}}}n.UnicodeTextModelHighlighter=p;function h(e,s){return`[${A.escapeRegExpCharacters(e.map(u=>String.fromCodePoint(u)).join(""))}]`}class l{constructor(s){this.options=s,this.allowedCodePoints=new Set(s.allowedCodePoints),this.ambiguousCharacters=A.AmbiguousCharacters.getInstance(new Set(s.allowedLocales))}getCandidateCodePoints(){if(this.options.nonBasicASCII)return"allNonBasicAscii";const s=new Set;if(this.options.invisibleCharacters)for(const o of A.InvisibleCharacters.codePoints)w(String.fromCodePoint(o))||s.add(o);if(this.options.ambiguousCharacters)for(const o of this.ambiguousCharacters.getConfusableCodePoints())s.add(o);for(const o of this.allowedCodePoints)s.delete(o);return s}shouldHighlightNonBasicASCII(s,o){const u=s.codePointAt(0);if(this.allowedCodePoints.has(u))return 0;if(this.options.nonBasicASCII)return 1;let b=!1,d=!1;if(o)for(const y of o){const _=y.codePointAt(0),N=A.isBasicASCII(y);b=b||N,!N&&!this.ambiguousCharacters.isAmbiguous(_)&&!A.InvisibleCharacters.isInvisibleCharacter(_)&&(d=!0)}return!b&&d?0:this.options.invisibleCharacters&&!w(s)&&A.InvisibleCharacters.isInvisibleCharacter(u)?2:this.options.ambiguousCharacters&&this.ambiguousCharacters.isAmbiguous(u)?3:0}}function w(e){return e===" "||e===`
`||e==="	"}}),X(Z[60],K([0,1]),function(q,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.WrappingIndent=n.TrackedRangeStickiness=n.TextEditorCursorStyle=n.TextEditorCursorBlinkingStyle=n.SymbolTag=n.SymbolKind=n.SignatureHelpTriggerKind=n.ShowLightbulbIconMode=n.SelectionDirection=n.ScrollbarVisibility=n.ScrollType=n.RenderMinimap=n.RenderLineNumbersType=n.PositionAffinity=n.PartialAcceptTriggerKind=n.OverviewRulerLane=n.OverlayWidgetPositionPreference=n.NewSymbolNameTag=n.MouseTargetType=n.MinimapPosition=n.MarkerTag=n.MarkerSeverity=n.KeyCode=n.InlineEditTriggerKind=n.InlineCompletionTriggerKind=n.InlayHintKind=n.InjectedTextCursorStops=n.IndentAction=n.GlyphMarginLane=n.EndOfLineSequence=n.EndOfLinePreference=n.EditorOption=n.EditorAutoIndentStrategy=n.DocumentHighlightKind=n.DefaultEndOfLine=n.CursorChangeReason=n.ContentWidgetPositionPreference=n.CompletionTriggerKind=n.CompletionItemTag=n.CompletionItemKind=n.CompletionItemInsertTextRule=n.CodeActionTriggerType=n.AccessibilitySupport=void 0;var r;(function(t){t[t.Unknown=0]="Unknown",t[t.Disabled=1]="Disabled",t[t.Enabled=2]="Enabled"})(r||(n.AccessibilitySupport=r={}));var M;(function(t){t[t.Invoke=1]="Invoke",t[t.Auto=2]="Auto"})(M||(n.CodeActionTriggerType=M={}));var A;(function(t){t[t.None=0]="None",t[t.KeepWhitespace=1]="KeepWhitespace",t[t.InsertAsSnippet=4]="InsertAsSnippet"})(A||(n.CompletionItemInsertTextRule=A={}));var g;(function(t){t[t.Method=0]="Method",t[t.Function=1]="Function",t[t.Constructor=2]="Constructor",t[t.Field=3]="Field",t[t.Variable=4]="Variable",t[t.Class=5]="Class",t[t.Struct=6]="Struct",t[t.Interface=7]="Interface",t[t.Module=8]="Module",t[t.Property=9]="Property",t[t.Event=10]="Event",t[t.Operator=11]="Operator",t[t.Unit=12]="Unit",t[t.Value=13]="Value",t[t.Constant=14]="Constant",t[t.Enum=15]="Enum",t[t.EnumMember=16]="EnumMember",t[t.Keyword=17]="Keyword",t[t.Text=18]="Text",t[t.Color=19]="Color",t[t.File=20]="File",t[t.Reference=21]="Reference",t[t.Customcolor=22]="Customcolor",t[t.Folder=23]="Folder",t[t.TypeParameter=24]="TypeParameter",t[t.User=25]="User",t[t.Issue=26]="Issue",t[t.Snippet=27]="Snippet"})(g||(n.CompletionItemKind=g={}));var v;(function(t){t[t.Deprecated=1]="Deprecated"})(v||(n.CompletionItemTag=v={}));var p;(function(t){t[t.Invoke=0]="Invoke",t[t.TriggerCharacter=1]="TriggerCharacter",t[t.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(p||(n.CompletionTriggerKind=p={}));var h;(function(t){t[t.EXACT=0]="EXACT",t[t.ABOVE=1]="ABOVE",t[t.BELOW=2]="BELOW"})(h||(n.ContentWidgetPositionPreference=h={}));var l;(function(t){t[t.NotSet=0]="NotSet",t[t.ContentFlush=1]="ContentFlush",t[t.RecoverFromMarkers=2]="RecoverFromMarkers",t[t.Explicit=3]="Explicit",t[t.Paste=4]="Paste",t[t.Undo=5]="Undo",t[t.Redo=6]="Redo"})(l||(n.CursorChangeReason=l={}));var w;(function(t){t[t.LF=1]="LF",t[t.CRLF=2]="CRLF"})(w||(n.DefaultEndOfLine=w={}));var e;(function(t){t[t.Text=0]="Text",t[t.Read=1]="Read",t[t.Write=2]="Write"})(e||(n.DocumentHighlightKind=e={}));var s;(function(t){t[t.None=0]="None",t[t.Keep=1]="Keep",t[t.Brackets=2]="Brackets",t[t.Advanced=3]="Advanced",t[t.Full=4]="Full"})(s||(n.EditorAutoIndentStrategy=s={}));var o;(function(t){t[t.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",t[t.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",t[t.accessibilitySupport=2]="accessibilitySupport",t[t.accessibilityPageSize=3]="accessibilityPageSize",t[t.ariaLabel=4]="ariaLabel",t[t.ariaRequired=5]="ariaRequired",t[t.autoClosingBrackets=6]="autoClosingBrackets",t[t.autoClosingComments=7]="autoClosingComments",t[t.screenReaderAnnounceInlineSuggestion=8]="screenReaderAnnounceInlineSuggestion",t[t.autoClosingDelete=9]="autoClosingDelete",t[t.autoClosingOvertype=10]="autoClosingOvertype",t[t.autoClosingQuotes=11]="autoClosingQuotes",t[t.autoIndent=12]="autoIndent",t[t.automaticLayout=13]="automaticLayout",t[t.autoSurround=14]="autoSurround",t[t.bracketPairColorization=15]="bracketPairColorization",t[t.guides=16]="guides",t[t.codeLens=17]="codeLens",t[t.codeLensFontFamily=18]="codeLensFontFamily",t[t.codeLensFontSize=19]="codeLensFontSize",t[t.colorDecorators=20]="colorDecorators",t[t.colorDecoratorsLimit=21]="colorDecoratorsLimit",t[t.columnSelection=22]="columnSelection",t[t.comments=23]="comments",t[t.contextmenu=24]="contextmenu",t[t.copyWithSyntaxHighlighting=25]="copyWithSyntaxHighlighting",t[t.cursorBlinking=26]="cursorBlinking",t[t.cursorSmoothCaretAnimation=27]="cursorSmoothCaretAnimation",t[t.cursorStyle=28]="cursorStyle",t[t.cursorSurroundingLines=29]="cursorSurroundingLines",t[t.cursorSurroundingLinesStyle=30]="cursorSurroundingLinesStyle",t[t.cursorWidth=31]="cursorWidth",t[t.disableLayerHinting=32]="disableLayerHinting",t[t.disableMonospaceOptimizations=33]="disableMonospaceOptimizations",t[t.domReadOnly=34]="domReadOnly",t[t.dragAndDrop=35]="dragAndDrop",t[t.dropIntoEditor=36]="dropIntoEditor",t[t.emptySelectionClipboard=37]="emptySelectionClipboard",t[t.experimentalWhitespaceRendering=38]="experimentalWhitespaceRendering",t[t.extraEditorClassName=39]="extraEditorClassName",t[t.fastScrollSensitivity=40]="fastScrollSensitivity",t[t.find=41]="find",t[t.fixedOverflowWidgets=42]="fixedOverflowWidgets",t[t.folding=43]="folding",t[t.foldingStrategy=44]="foldingStrategy",t[t.foldingHighlight=45]="foldingHighlight",t[t.foldingImportsByDefault=46]="foldingImportsByDefault",t[t.foldingMaximumRegions=47]="foldingMaximumRegions",t[t.unfoldOnClickAfterEndOfLine=48]="unfoldOnClickAfterEndOfLine",t[t.fontFamily=49]="fontFamily",t[t.fontInfo=50]="fontInfo",t[t.fontLigatures=51]="fontLigatures",t[t.fontSize=52]="fontSize",t[t.fontWeight=53]="fontWeight",t[t.fontVariations=54]="fontVariations",t[t.formatOnPaste=55]="formatOnPaste",t[t.formatOnType=56]="formatOnType",t[t.glyphMargin=57]="glyphMargin",t[t.gotoLocation=58]="gotoLocation",t[t.hideCursorInOverviewRuler=59]="hideCursorInOverviewRuler",t[t.hover=60]="hover",t[t.inDiffEditor=61]="inDiffEditor",t[t.inlineSuggest=62]="inlineSuggest",t[t.inlineEdit=63]="inlineEdit",t[t.letterSpacing=64]="letterSpacing",t[t.lightbulb=65]="lightbulb",t[t.lineDecorationsWidth=66]="lineDecorationsWidth",t[t.lineHeight=67]="lineHeight",t[t.lineNumbers=68]="lineNumbers",t[t.lineNumbersMinChars=69]="lineNumbersMinChars",t[t.linkedEditing=70]="linkedEditing",t[t.links=71]="links",t[t.matchBrackets=72]="matchBrackets",t[t.minimap=73]="minimap",t[t.mouseStyle=74]="mouseStyle",t[t.mouseWheelScrollSensitivity=75]="mouseWheelScrollSensitivity",t[t.mouseWheelZoom=76]="mouseWheelZoom",t[t.multiCursorMergeOverlapping=77]="multiCursorMergeOverlapping",t[t.multiCursorModifier=78]="multiCursorModifier",t[t.multiCursorPaste=79]="multiCursorPaste",t[t.multiCursorLimit=80]="multiCursorLimit",t[t.occurrencesHighlight=81]="occurrencesHighlight",t[t.overviewRulerBorder=82]="overviewRulerBorder",t[t.overviewRulerLanes=83]="overviewRulerLanes",t[t.padding=84]="padding",t[t.pasteAs=85]="pasteAs",t[t.parameterHints=86]="parameterHints",t[t.peekWidgetDefaultFocus=87]="peekWidgetDefaultFocus",t[t.definitionLinkOpensInPeek=88]="definitionLinkOpensInPeek",t[t.quickSuggestions=89]="quickSuggestions",t[t.quickSuggestionsDelay=90]="quickSuggestionsDelay",t[t.readOnly=91]="readOnly",t[t.readOnlyMessage=92]="readOnlyMessage",t[t.renameOnType=93]="renameOnType",t[t.renderControlCharacters=94]="renderControlCharacters",t[t.renderFinalNewline=95]="renderFinalNewline",t[t.renderLineHighlight=96]="renderLineHighlight",t[t.renderLineHighlightOnlyWhenFocus=97]="renderLineHighlightOnlyWhenFocus",t[t.renderValidationDecorations=98]="renderValidationDecorations",t[t.renderWhitespace=99]="renderWhitespace",t[t.revealHorizontalRightPadding=100]="revealHorizontalRightPadding",t[t.roundedSelection=101]="roundedSelection",t[t.rulers=102]="rulers",t[t.scrollbar=103]="scrollbar",t[t.scrollBeyondLastColumn=104]="scrollBeyondLastColumn",t[t.scrollBeyondLastLine=105]="scrollBeyondLastLine",t[t.scrollPredominantAxis=106]="scrollPredominantAxis",t[t.selectionClipboard=107]="selectionClipboard",t[t.selectionHighlight=108]="selectionHighlight",t[t.selectOnLineNumbers=109]="selectOnLineNumbers",t[t.showFoldingControls=110]="showFoldingControls",t[t.showUnused=111]="showUnused",t[t.snippetSuggestions=112]="snippetSuggestions",t[t.smartSelect=113]="smartSelect",t[t.smoothScrolling=114]="smoothScrolling",t[t.stickyScroll=115]="stickyScroll",t[t.stickyTabStops=116]="stickyTabStops",t[t.stopRenderingLineAfter=117]="stopRenderingLineAfter",t[t.suggest=118]="suggest",t[t.suggestFontSize=119]="suggestFontSize",t[t.suggestLineHeight=120]="suggestLineHeight",t[t.suggestOnTriggerCharacters=121]="suggestOnTriggerCharacters",t[t.suggestSelection=122]="suggestSelection",t[t.tabCompletion=123]="tabCompletion",t[t.tabIndex=124]="tabIndex",t[t.unicodeHighlighting=125]="unicodeHighlighting",t[t.unusualLineTerminators=126]="unusualLineTerminators",t[t.useShadowDOM=127]="useShadowDOM",t[t.useTabStops=128]="useTabStops",t[t.wordBreak=129]="wordBreak",t[t.wordSeparators=130]="wordSeparators",t[t.wordWrap=131]="wordWrap",t[t.wordWrapBreakAfterCharacters=132]="wordWrapBreakAfterCharacters",t[t.wordWrapBreakBeforeCharacters=133]="wordWrapBreakBeforeCharacters",t[t.wordWrapColumn=134]="wordWrapColumn",t[t.wordWrapOverride1=135]="wordWrapOverride1",t[t.wordWrapOverride2=136]="wordWrapOverride2",t[t.wrappingIndent=137]="wrappingIndent",t[t.wrappingStrategy=138]="wrappingStrategy",t[t.showDeprecated=139]="showDeprecated",t[t.inlayHints=140]="inlayHints",t[t.editorClassName=141]="editorClassName",t[t.pixelRatio=142]="pixelRatio",t[t.tabFocusMode=143]="tabFocusMode",t[t.layoutInfo=144]="layoutInfo",t[t.wrappingInfo=145]="wrappingInfo",t[t.defaultColorDecorators=146]="defaultColorDecorators",t[t.colorDecoratorsActivatedOn=147]="colorDecoratorsActivatedOn",t[t.inlineCompletionsAccessibilityVerbose=148]="inlineCompletionsAccessibilityVerbose"})(o||(n.EditorOption=o={}));var u;(function(t){t[t.TextDefined=0]="TextDefined",t[t.LF=1]="LF",t[t.CRLF=2]="CRLF"})(u||(n.EndOfLinePreference=u={}));var b;(function(t){t[t.LF=0]="LF",t[t.CRLF=1]="CRLF"})(b||(n.EndOfLineSequence=b={}));var d;(function(t){t[t.Left=1]="Left",t[t.Center=2]="Center",t[t.Right=3]="Right"})(d||(n.GlyphMarginLane=d={}));var y;(function(t){t[t.None=0]="None",t[t.Indent=1]="Indent",t[t.IndentOutdent=2]="IndentOutdent",t[t.Outdent=3]="Outdent"})(y||(n.IndentAction=y={}));var _;(function(t){t[t.Both=0]="Both",t[t.Right=1]="Right",t[t.Left=2]="Left",t[t.None=3]="None"})(_||(n.InjectedTextCursorStops=_={}));var N;(function(t){t[t.Type=1]="Type",t[t.Parameter=2]="Parameter"})(N||(n.InlayHintKind=N={}));var S;(function(t){t[t.Automatic=0]="Automatic",t[t.Explicit=1]="Explicit"})(S||(n.InlineCompletionTriggerKind=S={}));var C;(function(t){t[t.Invoke=0]="Invoke",t[t.Automatic=1]="Automatic"})(C||(n.InlineEditTriggerKind=C={}));var i;(function(t){t[t.DependsOnKbLayout=-1]="DependsOnKbLayout",t[t.Unknown=0]="Unknown",t[t.Backspace=1]="Backspace",t[t.Tab=2]="Tab",t[t.Enter=3]="Enter",t[t.Shift=4]="Shift",t[t.Ctrl=5]="Ctrl",t[t.Alt=6]="Alt",t[t.PauseBreak=7]="PauseBreak",t[t.CapsLock=8]="CapsLock",t[t.Escape=9]="Escape",t[t.Space=10]="Space",t[t.PageUp=11]="PageUp",t[t.PageDown=12]="PageDown",t[t.End=13]="End",t[t.Home=14]="Home",t[t.LeftArrow=15]="LeftArrow",t[t.UpArrow=16]="UpArrow",t[t.RightArrow=17]="RightArrow",t[t.DownArrow=18]="DownArrow",t[t.Insert=19]="Insert",t[t.Delete=20]="Delete",t[t.Digit0=21]="Digit0",t[t.Digit1=22]="Digit1",t[t.Digit2=23]="Digit2",t[t.Digit3=24]="Digit3",t[t.Digit4=25]="Digit4",t[t.Digit5=26]="Digit5",t[t.Digit6=27]="Digit6",t[t.Digit7=28]="Digit7",t[t.Digit8=29]="Digit8",t[t.Digit9=30]="Digit9",t[t.KeyA=31]="KeyA",t[t.KeyB=32]="KeyB",t[t.KeyC=33]="KeyC",t[t.KeyD=34]="KeyD",t[t.KeyE=35]="KeyE",t[t.KeyF=36]="KeyF",t[t.KeyG=37]="KeyG",t[t.KeyH=38]="KeyH",t[t.KeyI=39]="KeyI",t[t.KeyJ=40]="KeyJ",t[t.KeyK=41]="KeyK",t[t.KeyL=42]="KeyL",t[t.KeyM=43]="KeyM",t[t.KeyN=44]="KeyN",t[t.KeyO=45]="KeyO",t[t.KeyP=46]="KeyP",t[t.KeyQ=47]="KeyQ",t[t.KeyR=48]="KeyR",t[t.KeyS=49]="KeyS",t[t.KeyT=50]="KeyT",t[t.KeyU=51]="KeyU",t[t.KeyV=52]="KeyV",t[t.KeyW=53]="KeyW",t[t.KeyX=54]="KeyX",t[t.KeyY=55]="KeyY",t[t.KeyZ=56]="KeyZ",t[t.Meta=57]="Meta",t[t.ContextMenu=58]="ContextMenu",t[t.F1=59]="F1",t[t.F2=60]="F2",t[t.F3=61]="F3",t[t.F4=62]="F4",t[t.F5=63]="F5",t[t.F6=64]="F6",t[t.F7=65]="F7",t[t.F8=66]="F8",t[t.F9=67]="F9",t[t.F10=68]="F10",t[t.F11=69]="F11",t[t.F12=70]="F12",t[t.F13=71]="F13",t[t.F14=72]="F14",t[t.F15=73]="F15",t[t.F16=74]="F16",t[t.F17=75]="F17",t[t.F18=76]="F18",t[t.F19=77]="F19",t[t.F20=78]="F20",t[t.F21=79]="F21",t[t.F22=80]="F22",t[t.F23=81]="F23",t[t.F24=82]="F24",t[t.NumLock=83]="NumLock",t[t.ScrollLock=84]="ScrollLock",t[t.Semicolon=85]="Semicolon",t[t.Equal=86]="Equal",t[t.Comma=87]="Comma",t[t.Minus=88]="Minus",t[t.Period=89]="Period",t[t.Slash=90]="Slash",t[t.Backquote=91]="Backquote",t[t.BracketLeft=92]="BracketLeft",t[t.Backslash=93]="Backslash",t[t.BracketRight=94]="BracketRight",t[t.Quote=95]="Quote",t[t.OEM_8=96]="OEM_8",t[t.IntlBackslash=97]="IntlBackslash",t[t.Numpad0=98]="Numpad0",t[t.Numpad1=99]="Numpad1",t[t.Numpad2=100]="Numpad2",t[t.Numpad3=101]="Numpad3",t[t.Numpad4=102]="Numpad4",t[t.Numpad5=103]="Numpad5",t[t.Numpad6=104]="Numpad6",t[t.Numpad7=105]="Numpad7",t[t.Numpad8=106]="Numpad8",t[t.Numpad9=107]="Numpad9",t[t.NumpadMultiply=108]="NumpadMultiply",t[t.NumpadAdd=109]="NumpadAdd",t[t.NUMPAD_SEPARATOR=110]="NUMPAD_SEPARATOR",t[t.NumpadSubtract=111]="NumpadSubtract",t[t.NumpadDecimal=112]="NumpadDecimal",t[t.NumpadDivide=113]="NumpadDivide",t[t.KEY_IN_COMPOSITION=114]="KEY_IN_COMPOSITION",t[t.ABNT_C1=115]="ABNT_C1",t[t.ABNT_C2=116]="ABNT_C2",t[t.AudioVolumeMute=117]="AudioVolumeMute",t[t.AudioVolumeUp=118]="AudioVolumeUp",t[t.AudioVolumeDown=119]="AudioVolumeDown",t[t.BrowserSearch=120]="BrowserSearch",t[t.BrowserHome=121]="BrowserHome",t[t.BrowserBack=122]="BrowserBack",t[t.BrowserForward=123]="BrowserForward",t[t.MediaTrackNext=124]="MediaTrackNext",t[t.MediaTrackPrevious=125]="MediaTrackPrevious",t[t.MediaStop=126]="MediaStop",t[t.MediaPlayPause=127]="MediaPlayPause",t[t.LaunchMediaPlayer=128]="LaunchMediaPlayer",t[t.LaunchMail=129]="LaunchMail",t[t.LaunchApp2=130]="LaunchApp2",t[t.Clear=131]="Clear",t[t.MAX_VALUE=132]="MAX_VALUE"})(i||(n.KeyCode=i={}));var a;(function(t){t[t.Hint=1]="Hint",t[t.Info=2]="Info",t[t.Warning=4]="Warning",t[t.Error=8]="Error"})(a||(n.MarkerSeverity=a={}));var m;(function(t){t[t.Unnecessary=1]="Unnecessary",t[t.Deprecated=2]="Deprecated"})(m||(n.MarkerTag=m={}));var L;(function(t){t[t.Inline=1]="Inline",t[t.Gutter=2]="Gutter"})(L||(n.MinimapPosition=L={}));var c;(function(t){t[t.UNKNOWN=0]="UNKNOWN",t[t.TEXTAREA=1]="TEXTAREA",t[t.GUTTER_GLYPH_MARGIN=2]="GUTTER_GLYPH_MARGIN",t[t.GUTTER_LINE_NUMBERS=3]="GUTTER_LINE_NUMBERS",t[t.GUTTER_LINE_DECORATIONS=4]="GUTTER_LINE_DECORATIONS",t[t.GUTTER_VIEW_ZONE=5]="GUTTER_VIEW_ZONE",t[t.CONTENT_TEXT=6]="CONTENT_TEXT",t[t.CONTENT_EMPTY=7]="CONTENT_EMPTY",t[t.CONTENT_VIEW_ZONE=8]="CONTENT_VIEW_ZONE",t[t.CONTENT_WIDGET=9]="CONTENT_WIDGET",t[t.OVERVIEW_RULER=10]="OVERVIEW_RULER",t[t.SCROLLBAR=11]="SCROLLBAR",t[t.OVERLAY_WIDGET=12]="OVERLAY_WIDGET",t[t.OUTSIDE_EDITOR=13]="OUTSIDE_EDITOR"})(c||(n.MouseTargetType=c={}));var f;(function(t){t[t.AIGenerated=1]="AIGenerated"})(f||(n.NewSymbolNameTag=f={}));var R;(function(t){t[t.TOP_RIGHT_CORNER=0]="TOP_RIGHT_CORNER",t[t.BOTTOM_RIGHT_CORNER=1]="BOTTOM_RIGHT_CORNER",t[t.TOP_CENTER=2]="TOP_CENTER"})(R||(n.OverlayWidgetPositionPreference=R={}));var E;(function(t){t[t.Left=1]="Left",t[t.Center=2]="Center",t[t.Right=4]="Right",t[t.Full=7]="Full"})(E||(n.OverviewRulerLane=E={}));var x;(function(t){t[t.Word=0]="Word",t[t.Line=1]="Line",t[t.Suggest=2]="Suggest"})(x||(n.PartialAcceptTriggerKind=x={}));var D;(function(t){t[t.Left=0]="Left",t[t.Right=1]="Right",t[t.None=2]="None",t[t.LeftOfInjectedText=3]="LeftOfInjectedText",t[t.RightOfInjectedText=4]="RightOfInjectedText"})(D||(n.PositionAffinity=D={}));var T;(function(t){t[t.Off=0]="Off",t[t.On=1]="On",t[t.Relative=2]="Relative",t[t.Interval=3]="Interval",t[t.Custom=4]="Custom"})(T||(n.RenderLineNumbersType=T={}));var k;(function(t){t[t.None=0]="None",t[t.Text=1]="Text",t[t.Blocks=2]="Blocks"})(k||(n.RenderMinimap=k={}));var W;(function(t){t[t.Smooth=0]="Smooth",t[t.Immediate=1]="Immediate"})(W||(n.ScrollType=W={}));var j;(function(t){t[t.Auto=1]="Auto",t[t.Hidden=2]="Hidden",t[t.Visible=3]="Visible"})(j||(n.ScrollbarVisibility=j={}));var $;(function(t){t[t.LTR=0]="LTR",t[t.RTL=1]="RTL"})($||(n.SelectionDirection=$={}));var I;(function(t){t.Off="off",t.OnCode="onCode",t.On="on"})(I||(n.ShowLightbulbIconMode=I={}));var F;(function(t){t[t.Invoke=1]="Invoke",t[t.TriggerCharacter=2]="TriggerCharacter",t[t.ContentChange=3]="ContentChange"})(F||(n.SignatureHelpTriggerKind=F={}));var O;(function(t){t[t.File=0]="File",t[t.Module=1]="Module",t[t.Namespace=2]="Namespace",t[t.Package=3]="Package",t[t.Class=4]="Class",t[t.Method=5]="Method",t[t.Property=6]="Property",t[t.Field=7]="Field",t[t.Constructor=8]="Constructor",t[t.Enum=9]="Enum",t[t.Interface=10]="Interface",t[t.Function=11]="Function",t[t.Variable=12]="Variable",t[t.Constant=13]="Constant",t[t.String=14]="String",t[t.Number=15]="Number",t[t.Boolean=16]="Boolean",t[t.Array=17]="Array",t[t.Object=18]="Object",t[t.Key=19]="Key",t[t.Null=20]="Null",t[t.EnumMember=21]="EnumMember",t[t.Struct=22]="Struct",t[t.Event=23]="Event",t[t.Operator=24]="Operator",t[t.TypeParameter=25]="TypeParameter"})(O||(n.SymbolKind=O={}));var V;(function(t){t[t.Deprecated=1]="Deprecated"})(V||(n.SymbolTag=V={}));var H;(function(t){t[t.Hidden=0]="Hidden",t[t.Blink=1]="Blink",t[t.Smooth=2]="Smooth",t[t.Phase=3]="Phase",t[t.Expand=4]="Expand",t[t.Solid=5]="Solid"})(H||(n.TextEditorCursorBlinkingStyle=H={}));var U;(function(t){t[t.Line=1]="Line",t[t.Block=2]="Block",t[t.Underline=3]="Underline",t[t.LineThin=4]="LineThin",t[t.BlockOutline=5]="BlockOutline",t[t.UnderlineThin=6]="UnderlineThin"})(U||(n.TextEditorCursorStyle=U={}));var ie;(function(t){t[t.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",t[t.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",t[t.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",t[t.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(ie||(n.TrackedRangeStickiness=ie={}));var oe;(function(t){t[t.None=0]="None",t[t.Same=1]="Same",t[t.Indent=2]="Indent",t[t.DeepIndent=3]="DeepIndent"})(oe||(n.WrappingIndent=oe={}))}),X(Z[61],K([0,1,9,13]),function(q,n,r,M){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.TokenizationRegistry=void 0;class A{constructor(){this._tokenizationSupports=new Map,this._factories=new Map,this._onDidChange=new r.Emitter,this.onDidChange=this._onDidChange.event,this._colorMap=null}handleChange(p){this._onDidChange.fire({changedLanguages:p,changedColorMap:!1})}register(p,h){return this._tokenizationSupports.set(p,h),this.handleChange([p]),(0,M.toDisposable)(()=>{this._tokenizationSupports.get(p)===h&&(this._tokenizationSupports.delete(p),this.handleChange([p]))})}get(p){return this._tokenizationSupports.get(p)||null}registerFactory(p,h){var l;(l=this._factories.get(p))===null||l===void 0||l.dispose();const w=new g(this,p,h);return this._factories.set(p,w),(0,M.toDisposable)(()=>{const e=this._factories.get(p);!e||e!==w||(this._factories.delete(p),e.dispose())})}async getOrCreate(p){const h=this.get(p);if(h)return h;const l=this._factories.get(p);return!l||l.isResolved?null:(await l.resolve(),this.get(p))}isResolved(p){if(this.get(p))return!0;const l=this._factories.get(p);return!!(!l||l.isResolved)}setColorMap(p){this._colorMap=p,this._onDidChange.fire({changedLanguages:Array.from(this._tokenizationSupports.keys()),changedColorMap:!0})}getColorMap(){return this._colorMap}getDefaultBackground(){return this._colorMap&&this._colorMap.length>2?this._colorMap[2]:null}}n.TokenizationRegistry=A;class g extends M.Disposable{get isResolved(){return this._isResolved}constructor(p,h,l){super(),this._registry=p,this._languageId=h,this._factory=l,this._isDisposed=!1,this._resolvePromise=null,this._isResolved=!1}dispose(){this._isDisposed=!0,super.dispose()}async resolve(){return this._resolvePromise||(this._resolvePromise=this._create()),this._resolvePromise}async _create(){const p=await this._factory.tokenizationSupport;this._isResolved=!0,p&&!this._isDisposed&&this._register(this._registry.register(this._languageId,p))}}}),X(Z[62],K([19,63]),function(q,n){return q.create("vs/base/common/platform",n)}),X(Z[17],K([0,1,62]),function(q,n,r){"use strict";var M;Object.defineProperty(n,"__esModule",{value:!0}),n.isAndroid=n.isEdge=n.isSafari=n.isFirefox=n.isChrome=n.OS=n.setTimeout0=n.setTimeout0IsFaster=n.language=n.userAgent=n.isMobile=n.isIOS=n.webWorkerOrigin=n.isWebWorker=n.isWeb=n.isNative=n.isLinux=n.isMacintosh=n.isWindows=n.LANGUAGE_DEFAULT=void 0,n.isLittleEndian=c,n.LANGUAGE_DEFAULT="en";let A=!1,g=!1,v=!1,p=!1,h=!1,l=!1,w=!1,e=!1,s=!1,o=!1,u,b=n.LANGUAGE_DEFAULT,d=n.LANGUAGE_DEFAULT,y,_;const N=globalThis;let S;typeof N.vscode<"u"&&typeof N.vscode.process<"u"?S=N.vscode.process:typeof process<"u"&&(S=process);const C=typeof((M=S?.versions)===null||M===void 0?void 0:M.electron)=="string",i=C&&S?.type==="renderer";if(typeof S=="object"){A=S.platform==="win32",g=S.platform==="darwin",v=S.platform==="linux",p=v&&!!S.env.SNAP&&!!S.env.SNAP_REVISION,w=C,s=!!S.env.CI||!!S.env.BUILD_ARTIFACTSTAGINGDIRECTORY,u=n.LANGUAGE_DEFAULT,b=n.LANGUAGE_DEFAULT;const f=S.env.VSCODE_NLS_CONFIG;if(f)try{const R=JSON.parse(f),E=R.availableLanguages["*"];u=R.locale,d=R.osLocale,b=E||n.LANGUAGE_DEFAULT,y=R._translationsConfigFile}catch{}h=!0}else typeof navigator=="object"&&!i?(_=navigator.userAgent,A=_.indexOf("Windows")>=0,g=_.indexOf("Macintosh")>=0,e=(_.indexOf("Macintosh")>=0||_.indexOf("iPad")>=0||_.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,v=_.indexOf("Linux")>=0,o=_?.indexOf("Mobi")>=0,l=!0,u=r.getConfiguredDefaultLocale(r.localize(0,null))||n.LANGUAGE_DEFAULT,b=u,d=navigator.language):console.error("Unable to resolve platform.");let a=0;g?a=1:A?a=3:v&&(a=2),n.isWindows=A,n.isMacintosh=g,n.isLinux=v,n.isNative=h,n.isWeb=l,n.isWebWorker=l&&typeof N.importScripts=="function",n.webWorkerOrigin=n.isWebWorker?N.origin:void 0,n.isIOS=e,n.isMobile=o,n.userAgent=_,n.language=b,n.setTimeout0IsFaster=typeof N.postMessage=="function"&&!N.importScripts,n.setTimeout0=(()=>{if(n.setTimeout0IsFaster){const f=[];N.addEventListener("message",E=>{if(E.data&&E.data.vscodeScheduleAsyncWork)for(let x=0,D=f.length;x<D;x++){const T=f[x];if(T.id===E.data.vscodeScheduleAsyncWork){f.splice(x,1),T.callback();return}}});let R=0;return E=>{const x=++R;f.push({id:x,callback:E}),N.postMessage({vscodeScheduleAsyncWork:x},"*")}}return f=>setTimeout(f)})(),n.OS=g||e?2:A?1:3;let m=!0,L=!1;function c(){if(!L){L=!0;const f=new Uint8Array(2);f[0]=1,f[1]=2,m=new Uint16Array(f.buffer)[0]===513}return m}n.isChrome=!!(n.userAgent&&n.userAgent.indexOf("Chrome")>=0),n.isFirefox=!!(n.userAgent&&n.userAgent.indexOf("Firefox")>=0),n.isSafari=!!(!n.isChrome&&n.userAgent&&n.userAgent.indexOf("Safari")>=0),n.isEdge=!!(n.userAgent&&n.userAgent.indexOf("Edg/")>=0),n.isAndroid=!!(n.userAgent&&n.userAgent.indexOf("Android")>=0)}),X(Z[64],K([0,1,17]),function(q,n,r){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.platform=n.env=n.cwd=void 0;let M;const A=globalThis.vscode;if(typeof A<"u"&&typeof A.process<"u"){const g=A.process;M={get platform(){return g.platform},get arch(){return g.arch},get env(){return g.env},cwd(){return g.cwd()}}}else typeof process<"u"?M={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:M={get platform(){return r.isWindows?"win32":r.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};n.cwd=M.cwd,n.env=M.env,n.platform=M.platform}),X(Z[65],K([0,1,64]),function(q,n,r){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.sep=n.extname=n.basename=n.dirname=n.relative=n.resolve=n.normalize=n.posix=n.win32=void 0;const M=65,A=97,g=90,v=122,p=46,h=47,l=92,w=58,e=63;class s extends Error{constructor(a,m,L){let c;typeof m=="string"&&m.indexOf("not ")===0?(c="must not be",m=m.replace(/^not /,"")):c="must be";const f=a.indexOf(".")!==-1?"property":"argument";let R=`The "${a}" ${f} ${c} of type ${m}`;R+=`. Received type ${typeof L}`,super(R),this.code="ERR_INVALID_ARG_TYPE"}}function o(i,a){if(i===null||typeof i!="object")throw new s(a,"Object",i)}function u(i,a){if(typeof i!="string")throw new s(a,"string",i)}const b=r.platform==="win32";function d(i){return i===h||i===l}function y(i){return i===h}function _(i){return i>=M&&i<=g||i>=A&&i<=v}function N(i,a,m,L){let c="",f=0,R=-1,E=0,x=0;for(let D=0;D<=i.length;++D){if(D<i.length)x=i.charCodeAt(D);else{if(L(x))break;x=h}if(L(x)){if(!(R===D-1||E===1))if(E===2){if(c.length<2||f!==2||c.charCodeAt(c.length-1)!==p||c.charCodeAt(c.length-2)!==p){if(c.length>2){const T=c.lastIndexOf(m);T===-1?(c="",f=0):(c=c.slice(0,T),f=c.length-1-c.lastIndexOf(m)),R=D,E=0;continue}else if(c.length!==0){c="",f=0,R=D,E=0;continue}}a&&(c+=c.length>0?`${m}..`:"..",f=2)}else c.length>0?c+=`${m}${i.slice(R+1,D)}`:c=i.slice(R+1,D),f=D-R-1;R=D,E=0}else x===p&&E!==-1?++E:E=-1}return c}function S(i,a){o(a,"pathObject");const m=a.dir||a.root,L=a.base||`${a.name||""}${a.ext||""}`;return m?m===a.root?`${m}${L}`:`${m}${i}${L}`:L}n.win32={resolve(...i){let a="",m="",L=!1;for(let c=i.length-1;c>=-1;c--){let f;if(c>=0){if(f=i[c],u(f,"path"),f.length===0)continue}else a.length===0?f=r.cwd():(f=r.env[`=${a}`]||r.cwd(),(f===void 0||f.slice(0,2).toLowerCase()!==a.toLowerCase()&&f.charCodeAt(2)===l)&&(f=`${a}\\`));const R=f.length;let E=0,x="",D=!1;const T=f.charCodeAt(0);if(R===1)d(T)&&(E=1,D=!0);else if(d(T))if(D=!0,d(f.charCodeAt(1))){let k=2,W=k;for(;k<R&&!d(f.charCodeAt(k));)k++;if(k<R&&k!==W){const j=f.slice(W,k);for(W=k;k<R&&d(f.charCodeAt(k));)k++;if(k<R&&k!==W){for(W=k;k<R&&!d(f.charCodeAt(k));)k++;(k===R||k!==W)&&(x=`\\\\${j}\\${f.slice(W,k)}`,E=k)}}}else E=1;else _(T)&&f.charCodeAt(1)===w&&(x=f.slice(0,2),E=2,R>2&&d(f.charCodeAt(2))&&(D=!0,E=3));if(x.length>0)if(a.length>0){if(x.toLowerCase()!==a.toLowerCase())continue}else a=x;if(L){if(a.length>0)break}else if(m=`${f.slice(E)}\\${m}`,L=D,D&&a.length>0)break}return m=N(m,!L,"\\",d),L?`${a}\\${m}`:`${a}${m}`||"."},normalize(i){u(i,"path");const a=i.length;if(a===0)return".";let m=0,L,c=!1;const f=i.charCodeAt(0);if(a===1)return y(f)?"\\":i;if(d(f))if(c=!0,d(i.charCodeAt(1))){let E=2,x=E;for(;E<a&&!d(i.charCodeAt(E));)E++;if(E<a&&E!==x){const D=i.slice(x,E);for(x=E;E<a&&d(i.charCodeAt(E));)E++;if(E<a&&E!==x){for(x=E;E<a&&!d(i.charCodeAt(E));)E++;if(E===a)return`\\\\${D}\\${i.slice(x)}\\`;E!==x&&(L=`\\\\${D}\\${i.slice(x,E)}`,m=E)}}}else m=1;else _(f)&&i.charCodeAt(1)===w&&(L=i.slice(0,2),m=2,a>2&&d(i.charCodeAt(2))&&(c=!0,m=3));let R=m<a?N(i.slice(m),!c,"\\",d):"";return R.length===0&&!c&&(R="."),R.length>0&&d(i.charCodeAt(a-1))&&(R+="\\"),L===void 0?c?`\\${R}`:R:c?`${L}\\${R}`:`${L}${R}`},isAbsolute(i){u(i,"path");const a=i.length;if(a===0)return!1;const m=i.charCodeAt(0);return d(m)||a>2&&_(m)&&i.charCodeAt(1)===w&&d(i.charCodeAt(2))},join(...i){if(i.length===0)return".";let a,m;for(let f=0;f<i.length;++f){const R=i[f];u(R,"path"),R.length>0&&(a===void 0?a=m=R:a+=`\\${R}`)}if(a===void 0)return".";let L=!0,c=0;if(typeof m=="string"&&d(m.charCodeAt(0))){++c;const f=m.length;f>1&&d(m.charCodeAt(1))&&(++c,f>2&&(d(m.charCodeAt(2))?++c:L=!1))}if(L){for(;c<a.length&&d(a.charCodeAt(c));)c++;c>=2&&(a=`\\${a.slice(c)}`)}return n.win32.normalize(a)},relative(i,a){if(u(i,"from"),u(a,"to"),i===a)return"";const m=n.win32.resolve(i),L=n.win32.resolve(a);if(m===L||(i=m.toLowerCase(),a=L.toLowerCase(),i===a))return"";let c=0;for(;c<i.length&&i.charCodeAt(c)===l;)c++;let f=i.length;for(;f-1>c&&i.charCodeAt(f-1)===l;)f--;const R=f-c;let E=0;for(;E<a.length&&a.charCodeAt(E)===l;)E++;let x=a.length;for(;x-1>E&&a.charCodeAt(x-1)===l;)x--;const D=x-E,T=R<D?R:D;let k=-1,W=0;for(;W<T;W++){const $=i.charCodeAt(c+W);if($!==a.charCodeAt(E+W))break;$===l&&(k=W)}if(W!==T){if(k===-1)return L}else{if(D>T){if(a.charCodeAt(E+W)===l)return L.slice(E+W+1);if(W===2)return L.slice(E+W)}R>T&&(i.charCodeAt(c+W)===l?k=W:W===2&&(k=3)),k===-1&&(k=0)}let j="";for(W=c+k+1;W<=f;++W)(W===f||i.charCodeAt(W)===l)&&(j+=j.length===0?"..":"\\..");return E+=k,j.length>0?`${j}${L.slice(E,x)}`:(L.charCodeAt(E)===l&&++E,L.slice(E,x))},toNamespacedPath(i){if(typeof i!="string"||i.length===0)return i;const a=n.win32.resolve(i);if(a.length<=2)return i;if(a.charCodeAt(0)===l){if(a.charCodeAt(1)===l){const m=a.charCodeAt(2);if(m!==e&&m!==p)return`\\\\?\\UNC\\${a.slice(2)}`}}else if(_(a.charCodeAt(0))&&a.charCodeAt(1)===w&&a.charCodeAt(2)===l)return`\\\\?\\${a}`;return i},dirname(i){u(i,"path");const a=i.length;if(a===0)return".";let m=-1,L=0;const c=i.charCodeAt(0);if(a===1)return d(c)?i:".";if(d(c)){if(m=L=1,d(i.charCodeAt(1))){let E=2,x=E;for(;E<a&&!d(i.charCodeAt(E));)E++;if(E<a&&E!==x){for(x=E;E<a&&d(i.charCodeAt(E));)E++;if(E<a&&E!==x){for(x=E;E<a&&!d(i.charCodeAt(E));)E++;if(E===a)return i;E!==x&&(m=L=E+1)}}}}else _(c)&&i.charCodeAt(1)===w&&(m=a>2&&d(i.charCodeAt(2))?3:2,L=m);let f=-1,R=!0;for(let E=a-1;E>=L;--E)if(d(i.charCodeAt(E))){if(!R){f=E;break}}else R=!1;if(f===-1){if(m===-1)return".";f=m}return i.slice(0,f)},basename(i,a){a!==void 0&&u(a,"ext"),u(i,"path");let m=0,L=-1,c=!0,f;if(i.length>=2&&_(i.charCodeAt(0))&&i.charCodeAt(1)===w&&(m=2),a!==void 0&&a.length>0&&a.length<=i.length){if(a===i)return"";let R=a.length-1,E=-1;for(f=i.length-1;f>=m;--f){const x=i.charCodeAt(f);if(d(x)){if(!c){m=f+1;break}}else E===-1&&(c=!1,E=f+1),R>=0&&(x===a.charCodeAt(R)?--R===-1&&(L=f):(R=-1,L=E))}return m===L?L=E:L===-1&&(L=i.length),i.slice(m,L)}for(f=i.length-1;f>=m;--f)if(d(i.charCodeAt(f))){if(!c){m=f+1;break}}else L===-1&&(c=!1,L=f+1);return L===-1?"":i.slice(m,L)},extname(i){u(i,"path");let a=0,m=-1,L=0,c=-1,f=!0,R=0;i.length>=2&&i.charCodeAt(1)===w&&_(i.charCodeAt(0))&&(a=L=2);for(let E=i.length-1;E>=a;--E){const x=i.charCodeAt(E);if(d(x)){if(!f){L=E+1;break}continue}c===-1&&(f=!1,c=E+1),x===p?m===-1?m=E:R!==1&&(R=1):m!==-1&&(R=-1)}return m===-1||c===-1||R===0||R===1&&m===c-1&&m===L+1?"":i.slice(m,c)},format:S.bind(null,"\\"),parse(i){u(i,"path");const a={root:"",dir:"",base:"",ext:"",name:""};if(i.length===0)return a;const m=i.length;let L=0,c=i.charCodeAt(0);if(m===1)return d(c)?(a.root=a.dir=i,a):(a.base=a.name=i,a);if(d(c)){if(L=1,d(i.charCodeAt(1))){let k=2,W=k;for(;k<m&&!d(i.charCodeAt(k));)k++;if(k<m&&k!==W){for(W=k;k<m&&d(i.charCodeAt(k));)k++;if(k<m&&k!==W){for(W=k;k<m&&!d(i.charCodeAt(k));)k++;k===m?L=k:k!==W&&(L=k+1)}}}}else if(_(c)&&i.charCodeAt(1)===w){if(m<=2)return a.root=a.dir=i,a;if(L=2,d(i.charCodeAt(2))){if(m===3)return a.root=a.dir=i,a;L=3}}L>0&&(a.root=i.slice(0,L));let f=-1,R=L,E=-1,x=!0,D=i.length-1,T=0;for(;D>=L;--D){if(c=i.charCodeAt(D),d(c)){if(!x){R=D+1;break}continue}E===-1&&(x=!1,E=D+1),c===p?f===-1?f=D:T!==1&&(T=1):f!==-1&&(T=-1)}return E!==-1&&(f===-1||T===0||T===1&&f===E-1&&f===R+1?a.base=a.name=i.slice(R,E):(a.name=i.slice(R,f),a.base=i.slice(R,E),a.ext=i.slice(f,E))),R>0&&R!==L?a.dir=i.slice(0,R-1):a.dir=a.root,a},sep:"\\",delimiter:";",win32:null,posix:null};const C=(()=>{if(b){const i=/\\/g;return()=>{const a=r.cwd().replace(i,"/");return a.slice(a.indexOf("/"))}}return()=>r.cwd()})();n.posix={resolve(...i){let a="",m=!1;for(let L=i.length-1;L>=-1&&!m;L--){const c=L>=0?i[L]:C();u(c,"path"),c.length!==0&&(a=`${c}/${a}`,m=c.charCodeAt(0)===h)}return a=N(a,!m,"/",y),m?`/${a}`:a.length>0?a:"."},normalize(i){if(u(i,"path"),i.length===0)return".";const a=i.charCodeAt(0)===h,m=i.charCodeAt(i.length-1)===h;return i=N(i,!a,"/",y),i.length===0?a?"/":m?"./":".":(m&&(i+="/"),a?`/${i}`:i)},isAbsolute(i){return u(i,"path"),i.length>0&&i.charCodeAt(0)===h},join(...i){if(i.length===0)return".";let a;for(let m=0;m<i.length;++m){const L=i[m];u(L,"path"),L.length>0&&(a===void 0?a=L:a+=`/${L}`)}return a===void 0?".":n.posix.normalize(a)},relative(i,a){if(u(i,"from"),u(a,"to"),i===a||(i=n.posix.resolve(i),a=n.posix.resolve(a),i===a))return"";const m=1,L=i.length,c=L-m,f=1,R=a.length-f,E=c<R?c:R;let x=-1,D=0;for(;D<E;D++){const k=i.charCodeAt(m+D);if(k!==a.charCodeAt(f+D))break;k===h&&(x=D)}if(D===E)if(R>E){if(a.charCodeAt(f+D)===h)return a.slice(f+D+1);if(D===0)return a.slice(f+D)}else c>E&&(i.charCodeAt(m+D)===h?x=D:D===0&&(x=0));let T="";for(D=m+x+1;D<=L;++D)(D===L||i.charCodeAt(D)===h)&&(T+=T.length===0?"..":"/..");return`${T}${a.slice(f+x)}`},toNamespacedPath(i){return i},dirname(i){if(u(i,"path"),i.length===0)return".";const a=i.charCodeAt(0)===h;let m=-1,L=!0;for(let c=i.length-1;c>=1;--c)if(i.charCodeAt(c)===h){if(!L){m=c;break}}else L=!1;return m===-1?a?"/":".":a&&m===1?"//":i.slice(0,m)},basename(i,a){a!==void 0&&u(a,"ext"),u(i,"path");let m=0,L=-1,c=!0,f;if(a!==void 0&&a.length>0&&a.length<=i.length){if(a===i)return"";let R=a.length-1,E=-1;for(f=i.length-1;f>=0;--f){const x=i.charCodeAt(f);if(x===h){if(!c){m=f+1;break}}else E===-1&&(c=!1,E=f+1),R>=0&&(x===a.charCodeAt(R)?--R===-1&&(L=f):(R=-1,L=E))}return m===L?L=E:L===-1&&(L=i.length),i.slice(m,L)}for(f=i.length-1;f>=0;--f)if(i.charCodeAt(f)===h){if(!c){m=f+1;break}}else L===-1&&(c=!1,L=f+1);return L===-1?"":i.slice(m,L)},extname(i){u(i,"path");let a=-1,m=0,L=-1,c=!0,f=0;for(let R=i.length-1;R>=0;--R){const E=i.charCodeAt(R);if(E===h){if(!c){m=R+1;break}continue}L===-1&&(c=!1,L=R+1),E===p?a===-1?a=R:f!==1&&(f=1):a!==-1&&(f=-1)}return a===-1||L===-1||f===0||f===1&&a===L-1&&a===m+1?"":i.slice(a,L)},format:S.bind(null,"/"),parse(i){u(i,"path");const a={root:"",dir:"",base:"",ext:"",name:""};if(i.length===0)return a;const m=i.charCodeAt(0)===h;let L;m?(a.root="/",L=1):L=0;let c=-1,f=0,R=-1,E=!0,x=i.length-1,D=0;for(;x>=L;--x){const T=i.charCodeAt(x);if(T===h){if(!E){f=x+1;break}continue}R===-1&&(E=!1,R=x+1),T===p?c===-1?c=x:D!==1&&(D=1):c!==-1&&(D=-1)}if(R!==-1){const T=f===0&&m?1:f;c===-1||D===0||D===1&&c===R-1&&c===f+1?a.base=a.name=i.slice(T,R):(a.name=i.slice(T,c),a.base=i.slice(T,R),a.ext=i.slice(c,R))}return f>0?a.dir=i.slice(0,f-1):m&&(a.dir="/"),a},sep:"/",delimiter:":",win32:null,posix:null},n.posix.win32=n.win32.win32=n.win32,n.posix.posix=n.win32.posix=n.posix,n.normalize=b?n.win32.normalize:n.posix.normalize,n.resolve=b?n.win32.resolve:n.posix.resolve,n.relative=b?n.win32.relative:n.posix.relative,n.dirname=b?n.win32.dirname:n.posix.dirname,n.basename=b?n.win32.basename:n.posix.basename,n.extname=b?n.win32.extname:n.posix.extname,n.sep=b?n.win32.sep:n.posix.sep}),X(Z[18],K([0,1,65,17]),function(q,n,r,M){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.URI=void 0,n.uriToFsPath=N;const A=/^\w[\w\d+.-]*$/,g=/^\//,v=/^\/\//;function p(m,L){if(!m.scheme&&L)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${m.authority}", path: "${m.path}", query: "${m.query}", fragment: "${m.fragment}"}`);if(m.scheme&&!A.test(m.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(m.path){if(m.authority){if(!g.test(m.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(v.test(m.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function h(m,L){return!m&&!L?"file":m}function l(m,L){switch(m){case"https":case"http":case"file":L?L[0]!==e&&(L=e+L):L=e;break}return L}const w="",e="/",s=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class o{static isUri(L){return L instanceof o?!0:L?typeof L.authority=="string"&&typeof L.fragment=="string"&&typeof L.path=="string"&&typeof L.query=="string"&&typeof L.scheme=="string"&&typeof L.fsPath=="string"&&typeof L.with=="function"&&typeof L.toString=="function":!1}constructor(L,c,f,R,E,x=!1){typeof L=="object"?(this.scheme=L.scheme||w,this.authority=L.authority||w,this.path=L.path||w,this.query=L.query||w,this.fragment=L.fragment||w):(this.scheme=h(L,x),this.authority=c||w,this.path=l(this.scheme,f||w),this.query=R||w,this.fragment=E||w,p(this,x))}get fsPath(){return N(this,!1)}with(L){if(!L)return this;let{scheme:c,authority:f,path:R,query:E,fragment:x}=L;return c===void 0?c=this.scheme:c===null&&(c=w),f===void 0?f=this.authority:f===null&&(f=w),R===void 0?R=this.path:R===null&&(R=w),E===void 0?E=this.query:E===null&&(E=w),x===void 0?x=this.fragment:x===null&&(x=w),c===this.scheme&&f===this.authority&&R===this.path&&E===this.query&&x===this.fragment?this:new b(c,f,R,E,x)}static parse(L,c=!1){const f=s.exec(L);return f?new b(f[2]||w,a(f[4]||w),a(f[5]||w),a(f[7]||w),a(f[9]||w),c):new b(w,w,w,w,w)}static file(L){let c=w;if(M.isWindows&&(L=L.replace(/\\/g,e)),L[0]===e&&L[1]===e){const f=L.indexOf(e,2);f===-1?(c=L.substring(2),L=e):(c=L.substring(2,f),L=L.substring(f)||e)}return new b("file",c,L,w,w)}static from(L,c){return new b(L.scheme,L.authority,L.path,L.query,L.fragment,c)}static joinPath(L,...c){if(!L.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let f;return M.isWindows&&L.scheme==="file"?f=o.file(r.win32.join(N(L,!0),...c)).path:f=r.posix.join(L.path,...c),L.with({path:f})}toString(L=!1){return S(this,L)}toJSON(){return this}static revive(L){var c,f;if(L){if(L instanceof o)return L;{const R=new b(L);return R._formatted=(c=L.external)!==null&&c!==void 0?c:null,R._fsPath=L._sep===u&&(f=L.fsPath)!==null&&f!==void 0?f:null,R}}else return L}}n.URI=o;const u=M.isWindows?1:void 0;class b extends o{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=N(this,!1)),this._fsPath}toString(L=!1){return L?S(this,!0):(this._formatted||(this._formatted=S(this,!1)),this._formatted)}toJSON(){const L={$mid:1};return this._fsPath&&(L.fsPath=this._fsPath,L._sep=u),this._formatted&&(L.external=this._formatted),this.path&&(L.path=this.path),this.scheme&&(L.scheme=this.scheme),this.authority&&(L.authority=this.authority),this.query&&(L.query=this.query),this.fragment&&(L.fragment=this.fragment),L}}const d={58:"%3A",47:"%2F",63:"%3F",35:"%23",91:"%5B",93:"%5D",64:"%40",33:"%21",36:"%24",38:"%26",39:"%27",40:"%28",41:"%29",42:"%2A",43:"%2B",44:"%2C",59:"%3B",61:"%3D",32:"%20"};function y(m,L,c){let f,R=-1;for(let E=0;E<m.length;E++){const x=m.charCodeAt(E);if(x>=97&&x<=122||x>=65&&x<=90||x>=48&&x<=57||x===45||x===46||x===95||x===126||L&&x===47||c&&x===91||c&&x===93||c&&x===58)R!==-1&&(f+=encodeURIComponent(m.substring(R,E)),R=-1),f!==void 0&&(f+=m.charAt(E));else{f===void 0&&(f=m.substr(0,E));const D=d[x];D!==void 0?(R!==-1&&(f+=encodeURIComponent(m.substring(R,E)),R=-1),f+=D):R===-1&&(R=E)}}return R!==-1&&(f+=encodeURIComponent(m.substring(R))),f!==void 0?f:m}function _(m){let L;for(let c=0;c<m.length;c++){const f=m.charCodeAt(c);f===35||f===63?(L===void 0&&(L=m.substr(0,c)),L+=d[f]):L!==void 0&&(L+=m[c])}return L!==void 0?L:m}function N(m,L){let c;return m.authority&&m.path.length>1&&m.scheme==="file"?c=`//${m.authority}${m.path}`:m.path.charCodeAt(0)===47&&(m.path.charCodeAt(1)>=65&&m.path.charCodeAt(1)<=90||m.path.charCodeAt(1)>=97&&m.path.charCodeAt(1)<=122)&&m.path.charCodeAt(2)===58?L?c=m.path.substr(1):c=m.path[1].toLowerCase()+m.path.substr(2):c=m.path,M.isWindows&&(c=c.replace(/\//g,"\\")),c}function S(m,L){const c=L?_:y;let f="",{scheme:R,authority:E,path:x,query:D,fragment:T}=m;if(R&&(f+=R,f+=":"),(E||R==="file")&&(f+=e,f+=e),E){let k=E.indexOf("@");if(k!==-1){const W=E.substr(0,k);E=E.substr(k+1),k=W.lastIndexOf(":"),k===-1?f+=c(W,!1,!1):(f+=c(W.substr(0,k),!1,!1),f+=":",f+=c(W.substr(k+1),!1,!0)),f+="@"}E=E.toLowerCase(),k=E.lastIndexOf(":"),k===-1?f+=c(E,!1,!0):(f+=c(E.substr(0,k),!1,!0),f+=E.substr(k))}if(x){if(x.length>=3&&x.charCodeAt(0)===47&&x.charCodeAt(2)===58){const k=x.charCodeAt(1);k>=65&&k<=90&&(x=`/${String.fromCharCode(k+32)}:${x.substr(3)}`)}else if(x.length>=2&&x.charCodeAt(1)===58){const k=x.charCodeAt(0);k>=65&&k<=90&&(x=`${String.fromCharCode(k+32)}:${x.substr(2)}`)}f+=c(x,!0,!1)}return D&&(f+="?",f+=c(D,!1,!1)),T&&(f+="#",f+=L?T:y(T,!1,!1)),f}function C(m){try{return decodeURIComponent(m)}catch{return m.length>3?m.substr(0,3)+C(m.substr(3)):m}}const i=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function a(m){return m.match(i)?m.replace(i,L=>C(L)):m}}),X(Z[69],K([0,1,5,9,13,14,17,6]),function(q,n,r,M,A,g,v,p){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.SimpleWorkerServer=n.SimpleWorkerClient=void 0,n.logOnceWebWorkerWarning=w,n.create=i;const h="$initialize";let l=!1;function w(a){v.isWeb&&(l||(l=!0,console.warn("Could not create web worker(s). Falling back to loading web worker code in main thread, which might cause UI freezes. Please see https://github.com/microsoft/monaco-editor#faq")),console.warn(a.message))}class e{constructor(m,L,c,f){this.vsWorker=m,this.req=L,this.method=c,this.args=f,this.type=0}}class s{constructor(m,L,c,f){this.vsWorker=m,this.seq=L,this.res=c,this.err=f,this.type=1}}class o{constructor(m,L,c,f){this.vsWorker=m,this.req=L,this.eventName=c,this.arg=f,this.type=2}}class u{constructor(m,L,c){this.vsWorker=m,this.req=L,this.event=c,this.type=3}}class b{constructor(m,L){this.vsWorker=m,this.req=L,this.type=4}}class d{constructor(m){this._workerId=-1,this._handler=m,this._lastSentReq=0,this._pendingReplies=Object.create(null),this._pendingEmitters=new Map,this._pendingEvents=new Map}setWorkerId(m){this._workerId=m}sendMessage(m,L){const c=String(++this._lastSentReq);return new Promise((f,R)=>{this._pendingReplies[c]={resolve:f,reject:R},this._send(new e(this._workerId,c,m,L))})}listen(m,L){let c=null;const f=new M.Emitter({onWillAddFirstListener:()=>{c=String(++this._lastSentReq),this._pendingEmitters.set(c,f),this._send(new o(this._workerId,c,m,L))},onDidRemoveLastListener:()=>{this._pendingEmitters.delete(c),this._send(new b(this._workerId,c)),c=null}});return f.event}handleMessage(m){!m||!m.vsWorker||this._workerId!==-1&&m.vsWorker!==this._workerId||this._handleMessage(m)}_handleMessage(m){switch(m.type){case 1:return this._handleReplyMessage(m);case 0:return this._handleRequestMessage(m);case 2:return this._handleSubscribeEventMessage(m);case 3:return this._handleEventMessage(m);case 4:return this._handleUnsubscribeEventMessage(m)}}_handleReplyMessage(m){if(!this._pendingReplies[m.seq]){console.warn("Got reply to unknown seq");return}const L=this._pendingReplies[m.seq];if(delete this._pendingReplies[m.seq],m.err){let c=m.err;m.err.$isError&&(c=new Error,c.name=m.err.name,c.message=m.err.message,c.stack=m.err.stack),L.reject(c);return}L.resolve(m.res)}_handleRequestMessage(m){const L=m.req;this._handler.handleMessage(m.method,m.args).then(f=>{this._send(new s(this._workerId,L,f,void 0))},f=>{f.detail instanceof Error&&(f.detail=(0,r.transformErrorForSerialization)(f.detail)),this._send(new s(this._workerId,L,void 0,(0,r.transformErrorForSerialization)(f)))})}_handleSubscribeEventMessage(m){const L=m.req,c=this._handler.handleEvent(m.eventName,m.arg)(f=>{this._send(new u(this._workerId,L,f))});this._pendingEvents.set(L,c)}_handleEventMessage(m){if(!this._pendingEmitters.has(m.req)){console.warn("Got event for unknown req");return}this._pendingEmitters.get(m.req).fire(m.event)}_handleUnsubscribeEventMessage(m){if(!this._pendingEvents.has(m.req)){console.warn("Got unsubscribe for unknown req");return}this._pendingEvents.get(m.req).dispose(),this._pendingEvents.delete(m.req)}_send(m){const L=[];if(m.type===0)for(let c=0;c<m.args.length;c++)m.args[c]instanceof ArrayBuffer&&L.push(m.args[c]);else m.type===1&&m.res instanceof ArrayBuffer&&L.push(m.res);this._handler.sendMessage(m,L)}}class y extends A.Disposable{constructor(m,L,c){super();let f=null;this._worker=this._register(m.create("vs/base/common/worker/simpleWorker",k=>{this._protocol.handleMessage(k)},k=>{f?.(k)})),this._protocol=new d({sendMessage:(k,W)=>{this._worker.postMessage(k,W)},handleMessage:(k,W)=>{if(typeof c[k]!="function")return Promise.reject(new Error("Missing method "+k+" on main thread host."));try{return Promise.resolve(c[k].apply(c,W))}catch(j){return Promise.reject(j)}},handleEvent:(k,W)=>{if(N(k)){const j=c[k].call(c,W);if(typeof j!="function")throw new Error(`Missing dynamic event ${k} on main thread host.`);return j}if(_(k)){const j=c[k];if(typeof j!="function")throw new Error(`Missing event ${k} on main thread host.`);return j}throw new Error(`Malformed event name ${k}`)}}),this._protocol.setWorkerId(this._worker.getId());let R=null;const E=globalThis.require;typeof E<"u"&&typeof E.getConfig=="function"?R=E.getConfig():typeof globalThis.requirejs<"u"&&(R=globalThis.requirejs.s.contexts._.config);const x=(0,g.getAllMethodNames)(c);this._onModuleLoaded=this._protocol.sendMessage(h,[this._worker.getId(),JSON.parse(JSON.stringify(R)),L,x]);const D=(k,W)=>this._request(k,W),T=(k,W)=>this._protocol.listen(k,W);this._lazyProxy=new Promise((k,W)=>{f=W,this._onModuleLoaded.then(j=>{k(S(j,D,T))},j=>{W(j),this._onError("Worker failed to load "+L,j)})})}getProxyObject(){return this._lazyProxy}_request(m,L){return new Promise((c,f)=>{this._onModuleLoaded.then(()=>{this._protocol.sendMessage(m,L).then(c,f)},f)})}_onError(m,L){console.error(m),console.info(L)}}n.SimpleWorkerClient=y;function _(a){return a[0]==="o"&&a[1]==="n"&&p.isUpperAsciiLetter(a.charCodeAt(2))}function N(a){return/^onDynamic/.test(a)&&p.isUpperAsciiLetter(a.charCodeAt(9))}function S(a,m,L){const c=E=>function(){const x=Array.prototype.slice.call(arguments,0);return m(E,x)},f=E=>function(x){return L(E,x)},R={};for(const E of a){if(N(E)){R[E]=f(E);continue}if(_(E)){R[E]=L(E,void 0);continue}R[E]=c(E)}return R}class C{constructor(m,L){this._requestHandlerFactory=L,this._requestHandler=null,this._protocol=new d({sendMessage:(c,f)=>{m(c,f)},handleMessage:(c,f)=>this._handleMessage(c,f),handleEvent:(c,f)=>this._handleEvent(c,f)})}onmessage(m){this._protocol.handleMessage(m)}_handleMessage(m,L){if(m===h)return this.initialize(L[0],L[1],L[2],L[3]);if(!this._requestHandler||typeof this._requestHandler[m]!="function")return Promise.reject(new Error("Missing requestHandler or method: "+m));try{return Promise.resolve(this._requestHandler[m].apply(this._requestHandler,L))}catch(c){return Promise.reject(c)}}_handleEvent(m,L){if(!this._requestHandler)throw new Error("Missing requestHandler");if(N(m)){const c=this._requestHandler[m].call(this._requestHandler,L);if(typeof c!="function")throw new Error(`Missing dynamic event ${m} on request handler.`);return c}if(_(m)){const c=this._requestHandler[m];if(typeof c!="function")throw new Error(`Missing event ${m} on request handler.`);return c}throw new Error(`Malformed event name ${m}`)}initialize(m,L,c,f){this._protocol.setWorkerId(m);const x=S(f,(D,T)=>this._protocol.sendMessage(D,T),(D,T)=>this._protocol.listen(D,T));return this._requestHandlerFactory?(this._requestHandler=this._requestHandlerFactory(x),Promise.resolve((0,g.getAllMethodNames)(this._requestHandler))):(L&&(typeof L.baseUrl<"u"&&delete L.baseUrl,typeof L.paths<"u"&&typeof L.paths.vs<"u"&&delete L.paths.vs,typeof L.trustedTypesPolicy<"u"&&delete L.trustedTypesPolicy,L.catchError=!0,globalThis.require.config(L)),new Promise((D,T)=>{(globalThis.require||q)([c],W=>{if(this._requestHandler=W.create(x),!this._requestHandler){T(new Error("No RequestHandler!"));return}D((0,g.getAllMethodNames)(this._requestHandler))},T)}))}}n.SimpleWorkerServer=C;function i(a){return new C(a,null)}}),X(Z[66],K([19,63]),function(q,n){return q.create("vs/editor/common/languages",n)}),X(Z[67],K([0,1,42,18,2,61,66]),function(q,n,r,M,A,g,v){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.InlineEditTriggerKind=n.TokenizationRegistry=n.LazyTokenizationSupport=n.InlayHintKind=n.Command=n.NewSymbolNameTag=n.FoldingRangeKind=n.TextEdit=n.SymbolKinds=n.symbolKindNames=n.DocumentHighlightKind=n.SignatureHelpTriggerKind=n.DocumentPasteTriggerKind=n.SelectedSuggestionInfo=n.InlineCompletionTriggerKind=n.CompletionItemKinds=n.EncodedTokenizationResult=n.TokenizationResult=n.Token=void 0,n.isLocationLink=d,n.getAriaLabelForSymbol=y;class p{constructor(f,R,E){this.offset=f,this.type=R,this.language=E,this._tokenBrand=void 0}toString(){return"("+this.offset+", "+this.type+")"}}n.Token=p;class h{constructor(f,R){this.tokens=f,this.endState=R,this._tokenizationResultBrand=void 0}}n.TokenizationResult=h;class l{constructor(f,R){this.tokens=f,this.endState=R,this._encodedTokenizationResultBrand=void 0}}n.EncodedTokenizationResult=l;var w;(function(c){const f=new Map;f.set(0,r.Codicon.symbolMethod),f.set(1,r.Codicon.symbolFunction),f.set(2,r.Codicon.symbolConstructor),f.set(3,r.Codicon.symbolField),f.set(4,r.Codicon.symbolVariable),f.set(5,r.Codicon.symbolClass),f.set(6,r.Codicon.symbolStruct),f.set(7,r.Codicon.symbolInterface),f.set(8,r.Codicon.symbolModule),f.set(9,r.Codicon.symbolProperty),f.set(10,r.Codicon.symbolEvent),f.set(11,r.Codicon.symbolOperator),f.set(12,r.Codicon.symbolUnit),f.set(13,r.Codicon.symbolValue),f.set(15,r.Codicon.symbolEnum),f.set(14,r.Codicon.symbolConstant),f.set(15,r.Codicon.symbolEnum),f.set(16,r.Codicon.symbolEnumMember),f.set(17,r.Codicon.symbolKeyword),f.set(27,r.Codicon.symbolSnippet),f.set(18,r.Codicon.symbolText),f.set(19,r.Codicon.symbolColor),f.set(20,r.Codicon.symbolFile),f.set(21,r.Codicon.symbolReference),f.set(22,r.Codicon.symbolCustomColor),f.set(23,r.Codicon.symbolFolder),f.set(24,r.Codicon.symbolTypeParameter),f.set(25,r.Codicon.account),f.set(26,r.Codicon.issues);function R(D){let T=f.get(D);return T||(console.info("No codicon found for CompletionItemKind "+D),T=r.Codicon.symbolProperty),T}c.toIcon=R;const E=new Map;E.set("method",0),E.set("function",1),E.set("constructor",2),E.set("field",3),E.set("variable",4),E.set("class",5),E.set("struct",6),E.set("interface",7),E.set("module",8),E.set("property",9),E.set("event",10),E.set("operator",11),E.set("unit",12),E.set("value",13),E.set("constant",14),E.set("enum",15),E.set("enum-member",16),E.set("enumMember",16),E.set("keyword",17),E.set("snippet",27),E.set("text",18),E.set("color",19),E.set("file",20),E.set("reference",21),E.set("customcolor",22),E.set("folder",23),E.set("type-parameter",24),E.set("typeParameter",24),E.set("account",25),E.set("issue",26);function x(D,T){let k=E.get(D);return typeof k>"u"&&!T&&(k=9),k}c.fromString=x})(w||(n.CompletionItemKinds=w={}));var e;(function(c){c[c.Automatic=0]="Automatic",c[c.Explicit=1]="Explicit"})(e||(n.InlineCompletionTriggerKind=e={}));class s{constructor(f,R,E,x){this.range=f,this.text=R,this.completionKind=E,this.isSnippetText=x}equals(f){return A.Range.lift(this.range).equalsRange(f.range)&&this.text===f.text&&this.completionKind===f.completionKind&&this.isSnippetText===f.isSnippetText}}n.SelectedSuggestionInfo=s;var o;(function(c){c[c.Automatic=0]="Automatic",c[c.PasteAs=1]="PasteAs"})(o||(n.DocumentPasteTriggerKind=o={}));var u;(function(c){c[c.Invoke=1]="Invoke",c[c.TriggerCharacter=2]="TriggerCharacter",c[c.ContentChange=3]="ContentChange"})(u||(n.SignatureHelpTriggerKind=u={}));var b;(function(c){c[c.Text=0]="Text",c[c.Read=1]="Read",c[c.Write=2]="Write"})(b||(n.DocumentHighlightKind=b={}));function d(c){return c&&M.URI.isUri(c.uri)&&A.Range.isIRange(c.range)&&(A.Range.isIRange(c.originSelectionRange)||A.Range.isIRange(c.targetSelectionRange))}n.symbolKindNames={17:(0,v.localize)(0,null),16:(0,v.localize)(1,null),4:(0,v.localize)(2,null),13:(0,v.localize)(3,null),8:(0,v.localize)(4,null),9:(0,v.localize)(5,null),21:(0,v.localize)(6,null),23:(0,v.localize)(7,null),7:(0,v.localize)(8,null),0:(0,v.localize)(9,null),11:(0,v.localize)(10,null),10:(0,v.localize)(11,null),19:(0,v.localize)(12,null),5:(0,v.localize)(13,null),1:(0,v.localize)(14,null),2:(0,v.localize)(15,null),20:(0,v.localize)(16,null),15:(0,v.localize)(17,null),18:(0,v.localize)(18,null),24:(0,v.localize)(19,null),3:(0,v.localize)(20,null),6:(0,v.localize)(21,null),14:(0,v.localize)(22,null),22:(0,v.localize)(23,null),25:(0,v.localize)(24,null),12:(0,v.localize)(25,null)};function y(c,f){return(0,v.localize)(26,null,c,n.symbolKindNames[f])}var _;(function(c){const f=new Map;f.set(0,r.Codicon.symbolFile),f.set(1,r.Codicon.symbolModule),f.set(2,r.Codicon.symbolNamespace),f.set(3,r.Codicon.symbolPackage),f.set(4,r.Codicon.symbolClass),f.set(5,r.Codicon.symbolMethod),f.set(6,r.Codicon.symbolProperty),f.set(7,r.Codicon.symbolField),f.set(8,r.Codicon.symbolConstructor),f.set(9,r.Codicon.symbolEnum),f.set(10,r.Codicon.symbolInterface),f.set(11,r.Codicon.symbolFunction),f.set(12,r.Codicon.symbolVariable),f.set(13,r.Codicon.symbolConstant),f.set(14,r.Codicon.symbolString),f.set(15,r.Codicon.symbolNumber),f.set(16,r.Codicon.symbolBoolean),f.set(17,r.Codicon.symbolArray),f.set(18,r.Codicon.symbolObject),f.set(19,r.Codicon.symbolKey),f.set(20,r.Codicon.symbolNull),f.set(21,r.Codicon.symbolEnumMember),f.set(22,r.Codicon.symbolStruct),f.set(23,r.Codicon.symbolEvent),f.set(24,r.Codicon.symbolOperator),f.set(25,r.Codicon.symbolTypeParameter);function R(E){let x=f.get(E);return x||(console.info("No codicon found for SymbolKind "+E),x=r.Codicon.symbolProperty),x}c.toIcon=R})(_||(n.SymbolKinds=_={}));class N{}n.TextEdit=N;class S{static fromValue(f){switch(f){case"comment":return S.Comment;case"imports":return S.Imports;case"region":return S.Region}return new S(f)}constructor(f){this.value=f}}n.FoldingRangeKind=S,S.Comment=new S("comment"),S.Imports=new S("imports"),S.Region=new S("region");var C;(function(c){c[c.AIGenerated=1]="AIGenerated"})(C||(n.NewSymbolNameTag=C={}));var i;(function(c){function f(R){return!R||typeof R!="object"?!1:typeof R.id=="string"&&typeof R.title=="string"}c.is=f})(i||(n.Command=i={}));var a;(function(c){c[c.Type=1]="Type",c[c.Parameter=2]="Parameter"})(a||(n.InlayHintKind=a={}));class m{constructor(f){this.createSupport=f,this._tokenizationSupport=null}dispose(){this._tokenizationSupport&&this._tokenizationSupport.then(f=>{f&&f.dispose()})}get tokenizationSupport(){return this._tokenizationSupport||(this._tokenizationSupport=this.createSupport()),this._tokenizationSupport}}n.LazyTokenizationSupport=m,n.TokenizationRegistry=new g.TokenizationRegistry;var L;(function(c){c[c.Invoke=0]="Invoke",c[c.Automatic=1]="Automatic"})(L||(n.InlineEditTriggerKind=L={}))}),X(Z[68],K([0,1,39,9,36,18,4,2,43,67,60]),function(q,n,r,M,A,g,v,p,h,l,w){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.KeyMod=void 0,n.createMonacoBaseAPI=s;class e{static chord(u,b){return(0,A.KeyChord)(u,b)}}n.KeyMod=e,e.CtrlCmd=2048,e.Shift=1024,e.Alt=512,e.WinCtrl=256;function s(){return{editor:void 0,languages:void 0,CancellationTokenSource:r.CancellationTokenSource,Emitter:M.Emitter,KeyCode:w.KeyCode,KeyMod:e,Position:v.Position,Range:p.Range,Selection:h.Selection,SelectionDirection:w.SelectionDirection,MarkerSeverity:w.MarkerSeverity,MarkerTag:w.MarkerTag,Uri:g.URI,Token:l.Token}}}),X(Z[70],K([0,1,24,18,4,2,57,29,53,54,68,23,59,51,14,52]),function(q,n,r,M,A,g,v,p,h,l,w,e,s,o,u,b){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.EditorSimpleWorker=void 0,n.create=_;class d extends v.MirrorTextModel{get uri(){return this._uri}get eol(){return this._eol}getValue(){return this.getText()}findMatches(S){const C=[];for(let i=0;i<this._lines.length;i++){const a=this._lines[i],m=this.offsetAt(new A.Position(i+1,1)),L=a.matchAll(S);for(const c of L)(c.index||c.index===0)&&(c.index=c.index+m),C.push(c)}return C}getLinesContent(){return this._lines.slice(0)}getLineCount(){return this._lines.length}getLineContent(S){return this._lines[S-1]}getWordAtPosition(S,C){const i=(0,p.getWordAtText)(S.column,(0,p.ensureValidWordDefinition)(C),this._lines[S.lineNumber-1],0);return i?new g.Range(S.lineNumber,i.startColumn,S.lineNumber,i.endColumn):null}words(S){const C=this._lines,i=this._wordenize.bind(this);let a=0,m="",L=0,c=[];return{*[Symbol.iterator](){for(;;)if(L<c.length){const f=m.substring(c[L].start,c[L].end);L+=1,yield f}else if(a<C.length)m=C[a],c=i(m,S),L=0,a+=1;else break}}}getLineWords(S,C){const i=this._lines[S-1],a=this._wordenize(i,C),m=[];for(const L of a)m.push({word:i.substring(L.start,L.end),startColumn:L.start+1,endColumn:L.end+1});return m}_wordenize(S,C){const i=[];let a;for(C.lastIndex=0;(a=C.exec(S))&&a[0].length!==0;)i.push({start:a.index,end:a.index+a[0].length});return i}getValueInRange(S){if(S=this._validateRange(S),S.startLineNumber===S.endLineNumber)return this._lines[S.startLineNumber-1].substring(S.startColumn-1,S.endColumn-1);const C=this._eol,i=S.startLineNumber-1,a=S.endLineNumber-1,m=[];m.push(this._lines[i].substring(S.startColumn-1));for(let L=i+1;L<a;L++)m.push(this._lines[L]);return m.push(this._lines[a].substring(0,S.endColumn-1)),m.join(C)}offsetAt(S){return S=this._validatePosition(S),this._ensureLineStarts(),this._lineStarts.getPrefixSum(S.lineNumber-2)+(S.column-1)}positionAt(S){S=Math.floor(S),S=Math.max(0,S),this._ensureLineStarts();const C=this._lineStarts.getIndexOf(S),i=this._lines[C.index].length;return{lineNumber:1+C.index,column:1+Math.min(C.remainder,i)}}_validateRange(S){const C=this._validatePosition({lineNumber:S.startLineNumber,column:S.startColumn}),i=this._validatePosition({lineNumber:S.endLineNumber,column:S.endColumn});return C.lineNumber!==S.startLineNumber||C.column!==S.startColumn||i.lineNumber!==S.endLineNumber||i.column!==S.endColumn?{startLineNumber:C.lineNumber,startColumn:C.column,endLineNumber:i.lineNumber,endColumn:i.column}:S}_validatePosition(S){if(!A.Position.isIPosition(S))throw new Error("bad position");let{lineNumber:C,column:i}=S,a=!1;if(C<1)C=1,i=1,a=!0;else if(C>this._lines.length)C=this._lines.length,i=this._lines[C-1].length+1,a=!0;else{const m=this._lines[C-1].length+1;i<1?(i=1,a=!0):i>m&&(i=m,a=!0)}return a?{lineNumber:C,column:i}:S}}class y{constructor(S,C){this._host=S,this._models=Object.create(null),this._foreignModuleFactory=C,this._foreignModule=null}dispose(){this._models=Object.create(null)}_getModel(S){return this._models[S]}_getModels(){const S=[];return Object.keys(this._models).forEach(C=>S.push(this._models[C])),S}acceptNewModel(S){this._models[S.url]=new d(M.URI.parse(S.url),S.lines,S.EOL,S.versionId)}acceptModelChanged(S,C){if(!this._models[S])return;this._models[S].onEvents(C)}acceptRemovedModel(S){this._models[S]&&delete this._models[S]}async computeUnicodeHighlights(S,C,i){const a=this._getModel(S);return a?s.UnicodeTextModelHighlighter.computeUnicodeHighlights(a,C,i):{ranges:[],hasMore:!1,ambiguousCharacterCount:0,invisibleCharacterCount:0,nonBasicAsciiCharacterCount:0}}async computeDiff(S,C,i,a){const m=this._getModel(S),L=this._getModel(C);return!m||!L?null:y.computeDiff(m,L,i,a)}static computeDiff(S,C,i,a){const m=a==="advanced"?o.linesDiffComputers.getDefault():o.linesDiffComputers.getLegacy(),L=S.getLinesContent(),c=C.getLinesContent(),f=m.computeDiff(L,c,i),R=f.changes.length>0?!1:this._modelsAreIdentical(S,C);function E(x){return x.map(D=>{var T;return[D.original.startLineNumber,D.original.endLineNumberExclusive,D.modified.startLineNumber,D.modified.endLineNumberExclusive,(T=D.innerChanges)===null||T===void 0?void 0:T.map(k=>[k.originalRange.startLineNumber,k.originalRange.startColumn,k.originalRange.endLineNumber,k.originalRange.endColumn,k.modifiedRange.startLineNumber,k.modifiedRange.startColumn,k.modifiedRange.endLineNumber,k.modifiedRange.endColumn])]})}return{identical:R,quitEarly:f.hitTimeout,changes:E(f.changes),moves:f.moves.map(x=>[x.lineRangeMapping.original.startLineNumber,x.lineRangeMapping.original.endLineNumberExclusive,x.lineRangeMapping.modified.startLineNumber,x.lineRangeMapping.modified.endLineNumberExclusive,E(x.changes)])}}static _modelsAreIdentical(S,C){const i=S.getLineCount(),a=C.getLineCount();if(i!==a)return!1;for(let m=1;m<=i;m++){const L=S.getLineContent(m),c=C.getLineContent(m);if(L!==c)return!1}return!0}async computeMoreMinimalEdits(S,C,i){const a=this._getModel(S);if(!a)return C;const m=[];let L;C=C.slice(0).sort((f,R)=>{if(f.range&&R.range)return g.Range.compareRangesUsingStarts(f.range,R.range);const E=f.range?0:1,x=R.range?0:1;return E-x});let c=0;for(let f=1;f<C.length;f++)g.Range.getEndPosition(C[c].range).equals(g.Range.getStartPosition(C[f].range))?(C[c].range=g.Range.fromPositions(g.Range.getStartPosition(C[c].range),g.Range.getEndPosition(C[f].range)),C[c].text+=C[f].text):(c++,C[c]=C[f]);C.length=c+1;for(let{range:f,text:R,eol:E}of C){if(typeof E=="number"&&(L=E),g.Range.isEmpty(f)&&!R)continue;const x=a.getValueInRange(f);if(R=R.replace(/\r\n|\n|\r/g,a.eol),x===R)continue;if(Math.max(R.length,x.length)>y._diffLimit){m.push({range:f,text:R});continue}const D=(0,r.stringDiff)(x,R,i),T=a.offsetAt(g.Range.lift(f).getStartPosition());for(const k of D){const W=a.positionAt(T+k.originalStart),j=a.positionAt(T+k.originalStart+k.originalLength),$={text:R.substr(k.modifiedStart,k.modifiedLength),range:{startLineNumber:W.lineNumber,startColumn:W.column,endLineNumber:j.lineNumber,endColumn:j.column}};a.getValueInRange($.range)!==$.text&&m.push($)}}return typeof L=="number"&&m.push({eol:L,text:"",range:{startLineNumber:0,startColumn:0,endLineNumber:0,endColumn:0}}),m}async computeLinks(S){const C=this._getModel(S);return C?(0,h.computeLinks)(C):null}async computeDefaultDocumentColors(S){const C=this._getModel(S);return C?(0,b.computeDefaultDocumentColors)(C):null}async textualSuggest(S,C,i,a){const m=new e.StopWatch,L=new RegExp(i,a),c=new Set;e:for(const f of S){const R=this._getModel(f);if(R){for(const E of R.words(L))if(!(E===C||!isNaN(Number(E)))&&(c.add(E),c.size>y._suggestionsLimit))break e}}return{words:Array.from(c),duration:m.elapsed()}}async computeWordRanges(S,C,i,a){const m=this._getModel(S);if(!m)return Object.create(null);const L=new RegExp(i,a),c=Object.create(null);for(let f=C.startLineNumber;f<C.endLineNumber;f++){const R=m.getLineWords(f,L);for(const E of R){if(!isNaN(Number(E.word)))continue;let x=c[E.word];x||(x=[],c[E.word]=x),x.push({startLineNumber:f,startColumn:E.startColumn,endLineNumber:f,endColumn:E.endColumn})}}return c}async navigateValueSet(S,C,i,a,m){const L=this._getModel(S);if(!L)return null;const c=new RegExp(a,m);C.startColumn===C.endColumn&&(C={startLineNumber:C.startLineNumber,startColumn:C.startColumn,endLineNumber:C.endLineNumber,endColumn:C.endColumn+1});const f=L.getValueInRange(C),R=L.getWordAtPosition({lineNumber:C.startLineNumber,column:C.startColumn},c);if(!R)return null;const E=L.getValueInRange(R);return l.BasicInplaceReplace.INSTANCE.navigateValueSet(C,f,R,E,i)}loadForeignModule(S,C,i){const a=(c,f)=>this._host.fhr(c,f),L={host:(0,u.createProxyObject)(i,a),getMirrorModels:()=>this._getModels()};return this._foreignModuleFactory?(this._foreignModule=this._foreignModuleFactory(L,C),Promise.resolve((0,u.getAllMethodNames)(this._foreignModule))):new Promise((c,f)=>{q([S],R=>{this._foreignModule=R.create(L,C),c((0,u.getAllMethodNames)(this._foreignModule))},f)})}fmr(S,C){if(!this._foreignModule||typeof this._foreignModule[S]!="function")return Promise.reject(new Error("Missing requestHandler or method: "+S));try{return Promise.resolve(this._foreignModule[S].apply(this._foreignModule,C))}catch(i){return Promise.reject(i)}}}n.EditorSimpleWorker=y,y._diffLimit=1e5,y._suggestionsLimit=1e4;function _(N){return new y(N,null)}typeof importScripts=="function"&&(globalThis.monaco=(0,w.createMonacoBaseAPI)())})}).call(this);

//# sourceMappingURL=../../../../min-maps/vs/base/worker/workerMain.js.map